/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: FLIPUI.cpp,v 1.6 1997/07/03 00:08:46 mayer Exp $ *
 ***********************************************************************/

// ------------------------------------------------------
//  modul       ?       FLIP++UI.cpp                      |
// ------------------------------------------------------
//  project     ?       I n t e r F L I P + +            |
// ------------------------------------------------------
//  by whom     ?       Stefan Mayer                     |
//  with whom   ?       Wolfgang Slany                   |
//  when        ?       1994/1995                        |
//  what        ?       userinterface  for FLIP++        |
//  how         ?       C++                              |
// ------------------------------------------------------
// classes	?					
//							
// 	user interface 	for FLIP++			
//							
//							
//		MyWin					
//		Window_1				
//		Window_def_file				
//		point_float				
//							
//		Rule_listBox				
//			rule_segments			
//			rule_data_list			
//			rule_dyn_data			
//		rule_text_box				
//							
//		ChoiceParameterList			
//		Parameter_Win				
//		PSList_window_base			
//		PSList_window				
//							
//		membership_fct_window			
//		fuzzy_set_canvas			
//							
//		colour_choice_box			
//		CVListBox				
//		TermListBox				
//		op_set_window				
//							
//		cv_base_panel				
//		fuzzy_set_canvas
//		Flip_base_panel				
//		Flip_window				
// ------------------------------------------------------
//		concat_operator2string			
//		fuzzy_operator2string			
//		is_concat_operator			
//		is_flip_operator			
//		string2fuzzy_operator			
//		string2concat_operator			
//							
// ------------------------------------------------------
//			point_float			
//			point_float			
//							
//			print2errWin			
//			flip_error_t			
// ------------------------------------------------------




#include <builtin.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fstream.h>
#include <iostream.h>

#include "flip.h"
#include <stream.h>

#include "FLIPUI.h"


// *** declare errorstring; (for flip & uiflip)

static char error[100]=" ";

// global variable:

wxList 		my_children;			// list of subwindows

flip_error_t flip_error(error);			// display error messages

char flip_icn [50]      	=".icf";
char fpara_extension [50]	= ".pdb";
char fpara_extension_ [50]	= "*.pdb";
char rule_extension [50]	= ".rdb";
char rule_extension_ [50]	= "*.rdb";
char flip_data_path [50]	="";


#define	  PARA_READ		700 
#define   PARA_WRITE		710
#define   STATUS_LENGTH 	300



#define HELP_SERVER_ID -1	// for help



// This statement initialises the whole application
	App_Flip   flip_main;
	Flip_window *flipWin;

wxFrame *App_Flip::OnInit(void)
{
	int screen_x, screen_y;
	wxDisplaySize(&screen_x, &screen_y);

	// construct all windows and window-objects and init them
  	flipWin = new Flip_window(	NULL, "InterFLIP++",
					0, 0, 550, 600,wxDEFAULT_FRAME,
					flip_data_path);


 	 // Give it an icon
//	#ifdef wx_msw
//   	    flipWin->SetIcon(new wxIcon("mondrian"));
//	#endif
//	#ifdef wx_x
 // 	    flipWin->SetIcon(new wxIcon("aiai.xbm"));
//	#endif

 
   	return flipWin;
}













int Flip_DialogButtonPressed;


int	flip_fstream_OK (ofstream* file)
{
	if (! file)
	{
		cout<<"FILE-OPEN-ERROR"<<endl;
		return 0;
	}
	return 1;
}	

int	fstream_OK (ofstream* file)
{
	if (! file)
		return 0;
	return 1;
}	


//-----------------------------------------------------------------------
//
//				CLASS  MyWin
//
//-----------------------------------------------------------------------

MyWin::MyWin(wxFrame *frame, char *title, int x, int y, 
		 int w, int h, int type, Bool if_delete_is_ok_flag):
  wxFrame(frame, title, x, y, w, h, type)
{
	CreateStatusLine();
	childpanel = NULL;
	menu_bar = NULL;
	icon  = NULL;
	if_delete_is_ok_ = if_delete_is_ok_flag;
}

MyWin::~MyWin(void)
{
	cout << "  MyWin ("<<this<<") deleted\n";
}

void MyWin::openWindow(Bool do_open_win)
{
	if(do_open_win)
		if(Iconized())
			Iconize(FALSE);
		else
			Show(TRUE);
}
void MyWin::delete_is_ok(Bool boo)
{
	if_delete_is_ok_ = boo;
}
Bool MyWin::OnClose(void) 
{
	cout << "MyWin: close window()";
	Show(FALSE);
	if(if_delete_is_ok_)
		return TRUE;
	return FALSE;
}




//---------------------------------------------------------------------------------------
//			 CLASS  Window_1						-									//	 										-
//---------------------------------------------------------------------------------------


Window_1::Window_1(wxFrame *frame, char *title, int x, int y, 
		 int w, int h, int type):
  MyWin(frame, title, x, y, w, h, type)
{
   	CreateStatusLine();
	is_active = not_active;
  	my_children.Append(this);
	childpanel = NULL;
	child_file_menu = NULL;
	menu_bar = NULL;
	info_message = NULL;
	icon  = NULL;
}

Window_1::~Window_1(void)
{
  my_children.DeleteObject(this);
}


// Intercept menu commands
void Window_1::OnMenuCommand(int id)
{
  switch (id)
  {
    case QUIT_CHILD_WIN:
    {
	Show(FALSE,TRUE);	// 2'nd Arg is a dummy
      	break;
    }
  }
}

void Window_1::OnKillFocus(void)
{
	cout <<"Focus killed\n";
}

void Window_1::Show(Bool show, Bool) // 2'nd Arg is a dummy
{
	wxFrame::Show(show); 
	if(show)
		is_active = active;
	else
		is_active = not_active;
}

//---------------------------------------------------------------------------------------
//			 Window_def_file		 				-
//---------------------------------------------------------------------------------------

Window_def_file::Window_def_file(wxFrame *frame, char *title, char *default_dir, 
		int x, int y, 
		int w, int h, int type):
  Window_1(frame, title, x, y, w, h, type)
{
	strcpy(fileName_,"");
	set_path(default_dir);
}

void	Window_def_file::set_dir(char *new_dir)
{
	strncpy(default_dir_,  new_dir, 100);
}

void	Window_def_file::set_path(char *new_path)
{
	if(new_path && strcmp(new_path,"")!=0){
		strncpy(default_dir_, PathOnly(new_path), 100);
		strncpy(fileName_, FileNameFromPath(new_path), 100);
	}
	//else GetWorkingDirectory(default_dir_,100); 
	else strcpy(default_dir_,".");
}

void	Window_def_file::set_dir(void)		// input window
{
	char *new_dir = wxGetTextFromUser("input new default save directory","input path", default_dir_);
	if(new_dir)
	{
		set_dir(new_dir);
		delete new_dir;
	}
}

char	*Window_def_file::get_dir(void)
{
	return default_dir_;
}
char	*Window_def_file::get_file_name(void)
{
	if(strcmp(fileName_,"")==0)
		return NULL;
	return fileName_;
}

void	Window_def_file::show()
{
}





//-----------------------------------------------------------------------
//
//				CLASS  rule_segments
//
//-----------------------------------------------------------------------



rule_segments::rule_segments(CombinedVariable *cv, char *val)
{
	if(cv != NULL)
		left_side_.add(cv,val);
	operator_ = no_cop;
	certainty_ = -1;
}


rule_segments::~rule_segments(void)
{
}
void rule_segments::set(CombinedVariable *cv, char *val)
{
	left_side_.add(cv,val);
}

void	rule_segments::set_certainty(float cert)
{
	certainty_ = cert;
}
float	rule_segments::get_certainty(void)
{
 	return certainty_;
}
int 	rule_segments::left_side_lenght(void)
{
	return left_side_.get_number();
}


void rule_segments::add	(CombinedVariable *cv, char *val)
{
	left_side_.add(cv,val);
}
void rule_segments::set_right_side_cv(CombinedVariable *cv)
{
	right_side_.set_cv(cv);
}

void rule_segments::set_right_side_val(char *val)
{
	right_side_.set_lt(val);
}


void rule_segments::set_op	(concat_operator op)
{
	operator_ = op;
}


CombinedVariable *rule_segments::get_cv (int no) // get   no'th cv pointer 
{
	if(left_side_.get_number()>no) return left_side_.find_cv(no);
	else return NULL;	// error
}
char *rule_segments::get_value (int no)
{
	if(left_side_.get_number()>no) return (char*)left_side_.find_lt(no);
	else return NULL;	// error
}
concat_operator rule_segments::get_op (void)
{
	return operator_;
}

//-----------------------------------------------------------------------
//
//				CLASS  rule_data_list
//
//-----------------------------------------------------------------------

rule_data_list::rule_data_list(void)
{
	next = NULL;
}
rule_data_list::rule_data_list(CombinedVariable *cv, char *val)
{
	next = NULL;
	rule_data_.set(cv, val);
}

rule_data_list::~rule_data_list(void)
{
	if(next)
		{delete next;	//cout<<"\tdelete rule_data_list:"<< 
			// rule_data_.get_right_side_cv()->get_cv_name()<<"\n";	// testen !!!!!!!!!
		}
	next = NULL;
}

//-----------------------------------------------------------------------
//
//				CLASS  rule_dyn_data
//
//-----------------------------------------------------------------------

rule_dyn_data::rule_dyn_data(void)
{
	rule_no_ = 0;
	last_rule_data_ = NULL;
}



rule_dyn_data::~rule_dyn_data(void)
{	
}

int  rule_dyn_data::how_much_rules(void)
{
	return rule_no_;
}

Bool rule_dyn_data::not_empty()
{
	if(last_rule_data_)	return TRUE;
	return FALSE;
}
rule_segments* rule_dyn_data::get_last_rule	(void)
{
	return last_rule_data_->get();
}

void rule_dyn_data::add2lastrule(concat_operator op)
{
	get_last_rule()->set_op(op);
}
void rule_dyn_data::add2lastrule(CombinedVariable *cv, char *val)
{
	get_last_rule()->add(cv,val);
}
void rule_dyn_data::add(CombinedVariable *cv, char *val)
{
	rule_data_list *new_rule = new rule_data_list(cv,val);
	if(last_rule_data_) {
		last_rule_data_->next = new_rule;
		last_rule_data_ = new_rule;
	}
	else {
		first_rule_.get()->add(cv,val);
		last_rule_data_ = &first_rule_;
	}
	rule_no_ ++;
}
void	rule_dyn_data::set_certainty(float cert)
{
	if(get_last_rule())
		get_last_rule()->set_certainty(cert);
}

void rule_dyn_data::set_right_side_cv(CombinedVariable *cv)
{
	if(get_last_rule())
		get_last_rule()->set_right_side_cv(cv);
}

void rule_dyn_data::set_right_side_val(char *val)
{
	if(get_last_rule())
		get_last_rule()->set_right_side_val(val);
}

rule_segments *rule_dyn_data::get_rule(int search_no)
{
	rule_data_list *h_ptr = &first_rule_;
	for(int nr = 0; nr<search_no;nr++)
		if(h_ptr->next)
			h_ptr = h_ptr->next;
		else return NULL;
	return h_ptr->get();
}

char *rule_dyn_data::get_value (int rule_no, int no)
{
	rule_segments *h_ptr = get_rule(rule_no);
	if(h_ptr)
		return (char*)h_ptr->get_value(no);
	return NULL;
}

CombinedVariable *rule_dyn_data::get_cv (int rule_no, int no)
{
	rule_segments *h_ptr = get_rule(rule_no);
	if(h_ptr)
		return h_ptr->get_cv(no);
	return NULL;
}

TList *	rule_dyn_data::get_left_term	(int rule_no)
{
	rule_segments *h_ptr = get_rule(rule_no);
	if(h_ptr)
		return h_ptr->get_left_term();
	return NULL;
}

Term *	rule_dyn_data::get_right_term	(int rule_no)
{
	rule_segments *h_ptr = get_rule(rule_no);
	if(h_ptr)
		return h_ptr->get_right_term();
	return NULL;
}


concat_operator rule_dyn_data::get_op (int rule_no)
{
	rule_segments *h_ptr = get_rule(rule_no);
	if(h_ptr)
		return h_ptr->get_op();
	return no_cop;
}

float	rule_dyn_data::get_certainty(int rule_no)
{
	rule_segments *h_ptr = get_rule(rule_no);
	if(h_ptr)
		return h_ptr->get_certainty();
	return -1;
}
int rule_dyn_data::left_side_lenght(int rule_nr)
{
	rule_segments *h_ptr = get_rule(rule_nr);
		return h_ptr->left_side_lenght();
	return 0;
}

void	rule_dyn_data::show_cout(void)
{
	rule_segments *h_ptr;
	rule_data_list *data_ptr = &first_rule_;
	cout <<"\n\t    print ALL   R U L E S\n\n";
	cout <<  "    =====\n";
	while(data_ptr != NULL){
		h_ptr = data_ptr->get();
		cout <<" IF ";
		for(int nr=0;nr<h_ptr->left_side_lenght();nr++){
			cout<<h_ptr->get_cv(nr)->get_cv_name()<<"  IS  "<<
			h_ptr->get_value(nr) << "  ";
			if(h_ptr->left_side_lenght()>nr+1)
				if(h_ptr->get_op())
					cout <<"AND ";
				else    cout << "OR ";
		}
		cout << "\n\t  THEN  "<<
		h_ptr->get_right_side_cv()->get_cv_name() <<"  IS  "<<
		h_ptr->get_right_side_val()<< "   with certainty "<<
		h_ptr->get_certainty()<<"\n";

		data_ptr = data_ptr->next;
	} 
	cout <<"\n\n    RULES END\n";
	cout   <<"    =========\n\n\n";
}


/****************************************************************************************
*			 CLASS  rule_text_box		 				*
****************************************************************************************/


// to save edits in a textfile use button "OK" "CANCEL_EDITS" "UPDATE"

rule_text_box::rule_text_box(wxFrame *parent,
			     int x, int y, int width, int heigth)
	:wxTextWindow(parent, x, y, width, heigth,wxNATIVE_IMPL)
{
	act_rule_block_ = -1;
	act_rule_	= 0;
	act_rs_		= NULL;
	alternativ_style_ = FALSE;
}

rule_text_box::~rule_text_box(void)
{
}

void rule_text_box::set_operatorSet(void)
{
   if(act_rs_){
	wxDialogBox dialog (this,"operator set",TRUE, 40, 40, 500, 300);

	flip_op_fuzzy_Box *importance_op_box = 
		new flip_op_fuzzy_Box(&dialog, NULL,"importance operator",-1,-1,250,100);
	flip_op_fuzzy_Box *and_op_box = 
		new flip_op_fuzzy_Box(&dialog, NULL,"and operator",-1,-1,250,100);

	dialog.NewLine();
	flip_op_fuzzy_Box *or_op_box = 
		new flip_op_fuzzy_Box(&dialog, NULL,"or operator",-1,-1,250,100);
	flip_op_fuzzy_Box *certainty_op_box = 
		new flip_op_fuzzy_Box(&dialog, NULL,"certainty operator",-1,-1,250,100);

	dialog.NewLine();
	flip_op_fuzzy_Box *inference_op_box = 
		new flip_op_fuzzy_Box(&dialog, NULL,"inference operator",-1,-1,250,100);
	flip_op_fuzzy_Box *accumulate_op_box = 
		new flip_op_fuzzy_Box(&dialog, NULL,"accumulate operator",-1,-1,250,100);

	flip_defuzz_op_Box *defuzzy_op_box = 
		new flip_defuzz_op_Box(&dialog, NULL,"defuzzy operator",-1,-1,250,100);

	importance_op_box->Set(*act_rs_->get_operator_set()->get_importance_operator());
	and_op_box->Set(*act_rs_->get_operator_set()->get_and_operator());
	or_op_box->Set(*act_rs_->get_operator_set()->get_or_operator());
	certainty_op_box->Set(*act_rs_->get_operator_set()->get_certainty_operator());
	inference_op_box->Set(*act_rs_->get_operator_set()->get_inference_operator());
	accumulate_op_box->Set(*act_rs_->get_operator_set()->get_accumulate_operator());
	defuzzy_op_box->Set(*act_rs_->get_operator_set()->get_defuzzy_operator());

	wxSlider *gamma_sld = new wxSlider(&dialog,NULL,"gamma  = ",50,0,100,100);
	gamma_sld->SetValue((int)(act_rs_->get_operator_set()->get_gamma()*100));
	dialog.NewLine();
 	wxButton *ok_button = new wxButton(&dialog, (wxFunction)&Flip_DialogOkButton, "OK");
  	(void*)new wxButton(&dialog, (wxFunction)&Flip_DialogCancelButton, "Cancel");
  	ok_button->SetDefault();

	Flip_DialogButtonPressed = 0;
  	dialog.Fit();
  	dialog.Centre();
  	dialog.Show(TRUE);
	if(Flip_DialogButtonPressed)
	{	float gamma_ = ((float)gamma_sld->GetValue())/100;
		act_rs_->get_operator_set()->set_gamma(gamma_);
		act_rs_->get_operator_set()->set_accuracy(12);	// don`t need accuracy!

		act_rs_->get_operator_set()->set_importance_operator	(importance_op_box->Get());
		act_rs_->get_operator_set()->set_and_operator		(and_op_box->Get());
		act_rs_->get_operator_set()->set_or_operator		(or_op_box->Get());
		act_rs_->get_operator_set()->set_certainty_operator	(certainty_op_box->Get());
		act_rs_->get_operator_set()->set_inference_operator	(inference_op_box->Get());
		act_rs_->get_operator_set()->set_accumulate_operator	(accumulate_op_box->Get());
		act_rs_->get_operator_set()->set_defuzzy_operator	(defuzzy_op_box->Get());
	}
   }
}

RuleSet* rule_text_box::GetRule(int *rule_block, int *rule_no)
{
	// IF "cv1" IS "val"   {"operator" IF "cv" IS "val"}*  THEN "cv" IS "val" WITH CERTAINTY "cert"
	*rule_block = act_rule_block_;
	*rule_no = act_rule_;
	return act_rs_;
}

void rule_text_box::SetRule(RuleSet*rs, int rb_index)
{
	char *rule_line = NULL;
	act_rs_ = rs;
	act_rule_block_ = rb_index;
	for (int i=0; i<act_rs_->get_rule_number(rb_index); i++) 
	{
		if((act_rs_->get_left_side_cv(rb_index, i,0))->get_cv_name())
		{
			rule_line = make_rule_text(act_rs_, rb_index, i);
			WriteText(rule_line);
			WriteText("\n");
			delete rule_line;
		}
	}

}

void rule_text_box::SetRule(RuleSet*rs, int rule_block_no, int rule_no)
{
	int rb_index 	= rule_block_no;
	int r_index 	= rule_no;
	
	char *rule_string = new char[FLIP_LINE_LENGTH+1];
	char operator_str[20];
	int op_number=rs->get_operand_number(rb_index, r_index);
	if (rs->get_right_side_cv(rb_index, r_index) != NULL) 
	{
		concat_operator *concat_op = rs->get_aggregate_operator(rb_index, r_index);
		concat_operator2string(*concat_op, operator_str);

		for (int i=0; i<op_number; i++) 
		{  // op_number < OPERAND_NUMBER (<3)
			if(i==0) 
			{
				strcpy(rule_string,"IF ");
				//cout << "leftside name --->"<<
				//	(rs->get_left_side_cv(rb_index, r_index,i))
				//				->get_cv_name() <<"\n";
				strncat(rule_string,
				(rs->get_left_side_cv(rb_index, r_index,i))
								->get_cv_name(),
				FLIP_LINE_LENGTH);
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				strncat(rule_string,"IS ",FLIP_LINE_LENGTH);
				strncat(rule_string,
					(char*)rs->get_left_side_lt(rb_index, r_index,i),
					FLIP_LINE_LENGTH);
			}
			else if(i==1) 
			{
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				strncat(rule_string,operator_str,FLIP_LINE_LENGTH);
				strncat(rule_string,"  IF ",FLIP_LINE_LENGTH);
				strncat(rule_string,rs->get_left_side_cv(rb_index, r_index,i)
						->get_cv_name(),FLIP_LINE_LENGTH);
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				strncat(rule_string,"IS ",FLIP_LINE_LENGTH);
				strncat(rule_string,
					(char*)rs->get_left_side_lt(rb_index, r_index,i),
					FLIP_LINE_LENGTH);
			}
		}
		char certainty_string[NUMBER_STR_LEN];
		print_THEN(	rule_string,
				(rs->get_right_side_cv(rb_index, r_index))->get_cv_name(),
				(char*)(rs->get_right_side_lt(rb_index, r_index)),
				FloatToString(rs->get_certainty(rb_index, r_index)));
			//	nr2str(rs->get_certainty(rb_index, r_index),certainty_string,NUMBER_STR_LEN));
		WriteText(rule_string);
	}
	delete rule_string;
	WriteText(" no rule");
}

void	rule_text_box::show_rules (RuleSet* rs, char *cv_name, char *status)
{
	act_rs_ = rs;
	Clear();
	if(rs)
	{
	   if(cv_name)
	   {	CombinedVariable *cv_ptr = rs->get_cv(cv_name);
		if(cv_ptr) {
			act_rule_block_ = rs->search(cv_ptr);
			if(act_rule_block_>=0)
				SetRule(rs, act_rule_block_);
			else {
				strcpy(status,"no rules for ");
				strcat(status,cv_name);
			}
		}
	    }
	}
}
void	rule_text_box::show_rules (RuleSet* rs, char *status)
{
	act_rs_ = rs;
	int rb_no_max = rs->get_rule_block_number();
	Clear();
	if(rs)
	{
		for (int rb_no=0; rb_no<rb_no_max; rb_no++)
			SetRule(rs, rb_no);
	}
}

char* rule_text_box::make_rule_text(RuleSet* rs, int rule_block_no, int rule_no)
{
//	--------------------------------------------------------------------------------------
//	e.g.   IF alu1  IS 0.34 AND alu2 IS 0.63 THEN alu_alu IS 0.39 WITH CERTAINTY  0.23
//	--------------------------------------------------------------------------------------
//	--------------------------------------------------------------------------------------
//	e.g.   If alu1 = 0.34 AND alu2 = 0.63 then alu_alu = 0.39 (0.23)
//	--------------------------------------------------------------------------------------

	int rb_index 	= rule_block_no;
	int r_index 	= rule_no;
	
	
	char *rule_string = new char[FLIP_LINE_LENGTH+1];
	char operator_str[20];
	int op_number=rs->get_operand_number(rb_index, r_index);
	if (rs->get_right_side_cv(rb_index, r_index) != NULL) 
	{
		concat_operator *concat_op = rs->get_aggregate_operator(rb_index, r_index);
		concat_operator2string(*concat_op, operator_str);

		for (int i=0; i<op_number; i++) 
		{  
			if(i==0) 
			{
				strcpy(rule_string,"IF ");
				//cout << "leftside name --->"<<
				//	(rs->get_left_side_cv(rb_index, r_index,i))
				//				->get_cv_name() <<"\n";
				strncat(rule_string,
					(rs->get_left_side_cv(rb_index, r_index,i))
							->get_cv_name(),FLIP_LINE_LENGTH);
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				if(alternativ_style_)
					strncat(rule_string,"= ",FLIP_LINE_LENGTH);
				else 	strncat(rule_string,"IS ",FLIP_LINE_LENGTH);
				strncat(rule_string,
					(char*)rs->get_left_side_lt
						(rb_index, r_index,i),FLIP_LINE_LENGTH);
			}
			else if(i>=1) 
			{
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				strncat(rule_string,operator_str,FLIP_LINE_LENGTH);
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				strncat(rule_string,rs->get_left_side_cv(rb_index, r_index,i)
						->get_cv_name(),FLIP_LINE_LENGTH);
				strncat(rule_string,"  ",FLIP_LINE_LENGTH);
				if(alternativ_style_)
					strncat(rule_string,"= ",FLIP_LINE_LENGTH);
				else 	strncat(rule_string,"IS ",FLIP_LINE_LENGTH);
				strncat(rule_string,
				  (char*)rs->get_left_side_lt(rb_index, r_index,i),FLIP_LINE_LENGTH);
			}
		}
		char certainty_string[NUMBER_STR_LEN];
		print_THEN(rule_string,
			   (rs->get_right_side_cv(rb_index, r_index))->get_cv_name(),
			   (char*)(rs->get_right_side_lt(rb_index, r_index)),
			   FloatToString(rs->get_certainty(rb_index, r_index)));

		return rule_string;
	}
	delete rule_string;
	return NULL;
}

void rule_text_box::set_output_style(Bool style)
{
	alternativ_style_ = style;
}

void rule_text_box::print_THEN(char* line_string, char* right_side_name, char *right_side_value, 
				char* certainty)
{
    if(alternativ_style_ == FALSE) {
	strncat(line_string," THEN  ",FLIP_LINE_LENGTH);
	strncat(line_string,right_side_name,FLIP_LINE_LENGTH);
	strncat(line_string,"  IS  ",FLIP_LINE_LENGTH);
	strncat(line_string,right_side_value,FLIP_LINE_LENGTH);
	strncat(line_string,"  WITH CERTAINTY  ",FLIP_LINE_LENGTH);
	strncat(line_string,certainty,FLIP_LINE_LENGTH);
	strncat(line_string," ",FLIP_LINE_LENGTH);
    }
    else{
	strncat(line_string," THEN  ",FLIP_LINE_LENGTH);
	strncat(line_string,right_side_name,FLIP_LINE_LENGTH);
	strncat(line_string,"  =  ",FLIP_LINE_LENGTH);
	strncat(line_string,right_side_value,FLIP_LINE_LENGTH);
	strncat(line_string,"  (",FLIP_LINE_LENGTH);
	strncat(line_string,certainty,FLIP_LINE_LENGTH);
	strncat(line_string,") ",FLIP_LINE_LENGTH);
    }
}






CombinedVariable *rule_text_box::is_cv_name(char *cv_name)
{
	return act_rs_->get_cv(cv_name);
}



Bool rule_text_box::is_cv_value(char *token, CombinedVariable *cv)
{
	if(cv){
		NList *n_list_ptr = cv->get_names_of_vars();
		for(int nr=0;nr<n_list_ptr->get_number();nr++)
			if(strcmp(token, (char*)n_list_ptr->find_n(nr))==0)
				return TRUE;
	}
	return FALSE;	
}

char* rule_text_box::getToken(char *token, char *parseText)
{
	// return parseText - token
	// return NULL (if parseText - token == NULL)
	if(parseText == NULL || strcmp(parseText,"")==0) {strcpy(token,""); return NULL;}
	unsigned int text_len = strlen(parseText);
	strcpy(token,strtok(parseText," ")); 
	if(text_len != strlen(token)) {
		parseText = (char*) parseText + strlen(parseText)+1;
		if(strcmp(parseText,"\n")==0) return NULL;
		return parseText;
	}
	return NULL;
}


char* rule_text_box::get_rule_seg_civ(char *text, char *token, rule_dyn_data *rule_data, 
				      char *status, segm_type s_type)

//	 ------------         		 -------------              	 -----------
//	|  variable  |  ---------->	|    IS	      |    ------->	|   value   |
// 	 ------------         		 -------------              	 -----------

{
	CombinedVariable *cv=NULL;
	
	if((cv = is_cv_name(token))==NULL) {			// combined variable
		int rule_no_add = 0;
		if(s_type == SEG_NEW_RULE) rule_no_add = 1;
		error_rule_output(UNKNOWN_VARIABLE,status, token, 
				   rule_data->how_much_rules()+rule_no_add);
		return NULL;
	}


	strcpy(token,strtok(text," ")); 
	if(strcmp(token,"") == 0) return text;	
	if(is_IS(token)) 					// is
	{
		text = (char*) text + strlen(text)+1;
		strcpy(token,strtok(text," ")); 
		if(token == NULL) return text;
	}
	else
		{
			error_rule_output(NO_IS,status, token, rule_data->how_much_rules());
			return NULL;
		}
	
	if(is_cv_value(token, cv)==FALSE){			// value
		int rule_no_add = 0;
		if(s_type == SEG_NEW_RULE) rule_no_add = 1;
		error_rule_output(WRONG_TERM,status, token, 
				   rule_data->how_much_rules() + rule_no_add,
				   cv);
		return NULL;
	}
	text = (char*) text + strlen(text)+1;

	switch(s_type){
	case SEG_NEW_RULE:
		rule_data->add(cv, token);
		break;
	case SEG_IF:
		rule_data->add2lastrule(cv, token);
		break;
	case SEG_THEN:
		rule_data->set_right_side_cv(cv);
		rule_data->set_right_side_val(token);
		break;
	default: cout <<"\n\n\n\t unrecognised status ???\n\n";
	}
	return text;
}

char* rule_text_box::get_rule_seg_cert2(char *text, char *token, rule_dyn_data *rule_data, char *status)
{
	if(is_CERTAINTY2(token)==FALSE) {
		error_rule_output(CERTAINTY_SYNTAX_ERROR, status, token, rule_data->how_much_rules());
		return NULL;
	}

	char val_str[50];
	strcpy(token,token+1);
	char *what = strncpy(val_str,token,strlen(token)-1);
	float cert; 
	StringToFloat(what,&cert);

	if( cert > 1){ 
		strcpy(status," rule error: certainty > 1 !! (certainty = [0 .. 1] )");
		return "error";
	}
	if( cert <0){ 
		strcpy(status," rule error: certainty < 0 !! (certainty = [0 .. 1] )");
		return 0;
	}
	rule_data->set_certainty(cert);

	return getToken(token, text);
}

char* rule_text_box::get_rule_seg_cert(char *text, char *token, rule_dyn_data *rule_data, char *status)
{
	// certainty skipped
	
	if(is_IF(token)==TRUE){
		rule_data->set_certainty(1);
		return text;
	}
	if(is_NIL(token)==TRUE){
		rule_data->set_certainty(1);
		return text;
	}


	// certainty NOT skipped

	if(is_CERT_WITH(token)==FALSE){
		if(is_CERTAINTY2(token)==FALSE){
			error_rule_output(SHOW_RULE, status, token, rule_data->how_much_rules());
		}
		else {			// alternative certainty syntax "(0.4)"
			return get_rule_seg_cert2(text, token, rule_data, status);
		}
		return text;
	}

	text = getToken(token, text);

	if(is_CERTAINTY(token) == FALSE) {
		error_rule_output(SHOW_RULE,status, token, rule_data->how_much_rules());
		return text;
	}


	text = getToken(token, text);
	if(token == NULL) 
	{ 	strcpy(status, "syntax error: no certainty value"); 
			return text;
	}
	float cert;
 	StringToFloat(token,&cert);
	if( cert > 1){ 
		strcpy(status," rule error: certainty > 1 !! (certainty = [0 .. 1] )");
		return "error";
	}
	if( cert <0){ 
		strcpy(status," rule error: certainty < 0 !! (certainty = [0 .. 1] )");
		return 0;
	}
	rule_data->set_certainty(cert);
	return getToken(token, text);
}

char* rule_text_box::Get_rule(char *text, char *token, rule_dyn_data *rule_data, char *status)

//	 --------		 ----------------		----------	   
//	|  IF    |  ---->   	|  rule_seg_civ  |   ------>   |  THEN    |---------->
//	 --------  |		 ----------------		----------	   
//		   |				     ------>   | OPERATOR | --->
//		   |						----------	|
//		   |								|
//		    ----------------------------<-------------------------------




//        --------------		  ------------------
//  ---->|rule_seg_civ  |    -------->   |  with certainty  |
//        --------------		  ------------------

{
	concat_operator op = no_cop, old_op = no_cop;
	segm_type segm_t = SEG_NEW_RULE;

	if(text == NULL || strcmp(text,"")==0 || strcmp(text,"\n")==0 || 
	   strlen(text)==0) return NULL;

	if(strlen(text)==0 || strcmp(text,"\n")==0) return NULL;		// end of text		

	if(is_IF(token)==FALSE) {
		error_rule_output(NO_IF, status, token, rule_data->how_much_rules()+1);
		return NULL;
	}

	do{
		text = getToken(token, text);

		if ((text = get_rule_seg_civ(text, token, rule_data, status, segm_t))==NULL) 
					 return NULL;
		if(strcmp(status,"")!=0) return NULL;

		text = getToken(token, text);
		string2concat_operator(token, &op);
		if(segm_t == SEG_NEW_RULE)
			rule_data->add2lastrule(op);
		else if(is_THEN(token) == FALSE){
			if(is_concat_operator(token)==FALSE) {
				error_rule_output(NO_OPERATORorTHEN,status, token,
						   rule_data->how_much_rules());
				return NULL;
			}
			else if(segm_t == SEG_IF && old_op != op) 
			{
				error_rule_output(OPERATOR_MISMATCH,status, token,
						 rule_data->how_much_rules());
				return NULL;
			}
		}
		segm_t = SEG_IF; // in den SEG_NEW_RULE  Ast 
		old_op = op;	// in den SEG_NEW_RULE  Ast  // !!do_work!!
	}while(is_concat_operator(token));

	if(is_THEN(token)){
		text = getToken(token, text);
		text = get_rule_seg_civ(text, token, rule_data, status, SEG_THEN);
		if ((text == NULL) || (strcmp(status,"")) ) return NULL;
		if(is_rule_recursive(rule_data)) {
			error_rule_output(RECURSIVE_RULE, status, token,
					  rule_data->how_much_rules());
			return NULL;
		}
		text = getToken(token, text);
		if ((text = get_rule_seg_cert(text, token, rule_data, status))==NULL) 
					return NULL;
	}
	else {
		error_rule_output(NO_OPERATORorTHEN,status, token, rule_data->how_much_rules());
		return NULL;
	}
	return text;
}

// no recursive rules
Bool rule_text_box::is_rule_recursive(rule_dyn_data *rule_data)
{
   char *right_name; 
   int rule_no = rule_data->how_much_rules();
   TList *left_terms = rule_data->get_left_term(rule_no-1);
   if(left_terms){
	right_name = rule_data->get_right_term(rule_no-1)->get_cv()->get_cv_name();
	for(int no = 0; no<left_terms->get_number() ; no++){
		if(strcmp(right_name, left_terms->find_cv(no)->get_cv_name() )==0) 
			return TRUE;
	}
    }
    return FALSE;
}

void rule_text_box::error_rule_output(syntaxErrorTyp syntaxError,char *status,char *token, int rule_no,
	void *special)
	// special in use for:
	//	- WRONG_TERM: to get CombinedVariable* information
{
	char err_txt[400];
	char err_eg [100] = "e.g.   If v1 = good and v2 = bad then v3 = good with certainty 0.3";
	char err_eg2[100] = "e.g.   If v1 is good and v2 is bad then v3 is good (0.3)";
	strcpy(err_txt,"there is a syntax error in rule ");
	char *rule_no_str = IntToString(rule_no);
	strcat(err_txt,rule_no_str);
	strcpy(status,err_txt);
	strcat(err_txt,":\n\n");
	switch(syntaxError){
	case NO_OPERATORorTHEN:
		strcat(err_txt,token); 
		strcat(err_txt,"  is no operator or <then>!");
		strcat(err_txt,"\n  (use {AND,OR/and,or} as operators)");
		break;
	case OPERATOR_MISMATCH:
		strcat(err_txt,"do not use OR and AND operators in one rule"); 
		strcpy(err_txt, "do not use OR and AND operators in one rule");
		break;
	case SHOW_RULE:
		strcat(err_txt,err_eg);
		strcat(err_txt,"\n  {good,bad} have to be terms of the variable {v1,v2,v3}");
		break;
	case NO_IF:
		strcat(err_txt,"no If for the rule\n\n");
		strcat(err_txt,err_eg);
		break;
	case NO_IS:
		strcat(err_txt,"there is a <IS> missing\n\n");
		strcat(err_txt,err_eg);
		strcat(err_txt,"\n\n");
		strcat(err_txt,err_eg2);
		break;
	case WRONG_TERM:
		{
		CombinedVariable *act_cv = (CombinedVariable *)special;
		
		char varList[300]; strcpy(varList,"");
		if(act_cv){
			strcat(err_txt,"the variable ");
			strcat(err_txt,(char*)act_cv->get_cv_name());
			strcat(err_txt," has no term like ");
			strcat(err_txt,token);
			strcat(err_txt,".\n ");
			strcat(err_txt,"use a term in this list\n\t{");
			NList *name_list = act_cv->get_names_of_vars();
			if(name_list)				// get list of names (values)
				for(int nr=0; nr< name_list->get_number(); nr++){
					strcat(varList,(char*) name_list->find_n(nr));
					if(nr!=name_list->get_number()-1)
						strcat(varList,", ");
				}
			else {
				strcpy(varList,act_cv->get_cv_name());
				strcat(varList,"  ");
			}
			strcat(err_txt,varList);
			strcat(err_txt,"}");
		}
		else {
			strcat(err_txt,"an unidentified variable has the bad term ");
			strcat(err_txt,token);
		}
		}
		break;
	case UNKNOWN_VARIABLE:
		strcat(err_txt,"don`t know variable ");
		strcat(err_txt,token);
		strcat(err_txt,"!");
		strcat(err_txt,"\n  (use only the variables listed above)");
		break;
	case CERTAINTY_SYNTAX_ERROR:
		strcat(err_txt,"certainty variable syntax error\n");
		strcat(err_txt,"\t2 ways to specify a certainty value:");
		strcat(err_txt,"\t    - to write: <with certainty> + value");
		strcat(err_txt,"\t    -      e.g. <with certainty 0.45>");
		strcat(err_txt,"\t    - or      : <(> + value +<)>");
		strcat(err_txt,"\t    -      e.g. <(0.45)>\n\n");
		strcat(err_txt,err_eg);
		strcat(err_txt,"\n\n");
		strcat(err_txt,err_eg2);
		break;
     	case RECURSIVE_RULE:
		strcat(err_txt,"don`t use right term variable");
		strcat(err_txt," in the left side of the rule!\n");
		strcat(err_txt,"(no recursive rules allowed)");			
	}
	char header_buf[200]; strcpy(header_buf,"syntax error");
	print2errWin(err_txt,header_buf);
}

Bool rule_text_box::is_NIL(char *token)
{
	if(strcmp(token,"")==0) return TRUE;
	return FALSE;
}
Bool rule_text_box::is_THEN(char *token)
{
	if(strcmp(token,"THEN")==0) return TRUE;
	if(strcmp(token,"then")==0) return TRUE;
	if(strcmp(token,"->")==0) return TRUE;
	if(strcmp(token,"-->")==0) return TRUE;
	return FALSE;
}
Bool rule_text_box::is_IF(char *token)
{
	if(strcmp(token,"IF")==0) return TRUE;
	if(strcmp(token,"If")==0) return TRUE;
	if(strcmp(token,"if")==0) return TRUE;
	return FALSE;
}
Bool rule_text_box::is_IS(char *token)
{
	if(strcmp(token,"IS")==0) return TRUE;
	if(strcmp(token,"is")==0) return TRUE;
	if(strcmp(token,"=")==0) return TRUE;
	if(strcmp(token,"==")==0) return TRUE;
	return FALSE;
}
Bool rule_text_box::is_CERT_WITH(char *token)
{
	if(strcmp(token,"WITH")==0) return TRUE;
	if(strcmp(token,"with")==0) return TRUE;
	if(strcmp(token,"(")==0) return TRUE;
	return FALSE;
}
Bool rule_text_box::is_CERTAINTY2(char *token)
{
	if(((char*)strpbrk(token,"(")) == token &&
	   ((char*) strpbrk(token,")")) != NULL) return TRUE;
	  // ((char*) strpbrk(token,")")) == token+strlen(token)-1) return TRUE;
	if(((char*)strpbrk(token,"[")) == token &&
	   ((char*) strpbrk(token,")")) != NULL) return TRUE;
	  // ((char*) strpbrk(token,")")) == token+strlen(token)-1) return TRUE;
	return FALSE;
}
Bool rule_text_box::is_CERTAINTY(char *token)
{
	if(strcmp(token,"CERTAINTY")==0) return TRUE;
	if(strcmp(token,"CERT")==0) return TRUE;
	if(strcmp(token,"certainty")==0) return TRUE;
	if(strcmp(token,"cert")==0) return TRUE;
	return FALSE;
}

Bool rule_text_box::block_text_ok(char *rules_text, rule_dyn_data *rule_data, 
				  char *status)
{
	char token[100];
	if(rules_text == NULL || strlen(rules_text)==0) {
		strcpy(status,"there are no rules");
		return TRUE;
	}
	rules_text = getToken(token, rules_text);
	do {
		rules_text = Get_rule(rules_text, token, rule_data, status);
	} while (rules_text != NULL && strcmp(status,"")==0 
		&& strlen(rules_text)>1 && strcmp(rules_text,"\n")!=0);
	if(strcmp(status,"")==0){	
		return TRUE;
	}
	return FALSE;
}

char* rule_text_box::get_rule_text(void)
{
	char *block_text = GetContents();	// GetContents creates string with new!
	//cout <<"rule text length = "<<strlen(block_text)<<"\n";
	if(block_text==NULL || strlen(block_text)==0) return block_text;
	for(unsigned int i=0; i<strlen(block_text)-1; i++)
	{
		//cout <<block_text[i];
		// elinminate all "returns":
		if((block_text[i] == '\n') || (block_text[i]=='\r'))
			{block_text[i] = ' ';}
	}
	return block_text;
}

Bool rule_text_box::update_rule_block(char *status, Bool all_rules)
{
    if(!Modified()) return TRUE;
    Bool is_update_ok = TRUE;
    int rule_number = 0;
    char *block_text = get_rule_text();
    rule_dyn_data rule_data;
    if(block_text_ok(block_text, &rule_data, status))
    {
	if(all_rules)	{			// remove all rules and all ruleblocks
		while(act_rs_->get_number() > 0)
			act_rs_->remove(0);
	}
	else if(act_rule_block_>-1 && act_rs_->get_number() > 0)	// remove the selected ruleblock which has to be updated
		act_rs_->remove(act_rs_->get_right_side_cv(act_rule_block_,0));
	
	if(rule_data.not_empty())
		rule_number = rule_data.how_much_rules();
	for(int rule_no=0; rule_no<rule_number; rule_no++)
	{
		//cout << "       TEST <update_rule_block>  rule "<< rule_no <<
		//	" :  operator number =  "<< rule_data.left_side_lenght(rule_no)-1 <<
		//	"   var0 name ["<<rule_no<<"] = "<<
		//	(rule_data.get_cv(rule_no, 0))->get_cv_name() <<
		//	"   var1 name ["<<rule_no<<"] = "<<
		//	(rule_data.get_value(rule_no, 0)) <<
		//	"...\n";
		
		if(rule_data.left_side_lenght(rule_no)==1)  // no operator
		{
			act_rs_->add_BasicRule(	
					rule_data.get_cv(rule_no, 0),
					rule_data.get_value(rule_no, 0),
					rule_data.get_right_side_cv(rule_no),
					rule_data.get_right_side_val(rule_no),
					rule_data.get_certainty(rule_no));
		}
	 /*
		else if(rule_data.left_side_lenght(rule_no)==2)  // one operator
		{
			act_rs_->add_ComplexRule(	
					rule_data.get_cv(rule_no, 0),
					rule_data.get_value(rule_no, 0),
					rule_data.get_cv(rule_no, 1),
					rule_data.get_value(rule_no, 1),
					rule_data.get_right_side_cv(rule_no),
					rule_data.get_right_side_val(rule_no),
					rule_data.get_op(rule_no),	
					rule_data.get_certainty(rule_no)
					);
		}
	*/
		else 				// with one or more operators:
		{
			act_rs_->add_Rule(rule_data.get_left_term(rule_no),
					 rule_data.get_right_term(rule_no),
					 rule_data.get_op(rule_no),
					 rule_data.get_certainty(rule_no));
			//cout << "\tADD rule " << rule_data.get_right_side_cv(rule_no)->
			//		get_cv_name()<<"\n";
		}
	} 
	delete block_text;
    }
    else // ther is an error in the rule
	{
		is_update_ok = FALSE;
	}
    return is_update_ok;
}

void rule_text_box::clear_ruleset(void)
{
   RuleSet *rs = act_rs_;
   if(act_rs_){
	while (rs->get_number() >0){
		rs->remove(0);
	}
	rs->get_cv_list()->remove_all();
	while (rs->get_ps_list()->get_number() >0){
		rs->get_ps_list()->remove(0);
	}
   }	
}



/****************************************************************************************
*			 class msf_node				 			*
****************************************************************************************/
msf_node::msf_node(void)
{
	plim_ = NULL;
	selected_node_nr_ = 0;
	set_x(0);
	set_y(0);
	drag_min_x_ = 0;
	drag_min_y_ = 0;
	drag_max_x_ = 0;
	drag_max_y_ = 0;
	selected_function_no_ = 0;
}
void msf_node::clear(void)
{
	plim_ = NULL;
	selected_node_nr_ = 0;
	set_x(0);
	set_y(0);
	drag_min_x_ = 0;
	drag_min_y_ = 0;
	drag_max_x_ = 0;
	drag_max_y_ = 0;
	selected_function_no_ = 0;
}
PlimFuzzySet* msf_node::get_ps_list(void)
{
	return plim_;
}
int msf_node::get_node_number(void)
{
	if(plim_)
		return plim_->get_msf_point_number();
	return -1;
}
int msf_node::get_selected_msf_no(void)
{
	return(selected_function_no_);
}

int msf_node::get_selected_node_no(void)
{
	return selected_node_nr_;
}
void msf_node::set(CombinedVariable *cv, int selected_func_no, int node_number,
		   int drag_min_x, int drag_min_y, int drag_max_x, int drag_max_y)
{
	selected_function_no_ = selected_func_no;
	selected_node_nr_ = node_number; 
	set_x(cv->get_msf_x(selected_func_no,node_number));
	set_y(cv->get_msf_y(selected_func_no,node_number));
	drag_min_x_ = drag_min_x;
	drag_min_y_ = drag_min_y;
	drag_max_x_ = drag_max_x;
	drag_max_y_ = drag_max_y;
	plim_	    = cv->find(selected_function_no_);
}
Bool msf_node::is_selected(void)
{
	if(plim_) return TRUE;
	return FALSE;
}
int msf_node::get_drag_max_x_pix(void)
{
	return(drag_max_x_);
}
int msf_node::get_drag_min_x_pix(void)
{
	return(drag_min_x_);
}
int msf_node::get_drag_max_y_pix(void)
{
	return(drag_max_y_);
}
int msf_node::get_drag_min_y_pix(void)
{
	return(drag_min_y_);
}


/******************************************************************************
*			 class membership_fct_window   			      *
*******************************************************************************/
// window to show a membership function

membership_fct_window::membership_fct_window(
			CombinedVariable *cv,
			Flip_base_window *callingWin,
			char *title)
#ifdef WIN32
	:MyWin(NULL, title, 50, 50, 500, 550,wxSDI)
#else
	:MyWin(callingWin, title, 50, 50, 500, 550,wxSDI)
#endif
{
	char buf[100];
	strcpy(buf,"membership fct: "); 
	if(title == NULL){
		if(cv)
			SetTitle(cv->get_cv_name());
		else SetTitle("no variable");
		strcat(buf,"no variable");
	}
	else strcat(buf,title);

  	int width, height;
      	// Give it an icon
/*      icon = new wxIcon(flip_icn);
      	SetIcon(icon);
*/
  	GetClientSize(&width, &height);

	canvas = new fuzzy_set_canvas(cv,callingWin,(wxFrame*)this, 0, 0, width, height, wxRETAINED);
	//canvas->SetScrollbars(20, 20, 50, 50, 4, 4);
	SetTitle(buf);
}

membership_fct_window::~membership_fct_window()
{
	delete canvas;
}

void membership_fct_window::show(CombinedVariable *cv, 
				const Bool msf_on, const Bool imsf_on, const int sel_cv_no, Bool if_show)
{
	if(!msf_on && !imsf_on)
		Show(FALSE);
	else {
		openWindow(if_show);
		if(cv)
			SetTitle(cv->get_cv_name());
		canvas->set_selected_function_no_(sel_cv_no);
		canvas->show(cv,msf_on,imsf_on);
	}
}

void membership_fct_window::set_msf_scale(void)
{
  if(canvas->in_use()){
     Bool input_ok = FALSE;
     char certainty_string[NUMBER_STR_LEN];
     char x_min_str[20];
     char x_max_str[20];
     float x_min_float, x_max_float;

     wxDialogBox *panel = new wxDialogBox(this,
				"set scale for membership function", TRUE, 40, 40, 500, 160);
     panel->NewLine();
     wxText *x_min_item  = new wxText(panel, NULL, 
				"x minimum = ", FloatToString(canvas->scale.get_sc_x_min()), -1, -1, 150);
     panel->NewLine();
     wxText *x_max_item  = new wxText(panel, NULL, 
				"x maximum = ", FloatToString(canvas->scale.get_sc_x_max()), -1, -1, 150);
    wxButton *ok_button = new wxButton(panel, (wxFunction)&Flip_DialogOkButton, "OK");
    wxButton *cancel_button = new wxButton(panel, (wxFunction)&Flip_DialogCancelButton, "Cancel");

     do{
	Flip_DialogButtonPressed = 0; // a global variable
  	panel->Fit();
  	panel->Centre();
  	panel->Show(TRUE);

	if(Flip_DialogButtonPressed)
	{
		strncpy(x_min_str,x_min_item->GetValue(), 20);
		strncpy(x_max_str,x_max_item->GetValue(), 20);
		StringToFloat(x_min_str,&x_min_float);
		StringToFloat(x_max_str,&x_max_float);

		if(x_min_float<x_max_float){
				input_ok = TRUE; 
		}
		else wxMessageBox("input error: minimum >= maximum");
	}
      } while((input_ok == FALSE) && Flip_DialogButtonPressed);
   }
}









CanvasMenu::CanvasMenu(	char* str, 
			wxFunction func, 
			fuzzy_set_canvas * canv)
	:wxMenu(str, func)

{
	parent = canv;
}

//-----------------------------------------------------------------------
//
//				CLASS  scale_form
//
//-----------------------------------------------------------------------

scale_form::scale_form		(void)
{
	sc_x_min=-100; sc_y=0;
	sc_x_max=200; sc_dy=1;
   	pix_x=150, pix_y=100; 
   	pix_dx=250, pix_dy=300;

	text_font = new wxFont(8, wxSWISS, wxNORMAL, wxNORMAL);
	pen1      = new wxPen("BLACK",1,wxSOLID);

}
scale_form::~scale_form		(void)
{
	delete text_font;
	delete pen1;
}

double scale_form::starting_value(float x,float pot,int vz)
{	x = x * vz;
	double start = pow(10.0,pot);
	for (int i=1;i<10;i++){
		if (start*i >= x) return vz*start*i; 
	}
	return vz*start*9;
}

void scale_form::set_scale_support(float min, float max)
{
    	int min_pot=0, max_pot=0,min_vz = 1,max_vz=1;
    	double first_val, last_val;

	if(min<0)	
		{min_pot  = (int) log10(-1*min); min_vz = -1;}
	else if(min==0) {min_pot  = 1;}
	else 	min_pot  = (int) log10(min);
	
	if(max<0)	
		{max_pot  = (int) log10(-1*max); max_vz = -1;}
	else if(max==0) {max_pot  = 1;}
	else 	max_pot  = (int) log10(max);



	if(max_pot>min_pot)
	{
		first_val = starting_value(min,max_pot,min_vz);
		last_val = starting_value(max,max_pot,max_vz);
	}
	else 
	{
		first_val = starting_value(min,min_pot,min_vz);
		last_val = starting_value(max,min_pot,max_vz);
	}
	sc_x_max = max;
	sc_x_min = min;
    	sc_dx = sc_x_max - sc_x_min;
}



void scale_form::set_scale_support(CombinedVariable *cv)
{
	int i;
	float max, min;
	if(cv!=NULL) {
		max = cv->get_fs_upper_support_end(0);
		for(i=0;i<cv->get_number();i++)
			if(cv->get_fs_upper_support_end(i)>max)
				max = cv->get_fs_upper_support_end(i);

		min = cv->get_fs_lower_support_end(0);
		for(i=0;i<cv->get_number();i++)
			if(cv->get_fs_lower_support_end(i)<min)
				min = cv->get_fs_lower_support_end(i);
		else	set_scale_support(min, max);
	}

}

void scale_form::pixel2scale(float act_pix_x, float act_pix_y, 
					 float *scale_x, float *scale_y)
{	
	float help;

	help = act_pix_x - pix_x;
	help = help / pix_dx * sc_dx;
	*scale_x = help + sc_x_min;

	
	help = pix_y + pix_dy - act_pix_y;
	help = help / pix_dy;
	*scale_y = help / sc_dy;
}

int scale_form::value2pixel_x(float val)
{
	float val_dx,pro;
	int x_int;

	val_dx = sc_dx;
//	if (val < 0) return pix_x;
	pro = (val - sc_x_min) / val_dx;
	x_int = (int)((pix_dx *pro) + pix_x);
	if (x_int > pix_dx+pix_x) return pix_dx+pix_x;
	if (x_int < 0) return 0;
	return x_int;
}

int scale_form::value2pixel_y(float val)		//   	0 <= val <= 1
{
	if (val <= 0) return pix_y+pix_dy;
	if (val > 1) return pix_y; 
	float value_h = val/sc_dy;
	value_h = value_h * pix_dy;
	if (value_h > (pix_y+pix_dy)) return 0; 
	return (int) (pix_y + pix_dy - value_h);
}




void scale_form::Draw(	wxMemoryDC *dc)
{
	int i;
	dc->SetFont(text_font);
 	dc->SetPen(pen1);

	dc->DrawLine(pix_x,pix_y+pix_dy,pix_x,pix_y);				// y-scale
	dc->DrawText("1",pix_x-20,pix_y);
	dc->DrawText("0.9",pix_x-20,pix_y+(pix_dy*0.1)-2);
	dc->DrawText("0.8",pix_x-20,pix_y+(pix_dy*0.2)-2);
	dc->DrawText("0.7",pix_x-20,pix_y+(pix_dy*0.3)-2);
	dc->DrawText("0.6",pix_x-20,pix_y+(pix_dy*0.4)-2);
	dc->DrawText("0.5",pix_x-20,pix_y+(pix_dy/2)-2);
	dc->DrawText("0.4",pix_x-20,pix_y+(pix_dy*0.6)-2);
	dc->DrawText("0.3",pix_x-20,pix_y+(pix_dy*0.7)-2);
	dc->DrawText("0.2",pix_x-20,pix_y+(pix_dy*0.8)-2);
	dc->DrawText("0.1",pix_x-20,pix_y+(pix_dy*0.9)-2);
	dc->DrawText("0",pix_x-20,pix_y+pix_dy);
	for(i=1;i<11;i++) // y-scale 
		dc->DrawLine(pix_x-2,pix_y+(pix_dy/10*i),
			 pix_x+2,pix_y+(pix_dy/10*i));
	dc->DrawLine(pix_x+pix_dx,value2pixel_y(0),pix_x,value2pixel_y(0));	// x-scale at y = 0

	Draw_x_scale(dc,sc_x_min,sc_x_max);			// x - scale
}

void scale_form::draw_x_value(wxMemoryDC *dc,float real_x)
{
	int pix_y_0 = pix_y+pix_dy;
	int pixel_x = value2pixel_x(real_x);
	int corr_x = (int)(text_font->GetPointSize());	
	char * certainty_string = FloatToString(real_x);
	// cout << "\t\tx-value: "<<real_x<< "("<< certainty_string<<"), pixel: "<< pixel_x<<"\n";

	dc->DrawLine(pixel_x, pix_y_0-2, pixel_x, pix_y_0+2);
	dc->DrawText(certainty_string, pixel_x-(corr_x/2), pix_y_0+corr_x);
}


void scale_form::Draw_x_scale(wxMemoryDC *dc,double start,double end)
{
	int i;
	const int scale_granulartiy = 10;
	float scale_val,delta;
	scale_val = start;
	delta = (end-start) / scale_granulartiy;
	for(i = 0; i<scale_granulartiy;i++)
	{
		draw_x_value(dc,scale_val);
		scale_val = scale_val + delta;
	}
	draw_x_value(dc,scale_val);
}





/******************************************************************************
*			 class fuzzy_set_canvas		 		      *
******************************************************************************/


fuzzy_set_canvas::fuzzy_set_canvas(
			CombinedVariable *cv,
			Flip_base_window *callingWin,
			wxFrame *frame, int x, int y, int w, int h, int style = wxRETAINED)
	:wxCanvas(frame, x, y, w, h, style)
{
	selected_function_no_ = 0;
	value_ON = TRUE;
	canvasMode_ = NO_MODE;
	cv_ = cv;
	MSF_On = FALSE; I_MSF_On = FALSE;
	popupMenu = NULL;

	//make_new_node=FALSE;
	choose_node = FALSE;
	callingWindow_ = callingWin;

	memBmp = new wxBitmap(	(int)(scale.get_pix_x()+scale.get_pix_dx()+91), 
				(int)(scale.get_pix_y()+scale.get_pix_dy()+51));
	memDC = new wxMemoryDC();
  	memDC->SelectObject(memBmp);

	if(cv) scale.set_scale_support(cv);
    	sv_y_up = scale.get_pix_y()-25;	// for variable value sign
   	sv_height = 15;
	//sv_y_dw = scale.value2pixel_y(0)+2*sv_height;//scale.get_pix_y()+scale.get_pix_dy()+70;	// lower value sign
	background_colour = new wxColour("WHITE");
	SetTextBackground(background_colour);

	pen0 = new wxPen("RED",1,wxSOLID);
	pen1 = new wxPen("BLACK",1,wxSOLID);
	pen2 = new wxPen("BLUE",3,wxSOLID);
	pen3 = new wxPen("BLUE",10,wxSOLID);
	text_font = new wxFont(17, wxSWISS, wxNORMAL, wxNORMAL);
	text_font2 = new wxFont(8, wxSWISS, wxNORMAL, wxNORMAL);
	text_font2_fat = new wxFont(10, wxSWISS, wxNORMAL, wxNORMAL);
	text_font_normal = new wxFont(12, wxMODERN, wxNORMAL, wxNORMAL);
	brush_clear = new wxBrush("WHITE",wxSOLID);
	brush_trans = new wxBrush("WHITE",wxTRANSPARENT);
	fillBrush   = new wxBrush("BLACK",wxSOLID);	// or wxSOLID; wxCROSS_HATCH; wxVERTICAL_HATCH

	popupMenu = new CanvasMenu(NULL, (wxFunction)canvas_proc,this);
	popupMenu->Append(ADD_NODE, "ADD a node");
	popupMenu->Append(DELETE_NODE, "DELETE a node");
	popupMenu->Break() ;
  	//popupMenu->Append(TEST, "T e s t  -  change scale");


	if(cv) show();
}

fuzzy_set_canvas::~fuzzy_set_canvas(void)
{
	delete memDC;
	delete pen0; delete pen1; delete pen2; delete pen3;
	delete text_font; delete text_font2; delete text_font2_fat; delete text_font_normal;
	delete brush_clear; delete brush_trans; delete fillBrush;
	delete popupMenu;
}

void canvas_proc(CanvasMenu& menu, wxCommandEvent& event)
{
	int callback_value = event.commandInt;
	fuzzy_set_canvas *canvas = menu.get_canvas();
	switch (callback_value)
	{
		case ADD_NODE:	
			canvas->setMode(M_NEW_NODE);
			canvas->SetStatusText(ADD_NODE);
			break;
		case DELETE_NODE:
			canvas->setMode(M_DELETE_NODE);
			canvas->SetStatusText(DELETE_NODE);
			break;

	//	case TEST:
	//		canvas->scale.set_scale_support(canvas->get_last_cv());
	//		canvas->scale.Draw(canvas->get_memDC());
	//		break;

	}
}

void fuzzy_set_canvas::show(CombinedVariable *cv, Bool msf_on, Bool imsf_on)
{
	cv_ = cv;
	MSF_On = msf_on;
	I_MSF_On = imsf_on;	
	show();
}

void fuzzy_set_canvas::show(void)
{
   if(cv_){
  	BeginDrawing();
  	Draw();                     			// first, draw in memory dc
  	(*GetDC()).Blit(0.0, 0.0, 
		  scale.get_pix_x()+scale.get_pix_dx()+90, scale.get_pix_y()+scale.get_pix_dy()+50,     // second, copy memory dc to
		  memDC, 0.0 ,0.0, wxCOPY);   		// display (to avoid flickering)
  	EndDrawing();
   }
  else {
	Clear();
  	SetFont(text_font);
  	Draw_info("no membership fuction");
  }
}


void fuzzy_set_canvas::SetStatusText(char *text)
{
  	BeginDrawing();
	memDC->Clear();
  	memDC->SetFont(text_font2);
  	if(text&&strcmp(text,"")!=0)
		memDC->DrawText(text,1,10);
  	(*GetDC()).Blit(30.0, scale.get_pix_y()+scale.get_pix_dy()+40, 
		  scale.get_pix_x()+scale.get_pix_dx(), 60, 
		  memDC, 0.0 ,0.0, wxCOPY);   		
  	EndDrawing();
}
void fuzzy_set_canvas::SetStatusText(int status)
{
	switch (status)
	{
		case ADD_NODE:		
			SetStatusText("ADD node : select the position by pressing the left mouse button");
			break;
		case DELETE_NODE:	
			SetStatusText("DELETE node : select the node by pressing the left mouse button");
		 	break;
		case STANDART:	
			SetStatusText("press RIGHT mouse button to get pulldown menu");
		 	break;
		case NODE_SELECTED:
			SetStatusText("node selected: LMB UP to reset it");
			break;
	}
}


void fuzzy_set_canvas::Draw(void)
{
  	memDC->Clear();
	if(cv_ && cv_->get_number()>0)
	{
		memDC->SetPen(pen3);
		scale.set_scale_support(cv_);
		memDC->SetFont(text_font);

		scale.Draw(get_memDC());
		Draw_name_of_term(cv_, selected_function_no_);

		if(MSF_On) {
			if(cv_->get_number()<=selected_function_no_)
				cout << "error in fuzzy_set_canvas::Draw --- an unknown membership-function is selected!\n";
			else Draw_fkts(selected_function_no_);
		}
		if(I_MSF_On) {

			if(cv_->get_number()<=selected_function_no_)
				cout << "error in fuzzy_set_canvas::Draw --- an unknown instantiated membership-function is selected!\n";
			else Draw_inst_fkts(selected_function_no_);
		}


		show_cv_value(cv_->get_crisp_value());
	}
}


void fuzzy_set_canvas::Draw_name_of_term(CombinedVariable  *cv,int selected_term)
{
	
	int dx_h = 0;
	if(cv->get_number()>0) { 
		dx_h = scale.get_pix_dx() / cv->get_number();
	}
	char buf[150];
	for(int i=0; (i < cv->get_number()) && (i<10); i++)
	{

		if(i == selected_term)
			memDC->SetFont(text_font2_fat);
		else 	memDC->SetFont(text_font2);
		strcpy(buf,(char*)(cv_->get_names_of_vars()->find_n(i)));
		memDC->DrawText(buf,scale.get_pix_x()+i*dx_h,get_name_of_term_y(cv,i));
	}
}

int fuzzy_set_canvas::get_name_of_term_y(CombinedVariable  *cv,int i)
{
	int dy_h = 0;
	if(cv->get_number()>0)
		dy_h = (scale.get_pix_y() -40) / cv->get_number();
	return 20+dy_h*i;
}

void fuzzy_set_canvas::Draw_cv_name(CombinedVariable *cv, Bool is_instantiated)
{
	char buf[50];
	if(cv)
	{
		memDC->SetFont(text_font);
		if(is_instantiated){
			strcpy(buf,"instantiated membership function of ");
			strcat(buf,cv->get_cv_name());
			memDC->DrawText(buf,50,30);
		}
		else {	strcpy(buf,"membership function of ");
			strcat(buf,cv->get_cv_name());
			memDC->DrawText(buf,50,10);
		}
	}
	else 	memDC->DrawText("no variable",50,10);
}
void fuzzy_set_canvas::Draw_info (char *info_txt)
{
	if(info_txt) {
		memDC->SetFont(text_font_normal);
		memDC->DrawText(info_txt,50,450);
	}
}

Bool fuzzy_set_canvas::instant_func_ok(CombinedVariable *cv)
{
	if (cv)
		if(cv->get_imsf_point_number(0)!=0) { return TRUE;};
	return FALSE;
}
Bool fuzzy_set_canvas::instant_func_ok()
{
	if(cv_)
		if(cv_->get_imsf_point_number(0)!=0) return TRUE;
	return FALSE;
}

void fuzzy_set_canvas::set_inst_mess(char *mess)
{
	memDC->SetFont(text_font2);
	memDC->DrawText(mess,20,450);
}

void fuzzy_set_canvas::Draw_names_of_vars(NList *names_of_vars)
{
	memDC->SetFont(text_font_normal);
	for(int i=0;i<names_of_vars->get_number();i++) {
		
		memDC->DrawText((char*)names_of_vars->find(i),10,30+(i*15));
	}
}


void fuzzy_set_canvas::set_point_sign(const float sc_x,const float sc_y)
{
	int pix_x_point = scale.value2pixel_x(sc_x);
	int pix_y_point = scale.value2pixel_y(sc_y);
	//int pen_width	= pen2->GetWidth();
	
	memDC->SetPen(pen2);
	memDC->DrawEllipse(pix_x_point-4,pix_y_point-4,9,9);
}
void fuzzy_set_canvas::set_point_sign2(const float sc_x, const float sc_y)
{
	int pix_x_point = scale.value2pixel_x(sc_x);
	int pix_y_point = scale.value2pixel_y(sc_y);
	
	memDC->SetPen(pen2);
	memDC->DrawEllipse(pix_x_point-3,pix_y_point-3,7,7);
}

void fuzzy_set_canvas::show_position (const float x, const float y)
{
	BeginDrawing();
	memDC->Clear();
	memDC->SetFont(text_font_normal);
	memDC->SetBrush(brush_clear);
	memDC->DrawRectangle(0,0,scale.get_pix_x()-20,40);	
	char buf[70];
	//char certainty_string[NUMBER_STR_LEN];
	strcpy(buf,"x = "); strncat(buf,FloatToString(x),5); 
	memDC->DrawText(buf,4,1);
	strcpy(buf,"y = "); strncat(buf,FloatToString(y),5);
	memDC->DrawText(buf,4,20);
	(*GetDC()).Blit(5.0, (float) scale.get_pix_x()+(scale.get_pix_dy()/2), 
		(float)scale.get_pix_x()-20, (float)scale.get_pix_dy()-20, memDC, 0.0, 0.0, wxCOPY);
	EndDrawing();
}
void fuzzy_set_canvas::show_position_status (const float x, const float y)
{	
	char buf[100];
	strcpy(buf,"POSITION    x = "); strncat(buf,FloatToString(x),5); 
	strncat(buf,"   y = ",99); strncat(buf,FloatToString(y),5);
	memDC->DrawText(buf,4,20);
	SetStatusText(buf);
}

void fuzzy_set_canvas::show_position(char *text)
{
	if(text)
		memDC->DrawText(text,230,60);

	BeginDrawing();
	memDC->Clear();
	memDC->SetFont(text_font_normal);
	memDC->SetBrush(brush_clear);
	memDC->DrawRectangle(0,0,scale.get_pix_x()-20,40);	
	if(text)
		memDC->DrawText(text,1,1);
	(*GetDC()).Blit(5.0, (float) scale.get_pix_x()+(scale.get_pix_dy()/2), 
		(float)scale.get_pix_x()-20, (float)scale.get_pix_dy()/2, memDC, 0.0, 0.0, wxCOPY);
	EndDrawing();
}	

void fuzzy_set_canvas::Draw_fkts(const int selected_function)
{
	selected_function_no_ = selected_function;
	int fct_no = cv_->get_number();		// number of functions
	{
		for (int x=0;x<fct_no;x++)
			if(x!=selected_function)
				Draw_msf(cv_,x,cv_->get_msf_point_number(x),FALSE);
			else  	Draw_msf(cv_,x,cv_->get_msf_point_number(x),TRUE);
	}
}


void fuzzy_set_canvas::Draw_inst_fkts(const int selected_function)
{
	selected_function_no_ = selected_function;
	int fct_no = cv_->get_number();			// number of functions
	if(instant_func_ok(cv_))
	{
		for (int x=0;x<fct_no;x++)
			if(x!=selected_function)
				Draw_inst_msf(cv_,x,cv_->get_imsf_point_number(x),FALSE);
		Draw_inst_msf(cv_,selected_function,cv_->get_imsf_point_number(selected_function),TRUE);
	}
	else 
	{
		Draw_info("there is no instantiated function");
	}
}

void fuzzy_set_canvas::Draw_fkts(CombinedVariable  *cv,const int selected_term)
{
	cv_=cv;
	Draw_fkts(selected_term);
}

void fuzzy_set_canvas::Draw_inst_fkts(CombinedVariable  *cv,const int selected_term)
{
	cv_=cv;
	Draw_inst_fkts(selected_term);
}
void fuzzy_set_canvas::Draw_msf(CombinedVariable *pfs,const int fkt_no,const int point_number, 
				 Bool is_sel_fkt)
{
	int colour_nr = *pfs->find(fkt_no)->get_fs_colour();
	char colour_name[20]; get_wxColour(colour_nr, colour_name);
	int width = 1;
	if (is_sel_fkt && (!I_MSF_On)) width=2;
	//if (pen0) delete pen0;
	//pen0 = new wxPen(colour_name, width, wxSOLID);
	pen0->SetWidth(width); pen0->SetStyle(wxSOLID); pen0->SetColour(colour_name);

	for(int i=0;i<point_number-1;i++)
	{
		memDC->SetPen(pen0);
		memDC->DrawLine(scale.value2pixel_x(pfs->get_msf_x(fkt_no,i)),
		 	 scale.value2pixel_y(pfs->get_msf_y(fkt_no,i)),
		 	 scale.value2pixel_x(pfs->get_msf_x(fkt_no,i+1)),
		 	 scale.value2pixel_y(pfs->get_msf_y(fkt_no,i+1)));
		if(!I_MSF_On && is_sel_fkt) {
			set_point_sign(pfs->get_msf_x(fkt_no,i),pfs->get_msf_y(fkt_no,i));
			set_point_sign(pfs->get_msf_x(fkt_no,i+1),pfs->get_msf_y(fkt_no,i+1));
		}
	}
}

void fuzzy_set_canvas::Fill_msf	(int pkt1_x,int pkt1_y, int pkt2_x, int pkt2_y)
// fillBrush has to be set before
{
	wxPoint points[8];
	points[0].x = pkt1_x;
	points[0].y = scale.get_pix_y() + scale.get_pix_dy();
	points[1].x = pkt1_x;
	points[1].y = pkt1_y;
	points[2].x = pkt2_x;
	points[2].y = pkt2_y;
	points[3].x = pkt2_x;
	points[3].y = scale.get_pix_y() + scale.get_pix_dy();

	memDC->SetBrush(fillBrush);
	memDC->DrawPolygon(4,points,0,0,wxWINDING_RULE);		//wxODDEVEN_RULE
}

void fuzzy_set_canvas::Draw_inst_msf(CombinedVariable *pfs,const int fkt_no,
					      const int point_number, Bool is_sel_fkt)
{
	const int pointArrNo = 30;
	int point_no;
	wxPoint points[pointArrNo+2];
	int i = 0;
	int colour_nr = *pfs->find(fkt_no)->get_fs_colour();
	char colour_name[20]; get_wxColour(colour_nr, colour_name);
	int width = 2;
	if (is_sel_fkt) {
		width=4;
		fillBrush->SetStyle(wxSOLID);
	}
	else {
		fillBrush->SetStyle(wxCROSS_HATCH);
	}

	pen0->SetWidth(width); pen0->SetStyle(wxSOLID); pen0->SetColour(colour_name);
	fillBrush->SetColour(colour_name); 
	
	memDC->SetPen(pen0);
	memDC->SetBrush(fillBrush);

	while (i < point_number){
		for(point_no=0;point_no<pointArrNo && i<point_number; point_no++)
		{
			points[point_no+1].x = scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i));
			points[point_no+1].y = scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i));
			i = i + 1;
		}
		points[0].x = points[1].x;
		points[0].y = scale.value2pixel_y(0);
		points[point_no+2].x = points[point_number].x;
		points[point_no+2].y = scale.value2pixel_y(0);
		memDC->DrawPolygon(point_no+1,points,0,0,wxODDEVEN_RULE);		//wxODDEVEN_RULE; wxWINDING_RULE
	}
}



/*
void fuzzy_set_canvas::Draw_inst_msf(CombinedVariable *pfs,const int fkt_no,
					      const int point_number, Bool is_sel_fkt)
{
	int colour_nr = *pfs->find(fkt_no)->get_fs_colour();
	char colour_name[20]; get_wxColour(colour_nr, colour_name);
	int width = 2;
	if (is_sel_fkt) width=4;
	//if (pen0) delete pen0;
	//pen0 = new wxPen(colour_name, width, wxSOLID);
	pen0->SetWidth(width); pen0->SetStyle(wxSOLID); pen0->SetColour(colour_name);
	fillBrush->SetColour(colour_name);

//	cout << "\n\tTEST pointnumber is " << point_number << ".\n";
	for(int i=0;i<point_number-1;i++)
	{

//		cout << "\t\tTEST for cv >>"<< pfs->get_cv_name() <<" << : Punkt " << i << " Line(" << pfs->get_imsf_x(fkt_no,i) << ", " <<
//		 	 pfs->get_imsf_y(fkt_no,i) << ", " <<
//		 	 pfs->get_imsf_x(fkt_no,i+1) << ", " <<
//		 	 pfs->get_imsf_y(fkt_no,i+1) << ") ---transform-to--> (";
//
//		cout <<  scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i)) << ", " <<
//		 	 scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i)) << ", " <<
//		 	 scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i+1)) << ", " <<
//		 	 scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i+1)) << ");\n";

		memDC->SetPen(pen0);

//		memDC.DrawLine(scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i)),
//		 	 scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i)),
//		 	 scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i+1)),
//		 	 scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i+1)));

		Fill_msf(scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i)),
		 	 scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i)),
		 	 scale.value2pixel_x(pfs->get_imsf_x(fkt_no,i+1)),
		 	 scale.value2pixel_y(pfs->get_imsf_y(fkt_no,i+1)));

//		set_point_sign(pfs->get_imsf_x(fkt_no,i),pfs->get_imsf_y(fkt_no,i));
	}

//	if (point_number>1) 
//		set_point_sign(pfs->get_imsf_x(fkt_no,i+1),pfs->get_imsf_y(fkt_no,i+1));
// end of test
}
*/


void fuzzy_set_canvas::get_wxColour(int colour, char* colour_name)
{
	switch (colour){
		case violet:		strcpy(colour_name, "RED"); break;
		case blue:		strcpy(colour_name, "BLUE"); break;
		case light_blue: 	strcpy(colour_name, "LIGHT BLUE"); break;
		case turquoise:		strcpy(colour_name, "TURQUOISE"); break;
		case green:		strcpy(colour_name, "GREEN"); break;
		case yellow:		strcpy(colour_name, "YELLOW"); break;
		case orange:		strcpy(colour_name, "ORANGE"); break;
		case pink:		strcpy(colour_name, "MAGENTA"); break;
		case red:		strcpy(colour_name, "RED"); break;
		case white:		strcpy(colour_name, "WHITE"); break;
		case black:		strcpy(colour_name, "BLACK"); break;
		case grey:		strcpy(colour_name, "GREY"); break;
		case light_grey:	strcpy(colour_name, "LIGHT GREY"); break;
		case dark_grey:		strcpy(colour_name, "DARK GREY"); break;
		case dark_blue:		strcpy(colour_name, "DARK BLUE"); break;
		case light_green:	strcpy(colour_name, "LIGHT GREEN"); break;
		case dark_green:	strcpy(colour_name, "DARK GREEN"); break;
		case light_red:		strcpy(colour_name, "LIGHT RED"); break;
		case dark_red:		strcpy(colour_name, "DARK RED"); break;
		case brown:		strcpy(colour_name, "BROWN"); break;

		default: 		strcpy(colour_name, "MAGENTA"); break;
	}
}



Bool fuzzy_set_canvas::is_a_imsfs_node(int x_pix, int y_pix, float *x_pkt, float *y_pkt, 
					int *imsf_no, int *imsf_node_no)
{
	int fl_val_x,fl_val_y;
	int i;
	int fct_no = cv_->get_number();			// number of functions
	for (int x=0;x<fct_no;x++)
	{
		for(i=0;i<cv_->get_imsf_point_number(x);i++)
		{
			fl_val_x = scale.value2pixel_x(cv_->get_imsf_x(x, i));
			if(fl_val_x-5<x_pix && fl_val_x+5>x_pix)
			{
				fl_val_y = scale.value2pixel_y(cv_->get_imsf_y(x, i));
				if(fl_val_y-5<y_pix && fl_val_y+5>y_pix)
				{
					*x_pkt = cv_->get_imsf_x(x, i);
					*y_pkt = cv_->get_imsf_y(x, i);
					*imsf_no = x;
					*imsf_node_no  = i;
					return TRUE;
				}
			}
		}
	}
	*x_pkt = 0; *y_pkt = 0; *imsf_no = 0; *imsf_node_no = 0 ;
	return FALSE;
}

Bool fuzzy_set_canvas::is_a_msf_node(int msf_no, float x_pix, float y_pix,
					 float *x_pkt, float *y_pkt, int *node_no)
{
	int i;
	int fl_val_x,fl_val_y;
		for(i=0;i<cv_->get_msf_point_number(msf_no);i++)
		{
			fl_val_x = scale.value2pixel_x(cv_->get_msf_x(msf_no, i));
			if(fl_val_x-5<x_pix && fl_val_x+5>x_pix)
			{
				fl_val_y = scale.value2pixel_y(cv_->get_msf_y(msf_no, i));
				if(fl_val_y-5<y_pix && fl_val_y+5>y_pix)
				{
					*x_pkt = cv_->get_msf_x(msf_no, i);
					*y_pkt = cv_->get_msf_y(msf_no, i);
					*node_no  = i;
					return TRUE;
				}
			}
		}
	*x_pkt = 0; *y_pkt = 0; *node_no = 0;
	return FALSE;
}

Bool fuzzy_set_canvas::is_a_msfs_node(float x_pix, float y_pix, float *x_pkt, float *y_pkt,
					int *imsf_no, int *imsf_node_no)
{
	int fct_no = cv_->get_number();			// number of functions
	for (int x=0;x<fct_no;x++)
	{
		if(is_a_msf_node(x, x_pix, y_pix, x_pkt, y_pkt, imsf_node_no))
		{
			*imsf_no = x;
			return TRUE;
		}
	}
	*x_pkt = 0; *y_pkt = 0; *imsf_no = 0; *imsf_node_no = 0 ;
	return FALSE;
}

// Define the repainting behaviour
void fuzzy_set_canvas::OnPaint(void)
{
	//cout << "\t\t !!! ONPaint Event !!! \n";

  	BeginDrawing();

  	Draw();                                		// first, draw in memory dc
  	(*GetDC()).Blit(0.0, 0.0, 
		scale.get_pix_x()+scale.get_pix_dx()+90, 
		scale.get_pix_y()+scale.get_pix_dy()+50,     	// second, copy memory dc to
		memDC, 0.0 ,0.0, wxCOPY);   		// display (to avoid flickering)
  	EndDrawing();
}

void	fuzzy_set_canvas::OnSize(int x, int y)
{
	//cout << "\t\t !!! ONSize Event !!! ("<< x << ","<<y<<")\n";
	int width,length,new_x,new_y;
	GetSize(&width,&length);
	if(width>400) new_x = 400/4;  else new_x = width/4;
	if(length>400) new_y = 400/4; else new_x = length/4;
	scale.set_win_pix(
		new_x,
		width-(2*new_x)-2,
		new_y,
		length-(2*new_y)-2);

      #ifdef WIN32
	wxBitmap *memBmp2 = new wxBitmap((int)(scale.get_pix_x()+scale.get_pix_dx()+91), 
				(int)(scale.get_pix_y()+scale.get_pix_dy()+51));
	wxMemoryDC *memDC_new = new wxMemoryDC(GetDC());
	memDC_new->SelectObject(memBmp2);
	delete memDC;
	memDC = memDC_new;  memDC_new=NULL;
	memBmp = memBmp2;  memBmp2 = NULL;
      #else
	delete memBmp; 
	memBmp = new wxBitmap(	(int)(scale.get_pix_x()+scale.get_pix_dx()+91), 
				(int)(scale.get_pix_y()+scale.get_pix_dy()+51));
  	memDC->SelectObject(memBmp);

      #endif
	show();

}

void fuzzy_set_canvas::OnEvent (wxMouseEvent& event)
{
	float 		event_x_pix, event_y_pix;
	static Bool 	out_of_range;
	int 		function_no = selected_function_no_; 
	static int	function_node_no = 0;
	float 		x_node=0, y_node=0;
	event.Position(&event_x_pix, &event_y_pix);
//	cout << "\t\t("<<(int)event_x_pix<<","<<(int)event_y_pix<<")\n";

	if (event.RightDown()) 
	{
		wxDC *dc = GetDC();
		PopupMenu(popupMenu, dc->LogicalToDeviceX(event_x_pix), dc->LogicalToDeviceY(event_y_pix));
	}
	else if(canvasMode_ == M_NEW_NODE && event.ButtonDown()) 			// ADD a node
	{
		scale.pixel2scale(event_x_pix, event_y_pix, &x_node, &y_node);
		cv_->add_msf_point(function_no,x_node,y_node);
		canvasMode_ = NO_MODE;
		show();
		SetStatusText(STANDART);
	}
	else if(canvasMode_ == M_SET_VALUE && 
		 (event.ButtonDown() || event.Dragging())) 			// SET: cv = value
	{
		if(event_x_pix < scale.get_pix_x()+scale.get_pix_dx() && event_x_pix > scale.get_pix_x())
		{
			scale.pixel2scale(event_x_pix,event_y_pix,&x_node,&y_node); 
			cv_->set_value(x_node);
			//show_position_status(x_node, y_node);
			SetStatusText_value(x_node);
			show_cv_value_copy2dc(x_node);		
		}
	}
	else if(canvasMode_ == M_SET_VALUE && event.ButtonUp()) 			// SET: cv = value
	{
		if(event_x_pix < scale.get_pix_x()+scale.get_pix_dx() && event_x_pix > scale.get_pix_x())
		{
			scale.pixel2scale(event_x_pix,event_y_pix,&x_node,&y_node); 
			cv_->set_value(x_node);
			//show_position_status(x_node, y_node);
			SetStatusText_value(x_node);
			show_cv_value_copy2dc(x_node);		
			canvasMode_= NO_MODE;
			SetStatusText(STANDART);
			callingWindow_->show();		// show new cv value in calling window
		}
	}
	else if(event.ButtonDown())						// SELECT a node
	{	SetStatusText(STANDART);
		unselect_node();
		if(is_a_msf_node(function_no,	event_x_pix, event_y_pix, 
					&x_node, &y_node,
					&function_node_no))
		{
			select_node(function_no, function_node_no);
			SetStatusText(NODE_SELECTED);
			choose_node = TRUE;
			out_of_range  = FALSE;
			if(canvasMode_==M_DELETE_NODE)				// DELETE a node
			{	delete_selected_node();
				canvasMode_ = NO_MODE;
				SetStatusText(STANDART);
			}
		}
		else { int val_pix = scale.value2pixel_x(cv_->get_crisp_value());
		   if(event_x_pix > val_pix-10 && event_x_pix < val_pix+10 &&		// SET: cv = value
		      (event_y_pix > sv_y_up-10 && event_y_pix < sv_y_up+sv_height+10)){
			 // ||
			 //(event_y_pix > sv_y_dw-10 && event_y_pix < sv_y_dw+sv_height+10))){
			canvasMode_ = M_SET_VALUE;
		   }
		}
	}
	else if(event.Dragging())
	{    
	//	cout << "dragging: ["<< selected_node.get_drag_max_x_pix()<< "," <<
	//	selected_node.get_drag_min_x_pix() << "," <<
	//	selected_node.get_drag_max_y_pix() << "," <<
	//	selected_node.get_drag_min_y_pix() <<
	//	"]\n";
	    if(choose_node){
		if(event_x_pix <= selected_node.get_drag_max_x_pix()&&
		   event_x_pix >= selected_node.get_drag_min_x_pix()&&
		   event_y_pix <= selected_node.get_drag_max_y_pix()&&
		   event_y_pix >= selected_node.get_drag_min_y_pix())
		{
			scale.pixel2scale(event_x_pix,event_y_pix,&x_node,&y_node);
			show_position_status(x_node, y_node);
			out_of_range = FALSE;
		}
		else 
		{
			SetStatusText("out of range");
		//	show_position("out of range");
			out_of_range = TRUE;
		}
             }
	}
	else if(event.LeftUp() && choose_node)
	{
		if(event_x_pix > selected_node.get_drag_max_x_pix())
			event_x_pix = selected_node.get_drag_max_x_pix();
		else if(event_x_pix < selected_node.get_drag_min_x_pix())
			event_x_pix = selected_node.get_drag_min_x_pix();
		if(event_y_pix > selected_node.get_drag_max_y_pix())
			event_y_pix = selected_node.get_drag_max_y_pix();
		else if(event_y_pix < selected_node.get_drag_min_y_pix())
			event_y_pix = selected_node.get_drag_min_y_pix();

		scale.pixel2scale(event_x_pix, event_y_pix, &x_node, &y_node);
		set_msf_node(	selected_node.get_selected_msf_no(), 		// set a node
				selected_node.get_selected_node_no(), 
				x_node, y_node);
		out_of_range = FALSE;
		//make_new_node = FALSE;
	}	
	else if(event_y_pix > scale.get_pix_y())				// select action out of
	{	int sel_funct_no = 0;						// function area
		for(int i = 0;i<cv_->get_number();i++)
			if (event_y_pix < get_name_of_term_y(cv_,i))
				sel_funct_no ++;

		//cout << "select function: "<<sel_funct_no<<"\n";
	}

}

void fuzzy_set_canvas::SetStatusText_value(float x)
{
	char 	buf[100];
	strcpy(buf,"VALUE =  "); strncat(buf,FloatToString(x),5); 
	//strncat(buf,"   y = ",99); strncat(buf,FloatToString(y),5);
	SetStatusText(buf);
}

void fuzzy_set_canvas::unselect_node(void)
{
	if(selected_node.is_selected())
	{
		set_point_sign(selected_node.get_x(),selected_node.get_y());
	}
	choose_node = FALSE;
	selected_node.clear();
}
void fuzzy_set_canvas::select_node(const int function_no, const int function_node_no)
{
	int drag_min_x, drag_max_x;
	set_range_for_set_node(function_no, function_node_no, &drag_min_x,&drag_max_x);
	if(selected_node.is_selected())
		unselect_node();

	selected_node.set(cv_, function_no, function_node_no, 
			drag_min_x, scale.get_pix_y(), drag_max_x, scale.get_pix_y()+scale.get_pix_dy());
	set_point_sign2(selected_node.get_x(),selected_node.get_y());
	choose_node = TRUE;
}

void fuzzy_set_canvas::delete_selected_node(void)
{
	
	if(selected_node.is_selected())
	{
		(selected_node.get_ps_list())->delete_msf_point(selected_node.get_selected_node_no());
		unselect_node();
		show();
	}
}


void fuzzy_set_canvas::set_range_for_set_node(int function_no, int selected_node_number, 
					      int *drag_min_x, int *drag_max_x)
{
	int number_of_nodes = cv_->get_msf_point_number(function_no);

	if((number_of_nodes > selected_node_number+1)&&(selected_node_number>0)) // middle node
	{
		*drag_min_x = scale.value2pixel_x(cv_->get_msf_x(function_no,selected_node_number-1));
		*drag_max_x = scale.value2pixel_x(cv_->get_msf_x(function_no,selected_node_number+1));
	}
	else 
	{
		*drag_min_x = scale.get_pix_x();
		*drag_max_x = scale.get_pix_x()+scale.get_pix_dx();
	}
}


void fuzzy_set_canvas::set_msf_node(int msf_number, int selected_node_number, 
					float new_x, float new_y)
{
	if(selected_node_number+1==(cv_->get_msf_point_number(msf_number)))
		{cv_->set_fs_upper_support_end(msf_number, new_x); }
	else if(selected_node_number == 0)
		{cv_->set_fs_lower_support_end(msf_number, new_x); }
	else 
	{
		cv_->set_msf_y(msf_number, selected_node_number, new_y);
		cv_->set_msf_x(msf_number, selected_node_number, new_x);
	}
	unselect_node();
	show();
}

Bool fuzzy_set_canvas::show_cv_value(float value)
{
    if(value_ON)
	if((value != -1) && 
	   value < cv_->get_range_upper_end() &&
	   value > cv_->get_range_lower_end()){
		memDC->SetFont(text_font2);
		int x_scale_value = scale.value2pixel_x(value);
		memDC->DrawLine(x_scale_value,sv_y_up, x_scale_value,sv_y_up+sv_height-2); // upper mark
		//memDC->DrawLine(x_scale_value,sv_y_dw, x_scale_value,sv_y_dw+sv_height-2); // lower mark
		memDC->DrawText("value",x_scale_value+5, sv_y_up);
		return TRUE;
	}
    return FALSE;
}

Bool fuzzy_set_canvas::show_cv_value_copy2dc(float value)
{
    if(value_ON)
	if((value != -1) &&
	   value < cv_->get_range_upper_end() &&
	   value > cv_->get_range_lower_end()){
		BeginDrawing();		// upper value mark
		memDC->Clear();
		memDC->SetFont(text_font2);
		int x_pix_value = scale.value2pixel_x(value);
		memDC->DrawLine(30,0, 30, sv_height);
		//memDC->SetFont(text_font2);
		memDC->DrawText("value",35, 0);
		(*GetDC()).Blit((float)x_pix_value-30, (float) sv_y_up, 
				100.0, (float)sv_height, memDC, 0.0, 0.0, wxCOPY);
		EndDrawing();

		//	BeginDrawing();		// lower value mark
		//	memDC.Clear();
		//	memDC.SetFont(text_font2);
		//	memDC.DrawLine(30,0, 30,sv_height);
		//	(*GetDC()).Blit((float)x_pix_value-30,(float)sv_y_dw, 
		//				100.0, (float)sv_height, &memDC, 0.0, 0.0, wxCOPY);
		//	EndDrawing();

		return TRUE;
	}
    return FALSE;
}




/*****************************************************************************
*			class point_float				     *
******************************************************************************/

point_float::point_float(void)
{
	x_=0; y_=0;
}
point_float::point_float(float x, float y)
{
	x_=x;y_=y;
}

  float		point_float::get_x		(void)
{	
	return x_;
}
  float		point_float::get_y		(void)
{
	return y_;
}
  void		point_float::set_x		(float x) 
{
	x_=x;
}
  void		point_float::set_y		(float y) 
{
	y_=y;
}
  void		point_float::set		(float x,float y) 
{
	x_=x;y_=y;
}




/****************************************************************************************
*			 class Parameter_Win		 				*
****************************************************************************************/
Parameter_Win::Parameter_Win(wxFrame *parent, ParameterSet *ps,char *head_text,char *def_path)
	:Window_def_file(parent, head_text,def_path, 50, 50, 400, 300)
{
      	SetSize(200,150,400,400);
	ps_=ps;
      	// Give it an icon
//        icon = new wxIcon(flip_icn);
//      	SetIcon(icon);

  	// Give it a status line
      	CreateStatusLine();

  	// Make a menubar
  	wxMenu *child_file_menu = new wxMenu;
      	child_file_menu->Append(PARA_READ, "&READ");
      	child_file_menu->Append(PARA_WRITE, "&WRITE");
      	wxMenuBar *childmenu_bar = new wxMenuBar;
      	childmenu_bar->Append(child_file_menu,"&File");
     	SetMenuBar(childmenu_bar); 

     	childpanel = new wxPanel(this, 0, 0, 400, 250, wxBORDER);
     	childpanel->SetLabelPosition(wxVERTICAL);

	char buf[90];
	char certainty_string[NUMBER_STR_LEN];
	strcpy(buf,"name = "); strcat(buf,ps->get_ps_name());
	ps_name = new wxMessage(childpanel,buf);
  	childpanel->NewLine();
	range_lower_end = new wxText(childpanel,NULL,"range_lower_end = ",FloatToString(ps->get_range_lower_end()));
  	childpanel->NewLine();
	range_upper_end = new wxText(childpanel,NULL,"range_upper_end = ",FloatToString(ps->get_range_upper_end()));
  	childpanel->NewLine();
	median 		= new wxText(childpanel,NULL,"median 	  = ",FloatToString(ps->get_median()));
  	childpanel->NewLine();
	distribution 	= new wxText(childpanel,NULL,"distribution 	  = ",FloatToString(ps->get_distribution()));
  	//childpanel->NewLine();		// old version
  	//char *direction_strings[] = { "in","out"};
	//direction_choice = new wxChoice(childpanel,NULL,"direction",
	//				-1,-1,-1,-1,2, direction_strings);
	//direction dirkt =   ps->get_inout();
	//if(dirkt==in)
	//	direction_choice->SetSelection(0);
 	//else	direction_choice->SetSelection(1);
 	childpanel->NewLine();

 	wxButton *ok_button = new wxButton(childpanel, (wxFunction)&paraSet_Save_proc, "OK");
  	ok_button->SetDefault();

  	childpanel->Fit();
  	childpanel->Show(TRUE);

}

Parameter_Win::~Parameter_Win()
{
	cout <<"Parameter_Win deleted \n";
}

void Parameter_Win::OnMenuCommand(int id)
{
   switch(id)
   {
    case PARA_WRITE: // save corresponding table 
    {
	char *file = wxFileSelector("Chose a file to write",get_dir(),0,0,fpara_extension_);
	if(file){ // if "OK" button pressed in wxGetTextFromUser
		set_path(file);
		write(file);
	}
      	break;
    }
    case PARA_READ: // load corresponding table
    {
  	//wxPanel *panel = (wxPanel *)button.GetParent();
  	//Parameter_Win *paraWin = (Parameter_Win *)button.GetGrandParent();

	char *file_name_ptr;
	file_name_ptr = wxFileSelector("Chose a file to read",get_dir(),0,0,fpara_extension_);
	if(file_name_ptr) // if "OK" button pressed
	{
		set_path(file_name_ptr);
		read(file_name_ptr); 	
		show();
	}
      	break;
    }
  }
}

void Parameter_Win::show(ParameterSet *ps, Bool if_show)
{
	ps_ = ps;
	show(if_show);
}
void Parameter_Win::show(Bool if_show)
{
	openWindow();	// temp:   openWindow(if_show);
	if (ps_!=NULL)
	{
		//char certainty_string[NUMBER_STR_LEN];
		ps_name->SetLabel(ps_->get_ps_name());
		//ps_name->SetValue(ps_->get_ps_name());
		range_lower_end->SetValue(FloatToString(ps_->get_range_lower_end()));
		range_upper_end->SetValue(FloatToString(ps_->get_range_upper_end()));
		median->SetValue(FloatToString(ps_->get_median()));
		distribution->SetValue(FloatToString(ps_->get_distribution()));
		//if(ps_->get_inout()==in)	// old version
		//	direction_choice->SetSelection(0);
		//else 	direction_choice->SetSelection(1);
		//	direction->SetValue("in");
		//else 	direction->SetValue("out");
	}
}

void Parameter_Win::read(char *name)
{
	ifstream infile;
	if(ps_)
		delete ps_;
	ps_ = new ParameterSet;
	infile.open (name, ios::in);
	ps_->read (&infile);
	infile.close();
}
void Parameter_Win::write(char *file_name)
{
     	ofstream outfile;
	outfile.open (file_name);
	if (flip_fstream_OK(&outfile)) 
		{ ps_->write (&outfile);outfile.close();}
	else flip_error.show(Stream_Error);
}



// -----------------
//	Callbacks:
// -----------------


void paraSet_Save_proc(wxButton &button, wxCommandEvent&)
{
	Parameter_Win* win = (Parameter_Win*) button.GetGrandParent();
	win->SetStatusText("");
	float range_lower_end_val, range_upper_end_val, median_val, distribution_val;
	//char *name_st 		= win->name->GetValue();
	name range_lower_end_str; 
	strncpy(range_lower_end_str,win->range_lower_end->GetValue(),NAME_LENGTH);
	name range_upper_end_str; 
	strncpy(range_upper_end_str,win->range_upper_end->GetValue(),NAME_LENGTH);
	name median_str; 
	strncpy(median_str,win->range_lower_end->GetValue(),NAME_LENGTH);
	name distribution_str; 
	strncpy(distribution_str,win->distribution->GetValue(),NAME_LENGTH);
	if(convert_string2float(range_lower_end_str, &range_lower_end_val)&&
		  convert_string2float(range_upper_end_str, &range_upper_end_val)&&
		  convert_string2float(distribution_str, &distribution_val)&&
		  convert_string2float(median_str, &median_val))
	{
		if(range_lower_end_val<range_upper_end_val)
		{
		if(median_val<range_upper_end_val)
		{
		if(median_val>range_lower_end_val)
		{
		if(distribution_val>=0&&distribution_val<=1)
		{
			//direction in_out;	// old version
			//switch(win->direction_choice->GetSelection())
			//{
			//	case 0:	in_out = in;	break;
			//	default: in_out = out;
			//}
			//win->ps_->set_ps_name(name_st);
			win->ps_->set_range_lower_end(range_lower_end_val);
			win->ps_->set_range_upper_end(range_upper_end_val);
			win->ps_->set_median(median_val);
			win->ps_->set_distribution(distribution_val);
			// win->ps_->set_inout(in_out);	// old version
 		    }
		    else wxMessageBox("distribution is not [0 . . . 1]","error");
 		    }
		    else wxMessageBox("I cannot accept that median is smaller than lower range value","error");
 		    }
		    else wxMessageBox("I cannot accept that median value is bigger than upper range value","error");
 		    }
		    else wxMessageBox("I cannot accept that upper value is smaller than lower value","error");
	
	} else wxMessageBox(" cannot save: input all (float) values","no save");
}


// edit procedures:

void para_rle		(wxText& text, wxCommandEvent&)
{
	float value;
	char certainty_string[NUMBER_STR_LEN];
	Parameter_Win* paraWinPtr = (Parameter_Win*) text.GetGrandParent();
	name number; strncpy(number,paraWinPtr->range_lower_end->GetValue(),NAME_LENGTH);
	if(convert_string2float(number,&value))
		paraWinPtr->ps_->set_range_lower_end(value);
	strncpy(certainty_string,number,NUMBER_STR_LEN);
	//paraWinPtr->range_lower_end->SetValue(nr2str(paraWinPtr->ps_->get_range_lower_end(),certainty_string,NUMBER_STR_LEN));
	paraWinPtr->range_lower_end->SetValue(certainty_string);
}

void para_rue		(wxText& text, wxCommandEvent&)
{
	float value;
	char certainty_string[NUMBER_STR_LEN];
	Parameter_Win* paraWinPtr = (Parameter_Win*) text.GetGrandParent();
	name number; strncpy(number,paraWinPtr->range_upper_end->GetValue(),NAME_LENGTH);
	if(convert_string2float(number,&value))
		paraWinPtr->ps_->set_range_upper_end(value);
	strncpy(certainty_string,number,NUMBER_STR_LEN);
	//paraWinPtr->range_upper_end->SetValue(nr2str(paraWinPtr->ps_->get_range_upper_end(),certainty_string,NUMBER_STR_LEN));
	paraWinPtr->range_upper_end->SetValue(certainty_string);
}


void para_med		(wxText& text, wxCommandEvent&)
{
	float value;
	char certainty_string[NUMBER_STR_LEN];
	Parameter_Win* paraWinPtr = (Parameter_Win*) text.GetGrandParent();
	name number; strncpy(number,text.GetValue(),NAME_LENGTH);
	if(convert_string2float(number,&value))
		paraWinPtr->ps_->set_median(value);
	strncpy(certainty_string,number,NUMBER_STR_LEN);
	//paraWinPtr->median->SetValue(nr2str(paraWinPtr->ps_->get_median(),certainty_string,NUMBER_STR_LEN));
	paraWinPtr->median->SetValue(certainty_string);
}


void para_dtr		(wxText& text, wxCommandEvent&)
{
	float value;
	char certainty_string[NUMBER_STR_LEN];
	Parameter_Win* paraWinPtr = (Parameter_Win*) text.GetGrandParent();
	name number; strncpy(number,text.GetValue(),NAME_LENGTH);
	if(convert_string2float(number,&value))
		paraWinPtr->ps_->set_distribution(value);
	strncpy(certainty_string,number,NUMBER_STR_LEN);
	paraWinPtr->distribution->SetValue(certainty_string);
	//paraWinPtr->distribution->SetValue(nr2str(paraWinPtr->ps_->get_distribution(),certainty_string,NUMBER_STR_LEN));
}
/******************************************************************************
*				 ChoiceParameterList		 	      *
*******************************************************************************/

ChoiceParameterList::ChoiceParameterList(wxPanel *panel, wxFunction func, char *Title,int x,int y)
	:wxChoice(panel,func,Title,x,y,-1,-1)
{
	list_ = NULL;
}

ChoiceParameterList::ChoiceParameterList(PSList* list, wxPanel *panel, wxFunction func, char *Title,int x,int y)
	:wxChoice(panel,func,Title,x,y,-1,-1,0,NULL)
{
	list_ = list;
	if(list)
		for(int nr=0;nr<list->get_number();nr++)
			Append(list->find(nr)->get_ps_name());
}

ParameterSet* ChoiceParameterList::Get_ps()
{
	int nr= GetSelection();
	if(nr>-1)
		return list_->find(nr);
	return NULL;
}

void ChoiceParameterList::Set_ps(PSList* list)
{
	list_ = list;
	Clear();
	if(list)
		for(int nr=0;nr<list->get_number();nr++)
			Append(list->find(nr)->get_ps_name());
}



/******************************************************************************
*				 colour_choice_box		 		      *
*******************************************************************************/

colour_choice_box::colour_choice_box(wxPanel *panel, wxFunction func, char *Title,int x,int y)
	:wxChoice(panel,func,Title,x,y,-1,-1,0,NULL)
{
	Append("violet");
	Append("blue");
	Append("light_blue");
	Append("turquoise");
	Append("green");
	Append("yellow");
	Append("orange");
	Append("red");
	Append("pink");
	Append("white");
	Append("black");
	Append("grey");
	Append("light grey");
	Append("dark grey");
	Append("dark blue");
	Append("light green");
	Append("dark green");
	Append("light red");
	Append("dark red");
	Append("brown");
}

colourtype colour_choice_box::Get_colour (void)
{
	switch(GetSelection()+1)
	{
	case 1: return violet;
	case 2: return blue;
	case 3: return light_blue;
	case 4: return turquoise;
	case 5: return green;
	case 6: return yellow;
	case 7: return orange;
	case 8: return red;
	case 9: return pink;
	case 10: return white;
	case 11: return black;
	case 12: return grey;
	case 13: return light_grey;
	case 14: return dark_grey;
	case 15: return dark_blue;
	case 16: return light_green;
	case 17: return dark_green;
	case 18: return light_red;
	case 19: return dark_red;
	case 20: return brown;
	}
	return red;
}
	
void	colour_choice_box::Set_colour	(colourtype colour)
{
	switch(colour)
	{
	case violet: 	SetSelection(0); break;
	case blue: 	SetSelection(1); break;
	case light_blue:SetSelection(2); break;
	case turquoise: SetSelection(3); break;
	case green: 	SetSelection(4); break;
	case yellow: 	SetSelection(5); break;
	case orange: 	SetSelection(6); break;
	case red: 	SetSelection(7); break;
	case pink: 	SetSelection(8); break;
	case white: 	SetSelection(9); break;
	case black: 	SetSelection(10); break;
	case grey: 	SetSelection(11); break;
	case light_grey:SetSelection(12); break;
	case dark_grey: SetSelection(13); break;
	case dark_blue: SetSelection(14); break;
	case light_green: SetSelection(15); break;
	case dark_green: SetSelection(16); break;
	case light_red: SetSelection(17); break;
	case dark_red: 	SetSelection(18); break;
	case brown: 	SetSelection(19); break;
	default	:	SetSelection(1); break;
	}
}








//---------------------------------------------------------------------------------------
//			 class ChoiceColourWin	 					-
//---------------------------------------------------------------------------------------


ChoiceColourWin::ChoiceColourWin(wxWindow *window,colourtype old_colour, colourtype *new_colour,Bool *is_ok)
	:wxDialogBox(window,"select a colour for the actual term", TRUE, 10, 10, 500, 160)
{
  	SetClientSize(320, 160);
	colour_choice_box colour_box(this,NULL,"list of colours");
	colour_box.Set_colour(old_colour);
 	(void)new wxButton(this, (wxFunction)&Flip_DialogOkButton, "OK");
  	(void)new wxButton(this, (wxFunction)&Flip_DialogCancelButton, "Cancel");
  	NewLine();
  	Flip_DialogButtonPressed = 0;
	(*is_ok) = FALSE;
  	Fit();
  	Centre();
  	Show(TRUE);
	if(Flip_DialogButtonPressed) 
	{
		colourtype col = colour_box.Get_colour();
		(*new_colour) = col;
		(*is_ok) = TRUE;
	}
	
}



/******************************************************************************
*				 TermListBox		 		      *
*******************************************************************************/

TermListBox::TermListBox(wxPanel *panel, wxFunction func, char *Title,
					int x=-1,int y=-1,
					int width = -1)
	:wxListBox(panel,func,Title,wxSINGLE,x,y,width)
{
}

void TermListBox::set(NList* term_list)
{
	Clear();
	if(term_list){
		for(int nr=0; nr<term_list->get_number_NList(); nr++)
			Append((char*)term_list->find_n(nr));
	}
}

void TermListBox::set(CombinedVariable *cv)
{
	if(cv){
		set(cv->get_names_of_vars());
	} 
	else set((CombinedVariable *)NULL);
}
int TermListBox::Get_term_no(void)
{
	return GetSelection();
}




/************************************************************************
*			PSList_window_base	 			*
*************************************************************************/


PSList_window_base::PSList_window_base(wxFrame *parent, char *title, char *default_dir,
					wxMessage *def_dir_mess)
	:Window_def_file(parent, title, default_dir, 50, 50, 400, 300)
{
	ps_list_ = new PSList;
	ps_=NULL;
	def_dir_mess_ = def_dir_mess;

      	// Give it an icon 
//        icon = new wxIcon(flip_icn);
//      	SetIcon(icon);

  	// Make a menubar
  	wxMenu *child_file_menu = new wxMenu;
      	//child_file_menu->Append(PARA_DIR, "&default save DIR");
      	child_file_menu->Append(MSF_PARA_READ, "&READ");
      	child_file_menu->Append(MSF_PARA_WRITE, "&WRITE");
     	wxMenuBar *childmenu_bar = new wxMenuBar;
      	childmenu_bar->Append(child_file_menu,"&File");
     	SetMenuBar(childmenu_bar); 

     	childpanel = new wxPanel(this, 10, 10, 400, 250, wxBORDER);
     	childpanel->SetLabelPosition(wxVERTICAL);

 	(void)new wxButton(childpanel, (wxFunction)&psl_add, "ADD");
 	(void)new wxButton(childpanel, (wxFunction)&psl_delete, "DELETE");
 	//(void)new wxButton(childpanel, (wxFunction)&psl_edit, "EDIT");

  	childpanel->NewLine();
	param_Box = new wxListBox(childpanel, (wxFunction)&psl_callback_box_proc,"parameter sets",
					wxSINGLE,-1,-1,300);
  	childpanel->NewLine();
	ps_name = new wxMessage(childpanel,"");
	childpanel->NewLine();
	range_lower_end_mess = new wxMessage(childpanel,"");
	childpanel->NewLine();
	range_upper_end_mess = new wxMessage(childpanel,"");
	childpanel->NewLine();
	median_mess = new wxMessage(childpanel,"");
	childpanel->NewLine();
	distribution_mess = new wxMessage(childpanel,"");
	childpanel->NewLine();
	update_title();
}
void  PSList_window_base::get_extension	(char* ext_name)
{
 	strcpy((char*)ext_name, fpara_extension_);
}

void PSList_window_base::OnMenuCommand (int id)
{
	char buf[90];
	switch(id)
	{
	case MSF_PARA_READ:
		char *file_name_ptr;
		char extension[100]; get_extension(extension);
		file_name_ptr = wxFileSelector("Chose a file to read",get_dir(),0,0,extension);
		if(file_name_ptr) // if "OK" button pressed
		{
			set_path(file_name_ptr);
			read(file_name_ptr); 	
			show();
			if(def_dir_mess_){
				strcpy(buf,"data pool: active membership parameter file: ");
				strcat(buf, get_dir());
				def_dir_mess_->SetLabel(buf);
			}
			else strcpy(buf,"data pool: membership parameter: no active object");
		}
		break;
	case MSF_PARA_WRITE:
	   if(ps_list_)
	   {
		char extension[100]; get_extension(extension);
		char *file = wxFileSelector("Chose a file to write",get_dir(),NULL,NULL,extension);
		if(file){ // if "OK" button pressed in wxGetTextFromUser
			set_path(file);
			write(file);
		}
	   }
	   else SetStatusText("there is no data to write");
	   break;
	case PARA_DIR:
		set_dir();
		break;
	}
}

void PSList_window_base::set(PSList* list)
{
	ps_list_ = list;
}

void PSList_window_base::set_param_box(void)
{
	param_Box->Clear();
	for(int i=0;i<ps_list_->get_number();i++)
		param_Box->Append(ps_list_->find(i)->get_ps_name());
}

ParameterSet* PSList_window_base::Get_parameter_set(void)
{
	int sel = param_Box->GetSelection();
	if(sel>-1&&ps_list_)
		return ps_list_->find(sel);
	else return NULL;
}

void PSList_window_base::set_parameter_items(ParameterSet *ps)
{
	if(ps)
	{
		char buf[30];
		char certainty_string[NUMBER_STR_LEN];
		ps_ = ps;
		strcpy(buf,"name = "); strncat(buf,ps->get_ps_name(),29);
		ps_name->SetLabel(buf);
		strcpy(buf,"range_lower_end = "); 		
		strncat(buf,nr2str(ps->get_range_lower_end(),
			certainty_string,NUMBER_STR_LEN),29);
		range_lower_end_mess->SetLabel(buf);
		strcpy(buf,"range_upper_end = "); 
		strncat(buf,nr2str(ps->get_range_upper_end(),
			certainty_string,NUMBER_STR_LEN),29);
		range_upper_end_mess->SetLabel(buf);
		strcpy(buf,"median = "); 
		strncat(buf,nr2str(ps->get_median(),
			certainty_string,NUMBER_STR_LEN),29);
		median_mess->SetLabel(buf);
		strcpy(buf,"distribution = "); 
		strncat(buf,nr2str(ps->get_distribution(),
			certainty_string,NUMBER_STR_LEN),29);
		distribution_mess->SetLabel(buf);
	}
}

void  PSList_window_base::show(void)
{
	if(Iconized()) 
		Iconize(FALSE);
	else Show(TRUE,TRUE); // 2`nd Arg is dummy

	if(ps_list_)
	{
		set_param_box();
		//set_parameter_items(Get_parameter_set());
	}
}

void PSList_window_base::read(char *file)
{
	ifstream infile;
	if(ps_list_==NULL)
		ps_list_ = new PSList;
	 else if(ps_list_->get_number()>0){
		// delete ps_list_;  	// set parameter list in associated ruleset too!!
		do {
			ps_list_->remove(0);
		}while(ps_list_->get_number()>0);
	}
	infile.open (file, ios::in);
	if (infile.is_open()) 
	{
		SetStatusText("read file ..");
		if((ps_list_->read (&infile))!=1)	// flip error
			flip_error.show();
		infile.close();
		set_param_box();
		update_title();
		show();
	}
	else SetStatusText("read error");
}

void PSList_window_base::write(char *file)
{
     	ofstream outfile;
	outfile.open (file);
	if (fstream_OK(&outfile)) 
	{ 	if((ps_list_->write (&outfile))!=1)
			flip_error.show();
		else { SetStatusText("wrote data to file"); update_title();}
		outfile.close();
	}
	else flip_error.show(Stream_Error);
}

void PSList_window_base::update_title(void)
{
	char buf[150];
	strcpy(buf,"parameter list ");
	if(get_file_name()){
		strcat(buf," (");
		strcat(buf,get_file_name());
		strcat(buf,")");
	}
	SetTitle(buf);
}

void PSList_window_base::add(void)
{
	SetStatusText("add a table");
	ParameterSet *ps = newParaSetFromUser();
	if(ps)
	{
		char err_buf[200]; strcpy(err_buf,"");
		ps_list_->add(ps);
		if(strcmp(err_buf,"")!=0) SetStatusText(err_buf);
		set_param_box(); 
		param_Box->SetSelection(ps_list_->get_number()-1);
		show();
	}
	else SetStatusText("no parameter set added");
}

void PSList_window_base::del(void)
{
	SetStatusText("");
	int select = param_Box->GetSelection();
	if(select>-1)
	{
		ps_list_->remove(select);
		set_param_box();
		if(select<ps_list_->get_number())
			param_Box->SetSelection(select);
		show();
	}
}


ParameterSet *PSList_window_base::newParaSetFromUser(void)
{
	float dil_val;
	ParameterSet* ps = NULL;
	wxDialogBox dialog (this,"new set of parameter",TRUE, 40, 40, 500, 160);
  	dialog.SetClientSize(320, 160);

	wxText *dialog_name = new wxText(&dialog,NULL,"name = ","",-1,-1,200);
  	dialog.NewLine();
	wxText *range_lower_end = new wxText(&dialog,NULL,"range_lower_end = ","0");
  	dialog.NewLine();
	wxText *range_upper_end = new wxText(&dialog,NULL,"range_upper_end = ","0");
  	dialog.NewLine();
	wxText *median 		= new wxText(&dialog,NULL,"median 	  = ","0");
  	dialog.NewLine();
	//wxText *distribution 	= new wxText(&dialog,NULL,"distribution 	  = ","0");
	wxSlider distribution_sld(&dialog,NULL,"distribution  = ",50,0,100,100);
  	dialog.NewLine();

	// add importance
	//wxText *importance_txt 	= new wxText(&dialog,NULL,"importance 	  = ","0");
	wxSlider importance_sld(&dialog,NULL,"importance  = ",50,0,100,100);
  	dialog.NewLine();

	// add dilatation
	//wxText *dilatation_txt 	= new wxText(&dialog,NULL,"dilatation 	  = ","0");
	wxSlider dilatation_sld(&dialog,NULL,"dilatation  = ",50,0,100,100);
  	dialog.NewLine();
	
	// add NList & CList  (each term has a color!)
	wxSlider term_no_sld(&dialog,NULL,"how much terms  = ",3,1,10,100);

 	wxButton *ok_button = new wxButton(&dialog, (wxFunction)&Flip_DialogOkButton, "OK");
  	(void*)new wxButton(&dialog, (wxFunction)&Flip_DialogCancelButton, "Cancel");
  	ok_button->SetDefault();

	Flip_DialogButtonPressed = 0;
  	dialog.Fit();
  	dialog.Centre();
  	dialog.Show(TRUE);
	if(Flip_DialogButtonPressed)
	{
		float range_lower_end_val, range_upper_end_val, median_val, distribution_val;
		name name_st; strncpy(name_st,dialog_name->GetValue(),NAME_LENGTH);
		name range_lower_end_str; strncpy(range_lower_end_str,range_lower_end->GetValue(),NAME_LENGTH);
		name range_upper_end_str; strncpy(range_upper_end_str,range_upper_end->GetValue(),NAME_LENGTH);
		name median_str; strncpy(median_str,median->GetValue(),NAME_LENGTH);
		distribution_val = ((float)distribution_sld.GetValue()) / 100;

		if(convert_string2float(range_lower_end_str, &range_lower_end_val)&&
		   convert_string2float(range_upper_end_str, &range_upper_end_val)&&
		   //convert_string2float(distribution_str, &distribution_val)&&
		   convert_string2float(median_str, &median_val)&&
		   name_st)
		{
		    if(range_lower_end_val<range_upper_end_val)
		    {
		    if(median_val<=range_upper_end_val)
		    {
		    if(median_val>=range_lower_end_val)
		    {
		    if(distribution_val>=0&&distribution_val<=1)
		    {

  			NList name_list(term_no_sld.GetValue());
  			CList colour_list;		// !!do_work!!
  			colour_list.add(blue);
  			colour_list.add(violet);	
  			colour_list.add(black);	
  			colour_list.add(dark_green);	
  			colour_list.add(light_red);	
  			colour_list.add(pink);	
  			colour_list.add(red);	
  			colour_list.add(dark_grey);	
  			colour_list.add(dark_blue);	
  			colour_list.add(light_green);	
  			colour_list.add(red);	
  			colour_list.add(red);	
  			colour_list.add(red);	
  			colour_list.add(red);	
  			colour_list.add(red);	
  			colour_list.add(red);	

			float importance_val = ((float)importance_sld.GetValue()) / 100;
			dil_val  = ((float)dilatation_sld.GetValue()) / 100;
						// Test end
			ps = new ParameterSet(
						name_st,
						range_lower_end_val,
						range_upper_end_val,
						median_val,
						distribution_val,
						dil_val,
						importance_val,
						&colour_list,
						&name_list);
 		    }
		    else wxMessageBox("distribution is not [0 . . . 1]","error");
 		    }
		    else wxMessageBox("I cannot accept that median is smaller than lower range value","error");
 		    }
		    else wxMessageBox("I cannot accept that median value is bigger than upper range value","error");
 		    }
		    else wxMessageBox("I cannot accept that upper value is smaller than lower value","error");
		}
		else 
			wxMessageBox("input a number ,syntax is ##.#####   e.g.  0.34","no new parameter set created");
	}
	dialog.Show(FALSE);
	return ps;
}

// CALLBACK FUNCTION:

void psl_callback_box_proc		(wxListBox& box, wxEvent&)
{
	PSList_window_base* paraWinPtr = (PSList_window_base*) box.GetGrandParent();
	paraWinPtr->SetStatusText("");
	ParameterSet* ps = paraWinPtr->Get_parameter_set();
	//paraWinPtr->set_parameter_items(ps);
	paraWinPtr->show();
}

void psl_add		(wxButton& button, wxEvent&)
{
	PSList_window_base* paraWinPtr = (PSList_window_base*) button.GetGrandParent();
	paraWinPtr->add();
}

void psl_delete		(wxButton& button, wxEvent&)
{
	PSList_window_base* win = (PSList_window_base*) button.GetGrandParent();
	win->del();
}




/************************************************************************
*			PSList_window	 				*
*************************************************************************/


PSList_window::PSList_window(wxFrame *parent, char *title, char *default_dir,
					wxMessage *def_dir_mess, Bool make_items)
	:PSList_window_base(parent, title, default_dir, def_dir_mess)
{
   SetSize(150, 50, 500, 700);
   if(make_items){
	name_ps = new wxText(childpanel,(wxFunction)&ed_psl_name,"name = ","",-1,-1,100);
  	childpanel->NewLine();
	range_lower_end = new wxText(childpanel,(wxFunction)&ed_psl_range0,
				"range_lower_end = ","");
  	childpanel->NewLine();
	range_upper_end = new wxText(childpanel,(wxFunction)&ed_psl_range1,
				"range_upper_end = ","");
  	childpanel->NewLine();
	median 		= new wxText(childpanel,(wxFunction)&ed_psl_median,
				"median 	  = ","");
  	childpanel->NewLine();

	distribution_sld = new wxSlider(childpanel,(wxFunction)&ed_psl_distr,
				"distribution  = ",50,0,100,100);
  	childpanel->NewLine();

	// add importance
	importance_sld = new wxSlider(childpanel,(wxFunction)&ed_psl_importance,
				"importance  = ",50,0,100,100);
  	childpanel->NewLine();

	// add dilatation
	dilatation_sld = new wxSlider(childpanel,(wxFunction)&ed_psl_dilatation,
				"dilatation  = ",50,0,100,100);
  	childpanel->NewLine();
	wxButton *add_button = new wxButton(childpanel, (wxFunction)&ADD_term_proc, "ADD TERM");
  	childpanel->NewLine();
	// add NList & CList  (each term has a color!)
	term_list_box = new TermListBox(childpanel,
			(wxFunction)&ed_psl_term_list,"term list",-1,-1,180);
	term_select 	= new wxText(childpanel,(wxFunction)&psl_edit_term_proc,"","",-1,-1,100);
	colour_box_ = new colour_choice_box(childpanel,(wxFunction)&psl_edit_term_colour,"term colour");
   }
   last_termNr_ = -1;
   update_title();
}

void  PSList_window::show(void) // don't update param_Box
{
	ParameterSet *ps = Get_parameter_set();
	
	set_parameter_items(ps);
}

void PSList_window::set_parameter_items(ParameterSet *ps)
{
	char certainty_string[NUMBER_STR_LEN];
	//PSList_window_base::set_parameter_items(ps);
	if(ps){ strcpy(certainty_string,""); 
		name_ps->SetValue(ps->get_ps_name());
		double number = (double)ps->get_range_lower_end();
		sprintf(certainty_string,"%g",number);
		range_lower_end->SetValue(
			certainty_string);
		sprintf(certainty_string,"%g",ps->get_range_upper_end());
		range_upper_end->SetValue(certainty_string);
		median->SetValue(nr2str(ps->get_median(),
			certainty_string,NUMBER_STR_LEN));
		distribution_sld->SetValue((int)(ps->get_distribution()*100));
		importance_sld->SetValue((int)(ps->get_importance()*100));
		dilatation_sld->SetValue((int)(ps->get_dilatation()*100));
		term_list_box->set(ps->get_NList());
		term_select->SetValue(
			(char*) ps->get_NList()->find(term_list_box->GetSelection()));
		last_termNr_ = term_list_box->GetSelection();
	}
}


void PSList_window::edit_term(void)
{
   if(Get_parameter_set()){
	int which_term_no = term_list_box->GetSelection();
	if(which_term_no>-1){	// edit last term
		name value_nm; 
		strncpy(value_nm,term_select->GetValue(),NAME_LENGTH);
		edit_term(value_nm, which_term_no);
		term_list_box->SetSelection(which_term_no);
	}
   }
}
void PSList_window::edit_term(char *new_term, int term_no)
{
	Name *sel_term = Get_parameter_set()->get_NList()->find(term_no);
	
	if(strcmp(new_term,(char*)sel_term)!=0){
		strncpy((char*)sel_term->get_name(),new_term,NAME_LENGTH);
		term_list_box->set(Get_parameter_set()->get_NList());
	}
}
void PSList_window::add_term(void)
{  ParameterSet *ps_ptr = Get_parameter_set();
   if(ps_ptr){
	//NList *akt_list = ps_ptr->get_NList();
	ps_ptr->NList::add(wxGetTextFromUser("name = ","add term",""));
	term_list_box->set(ps_ptr->get_NList());
	term_list_box->SetSelection(ps_ptr->NList::get_number());
   }
}
void PSList_window::edit_name(void)
{
   if(Get_parameter_set()){
	name value_nm;
	strncpy(value_nm,name_ps->GetValue(),NAME_LENGTH);
	if(!value_nm)
		print2errWin("input a name");
	else {
		int sel_ps_no = param_Box->GetSelection();
		Get_parameter_set()->set_ps_name(value_nm);
		set_param_box();
		param_Box->SetSelection(sel_ps_no);
	}
    }
}
void PSList_window::edit_range0(void)
{
   if(Get_parameter_set()){
	name value_nm; float value;
	strncpy(value_nm,range_lower_end->GetValue(),NAME_LENGTH);
	if(!convert_string2float((char*)value_nm,&value))
		print2errWin("input a float value");
	else 
		Get_parameter_set()->set_range_lower_end(value);
   }
}
void PSList_window::edit_range1(void)
{
   if(Get_parameter_set()) 
   {
	name value_nm; float value;
	strncpy(value_nm,range_upper_end->GetValue(),NAME_LENGTH);
	if(!convert_string2float((char*)value_nm,&value))
		print2errWin("input a float value");
	else 
		Get_parameter_set()->set_range_upper_end(value);
    }
}
void PSList_window::edit_median(void)
{
   if(Get_parameter_set()){
	name value_nm; float value;
	strncpy(value_nm,median->GetValue(),NAME_LENGTH);
	if(!convert_string2float((char*)value_nm,&value))
		print2errWin("input a float value");
	else 
		Get_parameter_set()->set_median(value);
   }
}
void PSList_window::edit_distr(void)
{
  if(Get_parameter_set()){
	int  value_sl = distribution_sld->GetValue(); 
	float value = ((float)value_sl)/100;
	Get_parameter_set()->set_distribution(value);
   }
}
void PSList_window::edit_importance(void)
{
   if(Get_parameter_set()){
	int  value_sl = importance_sld->GetValue(); 
	float value = ((float)value_sl)/100;
	Get_parameter_set()->set_importance(value);
    }
}
void PSList_window::edit_dilatation(void)
{
   if(Get_parameter_set()){
	int  value_sl = dilatation_sld->GetValue(); 
	float value = ((float)value_sl)/100;
	Get_parameter_set()->set_dilatation(value);
   }
}
void PSList_window::edit_term_list(void)
{
   if(Get_parameter_set()){
	int ps_nr = term_list_box->GetSelection();
	if(ps_nr > -1){
		term_select->SetValue((char*) Get_parameter_set()->get_NList()->find(ps_nr));
		colour_box_->Set_colour(*Get_parameter_set()->
						   get_CList()->find(ps_nr)->get_colour());
	}
	else term_select->SetValue("");
	last_termNr_ = term_list_box->GetSelection();
   }
}
void PSList_window::edit_term_colour(void)
{
   if(Get_parameter_set()){
	colourtype new_colour = colour_box_->Get_colour();
	Get_parameter_set()->get_CList()->find(term_list_box->GetSelection())->
					set_colour(new_colour);
   }
}


// CALLBACK function

void ADD_term_proc	(wxButton& button, wxEvent&)
{
   PSList_window* win = (PSList_window*) button.GetGrandParent();
   win->add_term();
}
void ed_psl_name	(wxText& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_name();
}
void ed_psl_range0	(wxText& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_range0();
}
void ed_psl_range1	(wxText& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_range1();
}

void ed_psl_median	(wxText& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_median();
}
void ed_psl_distr	(wxSlider& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
    win->edit_distr();
}
void ed_psl_importance	(wxSlider& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_importance();
}
void ed_psl_dilatation	(wxSlider& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_dilatation();
}

void ed_psl_term_list	(TermListBox& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_term_list();
}


void psl_edit_term_proc (wxText& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_term();
}

void psl_edit_term_colour (colour_choice_box& obj, wxEvent&)
{
   PSList_window* win = (PSList_window*) obj.GetGrandParent();
   win->edit_term_colour();
}




//---------------------------------------------------------------------------------------
//			 CLASS  Flip_base_panel		 				-
//---------------------------------------------------------------------------------------

Flip_base_panel::Flip_base_panel(void)
{
  	constraint_mess  		= NULL;
	imp_mess  			= NULL;
	dilatation_mess  		= NULL;
        eval_value_mess 		= NULL;

}

void Flip_base_panel::set_panel(wxPanel *panel, int info_x, int info_y, int dy)
{
  	constraint_mess  		= new wxMessage(panel, "", info_x+30   , info_y);
	imp_mess  			= new wxMessage(panel, "", info_x+30, info_y+dy);
	dilatation_mess  		= new wxMessage(panel, "", info_x+30, info_y+(2*dy));
        eval_value_mess 		= new wxMessage(panel, "", info_x+30, info_y+(3*dy));

}

void Flip_base_panel::set_info(CombinedVariable *info)
{
	Clear_info_panel();
	char certainty_string[NUMBER_STR_LEN];
	if(info && constraint_mess){
 		char buf[250];
		//strcpy(buf,"variable ");	strcat(buf,info->get_cv_name());
		strcpy(buf,"crisp value: ");
		strcat(buf,FloatToString(info->get_crisp_value()));
		if(info->get_crisp_value() != -1)
 			constraint_mess->SetLabel(buf);
		else constraint_mess->SetLabel("        ");

	
		strcpy(buf,"dilatation  is   ");	strcat(buf,FloatToString(info->get_dilatation()));
		dilatation_mess->SetLabel(buf);

		strcpy(buf,"importance is   ");	strcat(buf,FloatToString(info->get_importance()));
		imp_mess->SetLabel(buf);
	}
}

void Flip_base_panel::Clear_info_panel(void)
{
   if(constraint_mess){
  	constraint_mess->SetLabel("");
  	dilatation_mess->SetLabel("");
  	imp_mess->SetLabel("");
	eval_value_mess->SetLabel("");
    }
}

void Flip_base_panel::set_info_name_list(wxListBox *box, CVList *cv_list)
{
    if(box){
	box->Clear();
	if (cv_list)
	{
		for(int nr=0; nr<cv_list->get_number(); nr++)
			box->Append(cv_list->find(nr)->get_cv_name());
	}
    }
}

//---------------------------------------------------------------------------------------
//			 CLASS  Flip_panel		 				-
//---------------------------------------------------------------------------------------

Flip_panel::Flip_panel(void)
	:Flip_base_panel()
{
	show_all_rules_ = FALSE;
	msf_win		= NULL;
     	rule_menue = new wxMenu;
      	term_menue = new wxMenu;
	rule_how_much_menu = new wxMenu;
      	rule_menue->Append(RULE_BLOCK_UPDATE, "&UPDATE edits");
      	rule_menue->Append(DUMMY_CASE, "&show how much rules", rule_how_much_menu);
      	rule_menue->Append(RULE_OUTPUT_STYLE, "&change output rule style");
      	rule_menue->Append(SET_OPERATOR, "&EDIT operator set");

	rule_how_much_menu->Append(RULE_SHOW_ALL,"&Show ALL rules");
	rule_how_much_menu->Append(RULE_SHOW_VAR,"&Show only rules for selected variable");

      	term_menue->Append(ADD_NODE, "&add a NODE to MSF");
      	term_menue->Append(SET_VALUE,"&set VALUE of variable");
      	term_menue->Append(DELETE_NODE, "&DEL a Node from MSF");
      	term_menue->Append(SELECT_TERM_COLOUR, "&choose a COLOUR for Term");
    //  	term_menue->Append(SET_SCALE, "&set SCALE for MSF");
}
Flip_panel::~Flip_panel(void)
{	
  // all subwindows are automatically deleted
  //delete msf_win;
  //delete rule_how_much_menu;
  //delete rule_menue;
  //delete term_menue;
}


void Flip_panel::set_panel(wxPanel *panel, wxFrame *frame, int x, int y, int width, int heigth,
					wxFunction con_list_funct,
					wxFunction msf_funct,
					wxFunction imsf_funct,
					wxFunction term_box_funct)	// choose a term
{
     	panel->SetLabelPosition(wxVERTICAL);
	Flip_base_panel::set_panel(panel,350);

 	msf_CB 		= new wxCheckBox(panel,msf_funct, "show msf",10,30);	
  	i_msf_CB 	= new wxCheckBox(panel,imsf_funct, "show instantiated msf",100,30);
    	panel->NewLine();
    	panel->NewLine();
    	panel->NewLine();
     	panel->NewLine();
     	panel->NewLine();

    	winList 	= new wxListBox	(panel, con_list_funct,
					"constraints:",wxSINGLE,10,120,300,170);
	termBox 	= new TermListBox (panel,term_box_funct,"terms",350,120,150);
	rule_box 	= new rule_text_box(frame,0,420,width,180);
	rule_win_line 	= new wxMessage(panel,"",10,400);
}

Bool Flip_panel::Is_msf_on(void)
{
	return msf_CB->GetValue();
}

Bool Flip_panel::Is_i_msf_on(void)
{
	return i_msf_CB->GetValue();
}

void Flip_panel::set_rule_win_line(char* cv_name)
{
	char buf[200]; 
	//char *cv_name = Get_selected_var_name();
	if(if_show_all_rules())
		strcpy(buf,"all");
	else	if(cv_name)strcpy(buf,cv_name);
		else strcpy(buf,"? ");
	strcat(buf," rules:");
	rule_win_line->SetLabel(buf);
}

void Flip_panel::show_msf(CombinedVariable *sel_cv)
{
    Bool msf_on = FALSE;
    Bool i_msf_on = FALSE;
    if(i_msf_CB->GetValue() == TRUE)
	i_msf_on = i_msf_CB->GetValue(); 
    if(msf_CB->GetValue() == TRUE)
	msf_on = msf_CB->GetValue(); 

    if(sel_cv && (msf_on || i_msf_on)){
//	if(!msf_win) msf_win = new membership_fct_window(
//					sel_cv,
//					NULL,
//					sel_cv->get_cv_name());
	msf_win->show(	sel_cv,
			msf_on,i_msf_on,
			termBox->Get_term_no(),TRUE);
    } else if(msf_win) msf_win->Show(FALSE);
}


//---------------------------------------------------------------------------------------
//			 CLASS  Flip_base_window	 				-
//---------------------------------------------------------------------------------------

Flip_base_window::Flip_base_window(wxFrame *frame, char *title, 
				 	int x, int y, int w, int h, int type, char *def_path)
	:Window_def_file(frame, title,def_path, x, y, w ,h, type),
	Flip_panel()
{
	msf_win = new membership_fct_window(NULL,this,"");
 
	winList = NULL;
	rule_win_line = NULL;
	show_all_rules_ = FALSE;
      	menu_bar = new wxMenuBar;
      	rule_menue = new wxMenu;
       	child_file_menu = new wxMenu;
	rule_how_much_menu = new wxMenu;
     	term_menue = new wxMenu;
      	constraints_menue = new wxMenu;

	child_file_menu->Append(READ,"&Read");
	child_file_menu->Append(WRITE,"&Write");

      	rule_menue->Append(RULE_BLOCK_UPDATE, "&UPDATE edits");
      	rule_menue->Append(DUMMY_CASE, "&show how much rules", rule_how_much_menu);
      	rule_menue->Append(RULE_OUTPUT_STYLE, "&change output rule style");
      	rule_menue->Append(SET_OPERATOR, "&EDIT operator set");

	rule_how_much_menu->Append(RULE_SHOW_ALL,"&Show ALL rules");
	rule_how_much_menu->Append(RULE_SHOW_VAR,"&Show only rules for selected variable");


      	term_menue->Append(ADD_NODE, "&ADD a Node to MSF");
      	term_menue->Append(SET_VALUE,"&SET value of variable");
      	term_menue->Append(DELETE_NODE, "&DEL a Node from MSF");
      	term_menue->Append(SELECT_TERM_COLOUR, "&CHOOSE a Colour for Term");
}

Bool Flip_base_window::OnClose(void)
{
	if(msf_win) msf_win->Show(FALSE);
	Show(FALSE, TRUE);	// 2'nd arg is dummy
	if(msf_win->Close())
		return TRUE;
	else return FALSE;
}

void Flip_base_window::OnMenuCommand(int id)
{
    switch (id)
    {
    case RULE_OUTPUT_STYLE:
	if(rule_box->get_output_style()) rule_box->set_output_style(FALSE);
	else rule_box->set_output_style(TRUE);
	show_rules();
	break;
    case SET_OPERATOR:
	rule_box->set_operatorSet();
	break;
    case RULE_SHOW_VAR:
	show_all_rules_ = FALSE;
	show_rules();	
	break;
    case RULE_SHOW_ALL:
	show_all_rules_ = TRUE;
	show_rules();	
	break;
    case RULE_BLOCK_UPDATE:
	SetStatusText("");
	char status[150]; strcpy(status,"");
	if(rule_box->update_rule_block(status,show_all_rules_)){
		SetStatusText("ruleblock updated");
		show_rules();
	}
	else 
		SetStatusText(status);
	break;
    case READ: 
	if(read())
		update_main_win();		
	break;
    case WRITE: 
	if(write())
		update_main_win();		
	break;
    case ADD_NODE:
	SetStatusText("select the position in the msf-window by pressing the left mouse button");
	msf_win->canvas->setMode(M_NEW_NODE);
	break;
    case SET_VALUE: //flip_gplot change
	SetStatusText("select the value in the msf-window by pressing the right mouse button");
	msf_win->canvas->setMode(M_SET_VALUE);
	msf_win->canvas->SetStatusText("set a value (right mouse button)");
	break;
    case DELETE_NODE:
	SetStatusText("select the node in the msf-window to delete it");
	msf_win->canvas->setMode(M_DELETE_NODE);
	break;
    case SELECT_TERM_COLOUR:
	{
	SetStatusText("");
	CombinedVariable *sel_cv = Get_selected_cv();
	int term_no = termBox->Get_term_no();
	colourtype new_colour;
	Bool is_ok;
	if(sel_cv&&term_no>-1){
		ChoiceColourWin(this,*(sel_cv->find(term_no))->get_fs_colour(),
				&new_colour, &is_ok);
		if(is_ok)
			(sel_cv->find(term_no))->set_fs_colour(new_colour);
	}
	}
	break;
    case SET_SCALE:
	SetStatusText("");
	msf_win->set_msf_scale();
	break;
    }
}

void Flip_base_window::set_panel(int x, int y, int width, int heigth, 
					wxFunction con_list_funct,
					wxFunction msf_funct,
					wxFunction imsf_funct,
					wxFunction term_box_funct)	// choose a term
{
     	//childpanel = new wxPanel(this, x, y, width, heigth-100, wxBORDER);
     	childpanel->SetLabelPosition(wxVERTICAL);
	Flip_panel::set_panel(childpanel, this, x, y, width, heigth, 
			       con_list_funct, msf_funct, imsf_funct, term_box_funct);
    	winList->SetLabel("constraints:");	// (10,100,300);
}



void 	Flip_base_window::show(void)
{
	show_sel_var();		// show selected constraint (in ConstraintListBox)
	rule_box->Clear();
	show_rules();		// update rules
}

void 	Flip_base_window::show_rules(void)
{
    char status[300]; strcpy(status,"");
    set_rule_win_line(Get_selected_var_name());
    if(if_show_all_rules()){
	rule_box->show_rules(get_rules(), status);
    }
    else {
	char *name_ptr = Get_selected_var_name();
	if(name_ptr)
		rule_box->show_rules(get_rules(), name_ptr, status);
    }
    SetStatusText(status);
}

void 	Flip_base_window::autom_rule_update(void)
{
	if(!if_show_all_rules()){
		char status[150]; strcpy(status,"");
		if(!rule_box->update_rule_block(status),!if_show_all_rules())
			SetStatusText(status);
		else SetStatusText("Rules updated");
	}
}

void 	Flip_base_window::update_comment(void)
{}

void Flip_base_window::get_extension(char* ext_name)
{
	strcpy((char*)ext_name, "");  // virtual fct
}
void Flip_base_window::clear(void)
{
	rule_box->Clear();
	Clear_info_panel();
	termBox->Clear();
	msf_CB->SetValue(FALSE);
	i_msf_CB->SetValue(FALSE);
	if(msf_win) msf_win->Show(FALSE);
	winList->Clear();
}
/*
void Flip_base_window::set_rule_win_line(void)
{
    char buf[200]; 
    CombinedVariable*cv_ptr = Get_selected_cv();
    if(cv_ptr){
    	char *cv_name = cv_ptr->get_cv_name();;
	if(if_show_all_rules())
		strcpy(buf,"all");
	else	if(cv_name)strcpy(buf,cv_name);
		else strcpy(buf,"");
	strcat(buf," rules:");
    } else strcpy(buf,"no rules");
    rule_win_line->SetLabel(buf);
}
*/
Bool Flip_base_window::read(void)
{
	char extension[100]; get_extension(extension);
	char *file_name_ptr = wxFileSelector("Chose a file to read",get_dir(),0,0,(char*)extension);
	Bool ok = FALSE;
	if(file_name_ptr) // if "OK" button pressed
	{
		set_path(file_name_ptr);
		ok = read(file_name_ptr); 
		if(ok){	
			clear();
			update_win_name(get_data_name());
			set_info_name_list();
			show();
			update_subwindows();
			SetStatusText("read ok");
			Show(TRUE,TRUE);	// 2'nd arg is dummy
		}
	}
	else 	SetStatusText("read error");
	return ok;
}

Bool Flip_base_window::write(void)
{
	Bool ok = FALSE;
	name extension; get_extension(extension);
	char *file = wxFileSelector("Chose a file to write",get_dir(),NULL,NULL,(char*)extension);
	if(file) // if "OK" button pressed in wxGetTextFromUser
	{
		set_path(file);
		ok = write(file);
		if(ok) update_win_name(get_data_name());
		SetStatusText("");
	}
	else 	SetStatusText("write error");
	return ok;
}
// virtual functions
Bool Flip_base_window::read(char *file_name) // load SetOfConstraints object
{
	return FALSE;
}

Bool Flip_base_window::write(char *file_name) // save SetOfConstraints object
{
	return FALSE;
}

void Flip_base_window::update_subwindows(void)
{
	if(msf_win) show_msf();
}
int Flip_base_window::GetSelection(void)
{
	return (winList->GetSelection())+1;
}

void Flip_base_window::update_win_name(char *soc_name)
{
    if(soc_name){
	char buf[50];
	strcpy(buf,"set of constraint  ");
	strcat(buf,soc_name);
	if(get_file_name()){
		strcat(buf," (");
		strcat(buf,get_file_name());
		strcat(buf,")");
	}
	SetTitle(buf);
     }
}



/*
Bool Flip_base_window::Is_msf_on(void)
{
	return msf_CB->GetValue();
}
Bool Flip_base_window::Is_i_msf_on(void)
{
	return i_msf_CB->GetValue();
}
*/
void Flip_base_window::set_info_name_list(void)
{
	winList->Clear();	// void fkt
}
RuleSet* Flip_base_window::get_rules(void)
{
	return NULL;	// virtual fct
}
void 	Flip_base_window::show_sel_var(void)
{
	termBox->Clear();
	CombinedVariable *sel_cv =  Get_selected_cv();
	if(sel_cv)
	{
		termBox->set(sel_cv);
		show_msf();
	}
}

CombinedVariable* Flip_base_window::Get_selected_cv(void)
{
	return NULL; // virtual fct 
}
char *Flip_base_window::get_data_name(void)
{
	return NULL;	// virtual fct
}

void Flip_base_window::show_msf(void)
{
	Flip_panel::show_msf(Get_selected_cv());
/*
    Bool msf_on = FALSE;
    Bool i_msf_on = FALSE;
    if(i_msf_CB->GetValue() == TRUE)
	i_msf_on = i_msf_CB->GetValue(); 
    if(msf_CB->GetValue() == TRUE)
	msf_on = msf_CB->GetValue(); 

    if(msf_on || i_msf_on){
	if(!msf_win) msf_win = new membership_fct_window(
					Get_selected_cv(),
					this,
					get_data_name());
	msf_win->show(	Get_selected_cv(),
			msf_on,i_msf_on,
			termBox->Get_term_no(),TRUE);
    } else if(msf_win) msf_win->Show(FALSE);
*/
}



//---------------------------------------------------------------------------------------
//			 CLASS  Flip_window	 				-
//---------------------------------------------------------------------------------------

Flip_window::Flip_window(wxFrame *frame, char *title, 
				 	int x, int y, int w, int h, int type, char *def_path)
	:Flip_base_window(frame, title, x, y, w ,h, type, def_path)
{
	rs_base_ = new RuleSet();
	PSList_Win_ = new PSList_window(this,"parameter list",def_path);
	PSList_Win_->Show(FALSE,TRUE);	// 2`nd arg is dummy
	PSList_Win_->set(rs_base_->get_ps_list());
      	constraints_menue = new wxMenu;
      	help_menue = new wxMenu;
       	child_file_menu = new wxMenu;

	help_menue->Append(HELP_HELP_CONTENTS,"&Help");

  //	SetSize(100,80,600,700);
	SetSize(x, y, w, h);

      	// Give it an icon
//      	icon = new wxIcon("flip_icn");
//      	frame->SetIcon(icon);

   	// Make a menubar
      	wxMenuBar *menu_bar = new wxMenuBar;
      	child_file_menu->Append(READ, "&READ");
      	child_file_menu->Append(WRITE, "&WRITE");
	child_file_menu->Append(QUIT,"&QUIT");

     	constraints_menue->Append	(ADD, "&ADD variable");
     	constraints_menue->Append	(EDIT, "&EDIT variable name");
     	constraints_menue->Append	(INF_DELETE, "&DELETE");
					// be careful with deletation !! :
					// (does invoke other constraint delatations
					//	and rule set changes ??
					// 		error possible!! )

        menu_bar->Append(child_file_menu,"&file"); 
        menu_bar->Append(constraints_menue,"&variables");
      	menu_bar->Append(term_menue,"&terms/msf");
      	menu_bar->Append(rule_menue,"&rules");
        //menu_bar->Append(help_menue,"&Help");
    	SetMenuBar(menu_bar);     	// Make a menubar

     	// Make a panel 
     	childpanel = new wxPanel(this, 0,0,(w*3)/2,420, wxBORDER);
	Flip_panel::set_panel(childpanel, this,0,0,w,h,
			(wxFunction)&flip_win_refresh_proc,
			(wxFunction)&flip_msf_show,		// show membership fct()
			(wxFunction)&flip_msf_show,		// show instantiated ms fct()
			(wxFunction)&flip_term);		// choose a term

  	pl_check_ = new wxCheckBox(childpanel,(wxFunction)&flip_plist_funct, "show parameter list",10,50);

     	(void*)new wxButton(childpanel, (wxFunction)& flip_EVAL_proc, "EVALUATE",300,1);
	(void*)new wxButton(childpanel, (wxFunction)& flip_gplotEVAL_proc, "gplot EVALUATE",380,1);  // flip_gplot
     	childpanel->NewLine();
  	childpanel->NewLine();

	#ifndef NOGNUPLOT
	gplot_win = new FrameFlipGplot(this, "evaluate list of values", 129, 352, 564, 563, wxDEFAULT_FRAME, "frame5");
	#endif

	Show(TRUE,TRUE); 	// 2'nd arg is dummy
}

Flip_window::~Flip_window(void)
{
  //all subwindows are automatically deleted!;
  delete rs_base_;  rs_base_ = NULL;
}

Bool Flip_window::OnClose(void)
{
  //	orig:delete this; return TRUE;
  Show(FALSE,TRUE);
  return TRUE;
}

Bool Flip_window::edit(void) 
{
    CombinedVariable *sel_cv = Get_selected_cv();
    if(sel_cv){
	name var_name; 
	wxDialogBox *panel = new wxDialogBox(this,"edit variable name", TRUE, 40, 40, 500, 160);
  	panel->NewLine();
  	wxText *info_name  = new wxText(panel, NULL, "name", sel_cv->get_cv_name(), -1, -1, 250);

 	wxButton *ok_button = new wxButton(panel, (wxFunction)&Flip_DialogOkButton, "OK");
  	wxButton *cancel_button = new wxButton(panel, (wxFunction)&Flip_DialogCancelButton, "Cancel");
  	panel->NewLine();
  	ok_button->SetDefault();
  	cancel_button->SetDefault();
	Flip_DialogButtonPressed = 0; // a global variable
  	panel->Fit();
  	panel->Centre();
  	panel->Show(TRUE);
	if(Flip_DialogButtonPressed)
	{
		strncpy(var_name,info_name->GetValue(),NAME_LENGTH);
		if(strlen(var_name)>0){
			sel_cv->set_cv_name(var_name);
			return TRUE;
		}
	}
    }
    return FALSE;
}

Bool Flip_window::add(void) 
{
	// open window to add variable to ruleSet
	//	input: 	cv name
	//		select parameter set
	name ps_name; 
	ParameterSet *ps;
	if(!rs_base_  || !rs_base_->get_ps_list() || rs_base_->get_ps_list()->get_number()==0){
		print2errWin("parameter set list is empty! (add a parameter set to the list first)");
		return FALSE;
	}

	wxDialogBox *panel = new wxDialogBox(this,"add new variable", TRUE, 40, 40, 500, 160);
  	panel->NewLine();
  	wxText *info_name  = new wxText(panel, NULL, "name", "", -1, -1, 250);
  	panel->NewLine();
	ChoiceParameterList* pl_choice = new ChoiceParameterList(rs_base_->get_ps_list(),
						panel,NULL,"parameter list");
	//pl_choice->Set_ps(rs_base_->get_ps_list());


 	wxButton *ok_button = new wxButton(panel, (wxFunction)&Flip_DialogOkButton, "OK");
  	wxButton *cancel_button = new wxButton(panel, (wxFunction)&Flip_DialogCancelButton, "Cancel");
  	panel->NewLine();
  	ok_button->SetDefault();
  	cancel_button->SetDefault();

	do {
		Flip_DialogButtonPressed = 0; // a global variable

  		panel->Fit();
  		panel->Centre();
  		panel->Show(TRUE);
		if(Flip_DialogButtonPressed)
		{
			strncpy(ps_name,info_name->GetValue(),NAME_LENGTH);
			ps = pl_choice->Get_ps();
			if(ps && ps_name){
				CombinedVariable *new_cv = new CombinedVariable(ps, ps_name);
				rs_base_->get_cv_list()->add(new_cv);
				return TRUE;
			}
			if(!ps) print2errWin("input name");
			if(!ps_name) print2errWin("internal error: cannot read Parameter set");
		}
	} while(Flip_DialogButtonPressed && (ps == NULL || ps_name == NULL));
	return FALSE;
}

void  Flip_window::get_extension	(char* ext_name)
{
 	strcpy((char*)ext_name, rule_extension_);
}


Bool Flip_window::read(char *file_name)
{
	ifstream infile;
	infile.open (file_name, ios::in);
	if (infile.is_open()) 
	{ 
		if(rs_base_) delete rs_base_;

		rs_base_ = new RuleSet();
		if(rs_base_->read(&infile) != 1)
			flip_error.show();
		else {
			show();
			update_win_name("FLIP++");
			PSList_Win_->set(rs_base_->get_ps_list());
			PSList_Win_->set_param_box();
			PSList_Win_->show();
			SetStatusText("read ok");
			return TRUE;
		}
	}
	else flip_error.show(Stream_Error);
   	return FALSE;
}

Bool Flip_window::write(char *file_name)
{
      	ofstream outfile;
	outfile.open (file_name);
	if (outfile.is_open()) 
	{ 
		if(rs_base_)
			if(rs_base_->write(&outfile)){
				update_win_name("FLIP++");
				SetStatusText("wrote data to file");
				return TRUE;
			}
			else 	flip_error.show();
	}
	else flip_error.show(Stream_Error);
	return FALSE;
}

void Flip_window::OnMenuCommand(int id)
{	
   SetStatusText("");
   Flip_base_window::OnMenuCommand(id);
   switch (id)
    {
    case QUIT:
      {	
	this->Close();
	break;
      }
    case ADD:
      {
	SetStatusText("add ..");
	if(add()){
	  set_info_name_list(); 
	  winList->SetSelection(winList->Number()-1);
	  show(); 
	}
	SetStatusText("");
	break;
      }
    case EDIT:
      {
	SetStatusText("edit ..");
	int var_no = winList->GetSelection();
	if(edit()){
	  set_info_name_list();
	  winList->SetSelection(var_no);
	  show();
	}
	SetStatusText("");
	break;
      }
    case INF_DELETE:
      {
	SetStatusText("delete ..");
	deleteSelectedInfo();
	int var_no = winList->GetSelection();
	set_info_name_list();
	if(var_no>0) winList->SetSelection(var_no-1);
	show();
	break;
      }
    case HELP_HELP_CONTENTS:
      {
	// not yet implemented
	break;
      }
    }
}


int Flip_window::GetVarNo(void)
{
	CVList *cv_list = rs_base_->get_cv_list();
	if(cv_list) return cv_list->get_number();
	return 0;
}

void Flip_window::set_info_name_list(void)
{
	Flip_base_panel::set_info_name_list(winList, rs_base_->get_cv_list());
}

void 	Flip_window::show(void)
{
	show_sel_var();
	show_rules();
}

void 	Flip_window::show_sel_var(void)
{
	Flip_base_window::show_sel_var();
	CombinedVariable *constraint = Get_selected_cv();
	set_info(constraint);
//	termBox->set(constraint);
}

void 	Flip_window::deleteSelectedInfo(void)
{
	char *name = Get_selected_var_name();
	CombinedVariable *cv_ptr;
	if(name && rs_base_ && rs_base_->get_cv_list()){
		CVList *list = rs_base_->get_cv_list();
		cv_ptr = list->find_cv(name);
		//int cv_no = list->find_cv_by_pointer(
		//			list->find_cv(name));
		if(cv_ptr)
			rs_base_->remove_cv_and_its_approaches(cv_ptr);
	}
}

char* Flip_window::Get_selected_var_name(void)
{
	CombinedVariable *cv = Get_selected_cv();
	if(cv) return cv->get_cv_name();
	return NULL;
}

int Flip_window::GetSelection(void)
{
	return (winList->GetSelection());
}

Bool	Flip_window::data_not_empty	(void) // TRUE if soc_data is empty
{
	if(rs_base_->get_cv_list()!=NULL &&
		rs_base_->get_cv_list()->get_number()>0)
			return TRUE;
	return FALSE;
}


CombinedVariable* Flip_window::Get_selected_cv(void)
{
	int cv_no = GetSelection();
	if(cv_no > -1){
		return rs_base_->get_cv_list()->find(cv_no);
	}
	return NULL;
}


void Flip_window::update_win_name(char *soc_name)
{
	char buf[150];
	if(soc_name)
		strcpy(buf,soc_name);
	else strcpy(buf,"FLIP++");
	if(get_file_name()){
		strcat(buf," (");
		strcat(buf,get_file_name());
		strcat(buf,")");
	}
	SetTitle(buf);
}


void Flip_window::evaluate(void)
{	
	if(data_not_empty())
	{
		//char buf[100];
		//char certainty_string[NUMBER_STR_LEN];
		CombinedVariable *sel_cv_ptr = Get_selected_cv();
		if(sel_cv_ptr)
		{
			float eval_val = rs_base_->evaluate(sel_cv_ptr);
			//strcpy(buf,"evaluated value is   ");	strcat(buf,nr2str(eval_val,certainty_string,NUMBER_STR_LEN));
			//eval_value_mess->SetLabel(buf);
			Flip_base_panel::set_info(sel_cv_ptr);
			Flip_panel::show_msf(sel_cv_ptr);
		}
		else {
			wxMessageBox("no evaluation","no variable to evaluate selected");
			SetStatusText("no evaluation");
		}
	}
}
void	Flip_window::show_ps_list(Bool do_show)
{
	PSList_Win_->Show(do_show,TRUE );  // 2'nd arg is dummy
}

void	Flip_window::listbox_callback(void)
{
   Bool update_error = FALSE;
   // autom. update:
   if(!if_show_all_rules()){
	char status[150]; strcpy(status,"");
	if(!rule_box->update_rule_block(status,if_show_all_rules()))
		{SetStatusText(status); update_error = TRUE;}
	else {SetStatusText("Rules updated"); }
   }
   if(!update_error) {
	show_sel_var();
	if(!if_show_all_rules()) show_rules();
	if(msf_win)
		msf_win->show(Get_selected_cv(),Is_msf_on(),Is_i_msf_on(),
				termBox->Get_term_no());
   } else {SetStatusText("Rules NOT updated"); }
}

//	====================================
// 	C A L L B A C K    F U N C T I O N s
//	====================================

void flip_term	(TermListBox& box, wxCommandEvent&)
{
	Flip_window *win = (Flip_window*)box.GetGrandParent();
	win->Flip_panel::show_msf(win->Get_selected_cv());
}
void flip_msf_show	(wxCheckBox& box, wxCommandEvent&)
{
   	Flip_window *win = (Flip_window *)box.GetGrandParent();
	win->Flip_panel::show_msf(win->Get_selected_cv());
}

void flip_plist_funct	(wxCheckBox& box, wxCommandEvent&)
{
   	Flip_window *win = (Flip_window *)box.GetGrandParent();
	win->show_ps_list(box.GetValue());
}


void flip_win_refresh_proc (wxListBox& list, wxCommandEvent&)
// CALLBACK function invoced, when info listbox changed
// used to get compare info name for "add a concat-info" input:
{
   Flip_window *win = (Flip_window *)list.GetGrandParent();
   win->listbox_callback();
}

void flip_EVAL_proc(wxButton& button, wxCommandEvent&)
	// evaluate a constrant
{
 	Flip_window *win = (Flip_window *)button.GetGrandParent();
	win->evaluate();
}

void flip_gplotEVAL_proc(wxButton& button, wxCommandEvent&)  //flip_gplot
	// evaluate a list of values for gplot
{	
   #ifdef  NOGNUPLOT
	wxMessageBox("Sorry, but gnuplot and ghostview are not available.");		
   #else
 	Flip_window *win = (Flip_window *)button.GetGrandParent();
	if(win->data_not_empty())
		win->show_gplotWin(win->get_rules());
	else wxMessageBox("sorry, but there is no data to evaluate .. ");
   #endif
}






/************************************************************************
*			flip_error_t		 			*
*************************************************************************/
flip_error_t::flip_error_t(char *global_flip_error_string)
{
	global_flip_error_string_ = global_flip_error_string;
	clear();
}

void flip_error_t::show()
{
	if(strcmp(global_flip_error_string_,"")!=0)
		wxMessageBox(global_flip_error_string_,"FLIP++ error");
}

void flip_error_t::show(flip_error_typ flip_err_no)
{
    char err_str[300]; strcmp(err_str,"");
    switch(flip_err_no){
	case NO_Error:
		strcat(err_str,"no error");
		break;
	case Stream_Error:
		strcat(err_str,"cannot open selected file");
		break;
    }
    wxMessageBox(err_str,"FLIP++ error");
}

void flip_error_t::clear(void)
{
	strcpy(global_flip_error_string_,"");
}


/*****************************************************************************
*			class flip_op_fuzzy_Box				     *
******************************************************************************/



flip_op_fuzzy_Box::flip_op_fuzzy_Box(wxPanel *panel, wxFunction func, char *Title,
				int x,int y,int width, int height)
			:wxListBox(panel,func,Title,wxSINGLE,x,y,width,height)
{
	Append("minimum");
	Append("maximum");
	Append("fuzzy_and");
	Append("fuzzy_or");
	Append("ass_comp_and");
	Append("ass_comp_or");
	Append("NO_OP");
}

void flip_op_fuzzy_Box::Set(fuzzy_operator op)
{
    switch(op){
	case minimum:
		SetSelection(0); break;
	case maximum:
		SetSelection(1); break;
	case fuzzy_and:
		SetSelection(2); break;
	case fuzzy_or:
		SetSelection(3); break;
	case ass_comp_and:
		SetSelection(4); break;
	case ass_comp_or:
		SetSelection(5); break;
	default: SetSelection(6);
    }
}

fuzzy_operator flip_op_fuzzy_Box::Get(void)
{
    switch(GetSelection())
    {
	case 0: 
		return minimum;
	case 1: 
		return maximum;
	case 2: 
		return fuzzy_and;
	case 3: 
		return fuzzy_or;
	case 4: 
		return ass_comp_and;
	case 5: 
		return ass_comp_or;
	default: return no_fop;
    }
}

/*****************************************************************************
*			class flip_defuzz_op_Box			     *
******************************************************************************/



flip_defuzz_op_Box::flip_defuzz_op_Box(wxPanel *panel, wxFunction func, char *Title,
				       int x,int y,int width, int h)
			:wxListBox(panel,func,Title,wxSINGLE,x,y,width,h)
{
	Append("cog");
	Append("NO_OP");
}

void flip_defuzz_op_Box::Set(defuzzification_operator op)
{
    switch(op){
	case cog:
		SetSelection(0); break;
	default: SetSelection(1);
    }
}

defuzzification_operator flip_defuzz_op_Box::Get(void)
{
    switch(GetSelection())
    {
	case 0: 
		return cog;
	default: return no_dfop;
    }
}



/*****************************************************************************
*			class flip_concat_op_Box			     *
******************************************************************************/



flip_concat_op_Box::flip_concat_op_Box(wxPanel *panel, wxFunction func, char *Title, 
					int x,int y,int width, int h)
			:wxListBox(panel,func,Title,wxSINGLE,x,y,width,h)
{
	Append("c_and");
	Append("c_or");
	Append("AND");
	Append("OR");
	Append("NO_OP");
}

void flip_concat_op_Box::Set(concat_operator op)
{
    switch(op){
	case c_and:
		SetSelection(0); break;
	case c_or:
		SetSelection(1); break;
	case AND:
		SetSelection(2); break;
	case OR:
		SetSelection(3); break;
	default: SetSelection(4);
    }
}

concat_operator flip_concat_op_Box::Get(void)
{
    switch(GetSelection())
    {
	case 0: 
		return c_and;
	case 1: 
		return c_or;
	case 2: 
		return AND;
	case 3: 
		return OR;
	default: return no_cop;
    }
}



/******************************************************************************
*				 operator functions			      *
*******************************************************************************/


Bool string2fuzzy_operator(char *string, fuzzy_operator *op)
{
	if(string == NULL) return FALSE;
	char lower_string[100]; strncpy(lower_string,string,99);
	strToLower(lower_string);
	if(strcmp(lower_string, "and")==0)
		{*op =  minimum; return TRUE;}
	if(strcmp(lower_string, "or")==0)
		{*op =   maximum; return TRUE;}

	if(strcmp(lower_string, "f_and")==0)
		{*op =   fuzzy_and; return TRUE;}
	if(strcmp(lower_string, "f_or")==0)
		{*op =   fuzzy_or; return TRUE;}

	if(strcmp(lower_string, "a_and")==0)
		{*op =   ass_comp_and; return TRUE;}
	if(strcmp(lower_string, "a_or")==0)
		{*op =   ass_comp_or; return TRUE;}

	*op =   no_fop; return FALSE;
}

Bool string2concat_operator(char *string, concat_operator *op)
{
	if(string == NULL) return FALSE;
	char lower_string[100]; strncpy(lower_string,string,99);
	strToLower(lower_string);
	if(strcmp(lower_string, "and")==0)
		{*op =  AND; return TRUE;}
	if(strcmp(lower_string, "or")==0)
		{*op =   OR; return TRUE;}

	if(strcmp(lower_string, "c_and")==0)
		{*op =   c_and; return TRUE;}
	if(strcmp(lower_string, "c_or")==0)
		{*op =   c_or; return TRUE;}

	*op =   no_cop; return FALSE;
}

Bool is_concat_operator(char *token)
{
	concat_operator op;
	return string2concat_operator(token,&op);
}
Bool is_fuzzy_operator(char *token)
{
	fuzzy_operator op;
	return string2fuzzy_operator(token,&op);
}

Bool fuzzy_operator2string(fuzzy_operator op, char* op_str)
{
	switch(op){
		case minimum: strcpy(op_str, "and"); return TRUE;
		case maximum: strcpy(op_str, "or");  return TRUE;
		case fuzzy_and: strcpy(op_str, "f_and");  return TRUE;
		case fuzzy_or: strcpy(op_str, "f_or");  return TRUE;
		case ass_comp_and: strcpy(op_str, "a_and");  return TRUE;
		case ass_comp_or: strcpy(op_str, "a_or");  return TRUE;
		default : strcpy(op_str, "NO_OPERATOR"); return FALSE;
	}
}

Bool concat_operator2string(concat_operator op, char* op_str)
{
	switch(op){
		case c_and: strcpy(op_str, "c_and"); return TRUE; 
		case c_or: strcpy(op_str, "c_or"); return TRUE; 
		case AND: strcpy(op_str, "and"); return TRUE; 
		case OR: strcpy(op_str, "or");  return TRUE; 
		default : strcpy(op_str, "NO_OPERATOR"); return FALSE;
	}
}




/******************************************************************************
*				 miscellaneous functions		      *
*******************************************************************************/



// error messages





void Set_choice_value(CombinedVariable*cv, wxChoice *choiceBox)
{
	for(int i=0;i<cv->get_number();i++)
		choiceBox->Append((char*)(cv->get_names_of_vars())->find(i));
}

void Set_choice_value(char *act_name, CombinedVariable*cv, wxChoice *choiceBox)
{
	for(int i=0;i<cv->get_number();i++)
		if(strcmp((char*)(cv->get_names_of_vars())->find(i),act_name)==0)
		{
			choiceBox->SetSelection(i);
			break;
		}
}


char* Get_choice_value(CombinedVariable *cv, wxChoice *choiceBox)
{
	int sel_val = choiceBox->GetSelection();
	if(sel_val>-1)
		return (char*)(cv->get_names_of_vars())->find(sel_val);
	return NULL;
}


void Flip_DialogOkButton(wxButton& but, wxEvent&)  
{
  wxDialogBox *dialog = (wxDialogBox *)but.GetParent();
  Flip_DialogButtonPressed = 1;
  dialog->Show(FALSE);
}

void Flip_DialogCancelButton(wxButton& but, wxEvent&)  
{
  wxDialogBox *dialog = (wxDialogBox *)but.GetParent();
  Flip_DialogButtonPressed = 0;
  dialog->Show(FALSE);
}






void print2errWin(char* errortext,char *header)
{
	wxMessageBox(errortext,header);
}

char *strToLower(char *string_)
{
	for (unsigned int no = 0; no<strlen(string_); no++)
		string_[no] = wxToLower(string_[no]);
	return string_;
}


double convert_string2float(char* strNumber)
{
	return atof(strNumber);
}

/*
Bool IsNumber(char c)
{
	if (c=='1'||c=='0') return TRUE;
	if (c=='2') return TRUE;
	if (c=='3') return TRUE;
	if (c=='4') return TRUE;
	if (c=='5') return TRUE;
	if (c=='6') return TRUE;
	if (c=='7'||c=='+') return TRUE;
	if (c=='8'||c=='-') return TRUE;
	if (c=='9'||c=='.') return TRUE;
	return FALSE;
}
*/

Bool convert_string2float(char* strNumber,float *value)
{
	StringToFloat(strNumber, value); 	//in wx_utils.h
	return TRUE;
}




// convert a double to string:
char *nr2str(const double number, char *ret_string, const int strlen)
{
	sprintf(ret_string,"%g",number);
	return ret_string;
};

char *nr2str(const float number, char *ret_string, const int strlen)
{
	sprintf(ret_string,"%g",(double)number);
	return ret_string;
};

char *nr2str(const int number, char *ret_string, const int strlen)
{
	return nr2str((double)number,ret_string,strlen);
};


