/************************************************************************
 * This library is free software; you can redistribute it and/or	*
 * modify it under the terms of the GNU Library General Public		*
 * License as published by the Free Software Foundation; either		*
 * version 2 of the License, or (at your option) any later version.	*
 * 									*
 * This library is distributed in the hope that it will be useful,	*
 * but WITHOUT ANY WARRANTY; without even the implied warranty of	*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU	*
 * Library General Public License for more details.			*
 * 									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the		*
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,		*
 * Boston, MA  02111-1307, USA.						*
 * 									*
 * The GNU Library General Public License file is included in		*
 * Online-Documentation							*
 *									*
 * GNU's Homepage - http://www.gnu.ai.mit.edu/home.html			*
 *									*
 * Questions & comments referring to *FLIP++: please contact us:	*
 *									*
 * Snail-Mail:								*
 *	Dr. Wolfgang SLANY						*
 *	Database and Expert System Group (E184-2)     			*
 *	Institute of Information Systems               			*
 *	Vienna University of Technology					*
 *	Paniglgasse 16, A-1040 Vienna, AUSTRIA				*
 * Telephone:								*
 *	+43-1-58801-6123     (area-code 1 maybe changed to 201 in 1998) *
 * FAX:									*
 *	+43-1-5055304	     (area-code 1 maybe changed to 201 in 1998) *
 * eMail:								*
 *	sflip@dbai.tuwien.ac.at						*
 * WWW:									*
 *	http://www.dbai.tuwien.ac.at/proj/StarFLIP/			*
 *                                                                      *
 * $Id: FLIPUI.h,v 1.6 1997/07/03 00:08:50 mayer Exp $ *
 ***********************************************************************/

// ------------------------------------------------------
//  modul       ?       FLIP++UI.h                       |
// ------------------------------------------------------
//  project     ?       I n t e r F L I P + +            |
// ------------------------------------------------------
//  by whom     ?       Stefan Mayer                     |
//  with whom   ?       Wolfgang Slany                   |
//  when        ?       1994/1995                        |
//  what        ?       userinterface  for FLIP++        |
//  how         ?       C++                              |
// ------------------------------------------------------
// classes	?					
//							
// 	user interface 	for FLIP++			
//							
//							
//		MyWin					
//		Window_1				
//		Window_def_file				
//		point_float				
//							
//		Rule_listBox				
//			rule_segments			
//			rule_data_list			
//			rule_dyn_data			
//		rule_text_box				
//							
//		ChoiceParameterList			
//		Parameter_Win				
//		PSList_window_base			
//		PSList_window				
//							
//		membership_fct_window			
//		fuzzy_set_canvas			
//							
//		colour_choice_box			
//		CVListBox				
//		TermListBox				
//		op_set_window				
//							
//		cv_base_panel				
//		Flip_base_panel				
//		Flip_window				
//------------------------------------------------------------

#include "wx_help.h"
#include "wx.h"
#include "wx_utils.h"
#include "wxstring.h"

#ifdef WIN32
// define NOGNUPLOT if ghostview and gnuplot are not available for MSWindows
// modify makefile.g95 if NOGNUPLOT is changed!
#define NOGNUPLOT 1
#endif

#ifndef NOGNUPLOT
#include "f_gplot.h"
#endif

extern char error[100];

class App_Flip: public wxApp
{
  public:
    	wxFrame 		*OnInit(void);
};



class MyWin: public wxFrame		// subwindow definition
{
protected:
    Bool	if_delete_is_ok_;
 //   char	_default_path[100];
public:
    wxPanel 	*childpanel;
    wxMenuBar	*menu_bar;
    wxIcon	*icon;
    		MyWin		(wxFrame *frame, char *title, 
				 int x, int y, int w, int h, int type=wxDEFAULT_FRAME,
				 Bool if_delete_is_ok_flag=FALSE);
    		~MyWin		(void);
    void 	openWindow	(Bool do_open_win = TRUE);
    void	delete_is_ok	(Bool boo=TRUE);
    Bool 	OnClose		(void);
};
//----------------------------------------------------------------------------
//			class Window_1					     -
//----------------------------------------------------------------------------

enum active_type { not_active,active,iconized};


class Window_1: public MyWin		// subwindow definition
{
  protected:
  public:
    //wxPanel 	*childpanel;
    wxMenu	*child_file_menu;
    //wxMenuBar	*menu_bar;
    wxMessage	*info_message;		// information message
    //wxIcon	*icon;
    active_type is_active;

    		Window_1			(wxFrame *frame, char *title, 
				 	int x, int y, int w, int h, int type=wxDEFAULT_FRAME);
    		~Window_1		(void);
    void	OnKillFocus		(void);
    void	Show(Bool,Bool);		// 2`nd Boolean only for non-overiding definition with `int wxbWindow::Show(int)'
    virtual void OnMenuCommand		(int id);
    void 	MakeWin_with_list	(void);
    //void 	openWindow();
};




//----------------------------------------------------------------------------
//			class Window_def_file				     -
//----------------------------------------------------------------------------
class Window_def_file: public Window_1
{
  protected:
	char 	default_dir_[100];
	char 	fileName_[100];
  public:
		Window_def_file		(wxFrame *frame, char *title, char *default_path,
				 	int x, int y, int w, int h, int type=wxDEFAULT_FRAME);
					// default_path have to be global or dynamic
	void	set_dir			(char *);
	void	set_path		(char *);
	void	set_dir			(void);		// input window
	char	*get_dir		(void);
	char	*get_file_name		(void);
	virtual void show		(void); // to initiate a refresh show 
};


/*****************************************************************************
*			class point_float				     *
******************************************************************************/
class point_float
{
protected:
	float x_;
	float y_;
public:
		point_float	(void);
		point_float	(float x, float y);
  float		get_x		(void);
  float		get_y		(void);
  void		set_x		(float x);
  void		set_y		(float y);
  void		set		(float x,float y);
};


//**********************************************************************//
//		colour_choice_box, a choice box to choose a color	//
//**********************************************************************//

class colour_choice_box: public wxChoice
{
   public:
			colour_choice_box	(wxPanel *, wxFunction, char *,
						 int x=-1,int y=-1);
    colourtype		Get_colour		(void);	
    void		Set_colour		(colourtype);
};

//----------------------------------------------------------------------------
//			class ChoiceColourWin				     -
//----------------------------------------------------------------------------

class ChoiceColourWin: public wxDialogBox
{
public:
			ChoiceColourWin		(wxWindow *,
						 colourtype old_colour, 
						 colourtype *new_colour,
						 Bool *is_ok);

};



/*****************************************************************************
*			class flip_op_fuzzy_Box				     *
******************************************************************************/

class flip_op_fuzzy_Box: public wxListBox
{
   public:
			flip_op_fuzzy_Box	(wxPanel *, wxFunction, char *,
						int x=-1,int y=-1,
						int width = -1,int height =-1);
    void		Set			(fuzzy_operator = no_fop);
    fuzzy_operator	Get			(void);	

};

/*****************************************************************************
*			class flip_defuzz_op_Box			     *
******************************************************************************/

class flip_defuzz_op_Box: public wxListBox
{
   public:
			flip_defuzz_op_Box	(wxPanel *, wxFunction, char *,
						int x=-1,int y=-1,
						int width = -1, int h = -1);
    void		Set			(defuzzification_operator = no_dfop);
    defuzzification_operator Get		(void);

};

/*****************************************************************************
*			class flip_concat_op_Box			     *
******************************************************************************/

class flip_concat_op_Box: public wxListBox
{
   public:
			flip_concat_op_Box	(wxPanel *, wxFunction, char *,
						int x=-1,int y=-1,
						int width = -1, int h = -1);
    void		Set			(concat_operator = no_cop);
    concat_operator 	Get			(void);

};



/*****************************************************************************
*			class Rule_listBox				     *
******************************************************************************/
/*
class Rule_listBox :public wxListBox
{
  private:
    char*	get_rule	(RuleSet* rs, int rule_block_no, int rule_no); 
    Bool	get_rule	(char *rule, int rule_block_no, int rule_no); 
  public:	
		Rule_listBox		(RuleSet*, char *title);
		~Rule_listBox		();
   void		set			(RuleSet*, int rb_index, int r_index,
					char *title = NULL);
};
*/


//--------------------------------------------------------------------------
//			class rule_segments				   
//--------------------------------------------------------------------------
enum segm_type { SEG_NEW_RULE,SEG_IF,SEG_THEN,SEG_EMPTY};

class rule_segments
{
private:
	concat_operator 	operator_;
	TList			left_side_;
	Term			right_side_;
	float			certainty_;



public:
	rule_segments				(CombinedVariable *cv=NULL, 
						 char* val=NULL);
	~rule_segments				(void);
	CombinedVariable	*get_cv		(int no);
	char			*get_value	(int no);
	int 			left_side_lenght(void);
        float			get_certainty	(void);
	void			set_certainty	(float);
	void			set_right_side_cv(CombinedVariable *cv);
	void			set_right_side_val(char *val);

	CombinedVariable *	get_right_side_cv(void){return right_side_.get_cv();};
	char *			get_right_side_val(void){return (char*)right_side_.get_lt();};
	TList *			get_left_term	(void){return &left_side_;};
	Term *			get_right_term	(void){return &right_side_;};

	void			set		(CombinedVariable *cv, char *val);
	void			add		(CombinedVariable *cv, char *val);
	void			set_op		(concat_operator op);
	concat_operator		get_op		(void);
};
//--------------------------------------------------------------------------
//			class rule_data_list				   
//--------------------------------------------------------------------------

class rule_data_list
{
public:
	rule_segments 		rule_data_;
	rule_data_list 		*next;

	rule_data_list		(void);	
	rule_data_list		(CombinedVariable *cv,char *val);	
	~rule_data_list		(void);
	rule_segments 		*get	(void){return &rule_data_;};
};

//--------------------------------------------------------------------------
//			class rule_dyn_data				   
//--------------------------------------------------------------------------

class rule_dyn_data
{
private:
	rule_data_list		first_rule_;
	rule_data_list 		*last_rule_data_;
	int 			rule_no_;

	rule_segments 		*get_rule	(int search_no);
	rule_segments		*get_last_rule	(void);
public:

	rule_dyn_data				(void);
	~rule_dyn_data				(void);
						
	void			add		(CombinedVariable *cv, 
						 char *val);	// add data of NEW rule

	void			add2lastrule	(concat_operator op);
	void			add2lastrule	(CombinedVariable *cv, char *val);
	void			set_right_side_cv(CombinedVariable *cv);
	void			set_right_side_val(char *val);
 	void			set_certainty	(float cert);

	CombinedVariable	*get_cv		(int rule_no, int no);	// no = [0..]
	char			*get_value	(int rule_no, int no);	// no = [0..]
	concat_operator		get_op		(int rule_no);	
        float			get_certainty	(int rule_no);

	CombinedVariable *	get_right_side_cv(int rule_no)
						{return get_rule(rule_no)->get_right_side_cv();};
	char *			get_right_side_val(int rule_no)
						{return get_rule(rule_no)->get_right_side_val();};
	TList *			get_left_term	(int rule_no);
	Term *			get_right_term	(int rule_no);

        void			show_cout	(void);
	Bool 			not_empty	(void);	  // there is at least one rule stored
	int 			how_much_rules  (void);
	int			left_side_lenght(int rule_nr);
};

enum syntaxErrorTyp {	OPERATOR_MISMATCH,SHOW_RULE,NO_OPERATORorTHEN,
			NO_IF,NO_IS,WRONG_TERM,UNKNOWN_VARIABLE,
			CERTAINTY_SYNTAX_ERROR,RECURSIVE_RULE};

//--------------------------------------------------------------------------
	class rule_text_box: public wxTextWindow
//--------------------------------------------------------------------------
{
protected:
    Bool 	alternativ_style_;
    char	*get_rule_text		(void);
    void 	print_THEN		(char* line_string, 
					char* right_side_name, 
					char *right_side_value, 
					char* certainty);
   int 		act_rule_block_;
   int 		act_rule_;
   RuleSet*	act_rs_;

   char*	make_rule_text		(RuleSet* rs, int rule_block_no, int rule_no); 
   Bool 	block_text_ok		(char *rules_text,rule_dyn_data *rule_data,
					 char *status);
					// TRUE if rule in textbox ist syntactic right
   char *	get_rule_seg_civ	(char *text, char *token, rule_dyn_data *rule_data, char *status,
					 segm_type s_type);
   char *	get_rule_seg_cert	(char *text, char *token, rule_dyn_data *rule_data, char *status);
   char *	get_rule_seg_cert2	(char *text, char *token, rule_dyn_data *rule_data, char *status);
//   char *	get_rule_seg_THEN	(char *rules_text, rule_dyn_data *rule_data, 
//					 char *status);
   float	read_certainty		(char *text, Bool *status);

   CombinedVariable *is_cv_name		(char *token);
   Bool		is_cv_value		(char *token, CombinedVariable *cv);
   char *	getToken		(char *token, char *parseText);
   Bool 	is_rule_recursive	(rule_dyn_data *rule_data);


public:
		rule_text_box		(wxFrame *parent,
				 	int x=-1, int y=-1, 
					int width=-1, int height=-1);
		~rule_text_box		(void);

    RuleSet*	GetRule			(int *rule_block, int *rule_no);
    char *	Get_rule  		(char *rules_text, char *token, rule_dyn_data* rule_data, 
					 char *status);
    void	SetRule			(RuleSet*rs, int rule_block_no, int rule_no);
    void	SetRule			(RuleSet*rs, int rule_block_no);
    void	show_rules		(RuleSet*rs, char *status);  // show ALL rules
    void	show_rules		(RuleSet*rs, char *cv_name, char *status); 
								// show rules with cv_name
    Bool 	update_rule_block	(char *status, Bool all_rules = FALSE);
    Bool 	is_CERT_WITH		(char *token);
    Bool 	is_CERTAINTY		(char *token);
    Bool 	is_CERTAINTY2		(char *token);
    Bool 	is_THEN			(char *token);
    Bool 	is_IF			(char *token);
    Bool 	is_IS			(char *token);
    Bool 	is_NIL			(char *token);
    void 	error_rule_output	(syntaxErrorTyp,char *status, char *token, int rule_no,
					void *special=NULL);
    void	set_output_style	(Bool style);
    Bool	get_output_style	(void){return alternativ_style_;};
    void	set_operatorSet		(void);
    void 	clear_ruleset		(void); // delete ruleset!!
};





//**********************************************************************//
//		TermListBox,	wxListBox for class (FLIP++) TList	//
//**********************************************************************//

enum Which_Term { IN_TERM,OUT_TERM};


class TermListBox: public wxListBox
{
   public:
			TermListBox		(wxPanel *, wxFunction, char *,
						int x=-1,int y=-1,
						int width = -1);
    void		set			(CombinedVariable*);
    void		set			(NList*);
    int			Get_term_no		(void);
};











/*****************************************************************************
*			class Parameter_Win				     *
*****************************************************************************/

class Parameter_Win : public Window_def_file
{
protected:

public:
    ParameterSet*	ps_;
    wxMessage		*ps_name;
    wxText		*range_lower_end;
    wxText		*range_upper_end;
    wxText		*median;
    wxText		*distribution;
    wxChoice		*direction_choice;

		Parameter_Win		(wxFrame *parent, 
					 ParameterSet *, char *title, char* def_path="");
		~Parameter_Win		();
   void		OnMenuCommand		(int id);
   void		show			(ParameterSet *, Bool if_show=TRUE);
   void		show			(Bool if_show=TRUE);
   void		write			(char *);	// write to  file
   void		read			(char *);	// read from file
};

// -------------------
// CALLBACK procedures:
// -------------------

// edit functions:
void paraSet_Save_proc(wxButton &button, wxCommandEvent& event);

void para_rle		(wxText& text, wxCommandEvent& event);
void para_rue		(wxText& text, wxCommandEvent& event);
void para_med		(wxText& text, wxCommandEvent& event);
void para_dtr		(wxText& text, wxCommandEvent& event);








//**********************************************************************//
//		PSList_window_base, 	window for class (FLIP++) PSList//
//**********************************************************************//


// -------------------
// CALLBACK procedures:
// -------------------

void psl_callback_box_proc	(wxListBox& box, wxEvent& event);
void psl_add			(wxButton& button, wxEvent& event);
void psl_delete			(wxButton& button, wxEvent& event);
//void psl_edit			(wxButton& button, wxEvent& event);




class PSList_window_base: public Window_def_file
{
	friend void psl_add(wxButton& button, wxEvent& event); 
	friend void psl_delete(wxButton& button, wxEvent& event);
//	friend void psl_edit(wxButton& button, wxEvent& event);
protected:
    wxMessage		*def_dir_mess_;
    char 		*def_dir_;
    PSList		*ps_list_;
    ParameterSet	*ps_;
    wxListBox		*param_Box;
    wxMessage		*ps_name;

    wxMessage		*range_lower_end_mess;
    wxMessage		*range_upper_end_mess;
    wxMessage		*median_mess;
    wxMessage		*distribution_mess;
public:

			PSList_window_base	(wxFrame *parent, char *title,
						char *default_dir,
						wxMessage *def_dir_mess = NULL);
    void		set			(PSList*);
    virtual void 	show			(void);
    virtual void	set_param_box		(void);
    virtual ParameterSet *Get_parameter_set	(void);
    virtual void	set_parameter_items	(ParameterSet *ps);
    void 		OnMenuCommand		(int id);
    virtual void	write			(char *);	// write to  file
    virtual void	read			(char *);	// read from file
    virtual void      	get_extension		(char *);
    ParameterSet*	newParaSetFromUser	(void);
    void		update_title		(void);
    virtual void	add			(void);
    virtual void	del			(void);

};



//void Delete_term_proc	(wxButton& button, wxEvent& event);
void ADD_term_proc	(wxButton& button, wxEvent& event);
void ed_psl_name	(wxText& obj, wxEvent& event);
void ed_psl_range0	(wxText& obj, wxEvent& event);
void ed_psl_range1	(wxText& obj, wxEvent& event);
void ed_psl_median	(wxText& obj, wxEvent& event);
void ed_psl_distr	(wxSlider& obj, wxEvent& event);
void ed_psl_importance	(wxSlider& obj, wxEvent& event);
void ed_psl_dilatation	(wxSlider& obj, wxEvent& event);
void ed_psl_term_list	(TermListBox& obj, wxEvent& event);
void psl_edit_term_proc	(wxText& obj, wxEvent& event);
void psl_edit_term_colour (colour_choice_box& obj, wxEvent& event);


class PSList_window: public PSList_window_base
{
friend void ADD_term_proc	(wxButton& button, wxEvent& event);
friend void ed_psl_name	(wxText& obj, wxEvent& event);
friend void ed_psl_range0	(wxText& obj, wxEvent& event);
friend void ed_psl_range1	(wxText& obj, wxEvent& event);
friend void ed_psl_median	(wxText& obj, wxEvent& event);
friend void ed_psl_distr	(wxSlider& obj, wxEvent& event);
friend void ed_psl_importance	(wxSlider& obj, wxEvent& event);
friend void ed_psl_dilatation	(wxSlider& obj, wxEvent& event);
friend void ed_psl_term_list	(TermListBox& obj, wxEvent& event);
friend void psl_edit_term_proc	(wxText& obj, wxEvent& event);
friend void psl_edit_term_colour (colour_choice_box& obj, wxEvent& event);


protected:
	wxText 	*name_ps;
	wxText 	*range_lower_end;
	wxText 	*range_upper_end;
	wxText 	*median;
	wxSlider *distribution_sld;
	wxSlider *importance_sld;
	wxSlider *dilatation_sld;
	TermListBox *term_list_box;
	wxText 	*term_select;
	colour_choice_box *colour_box_;

	int last_termNr_;
    inline void		edit_term		(char *new_term, int term_no);

public:

			PSList_window		(wxFrame *parent, char *title,
						char *default_dir,
						wxMessage *def_dir_mess = NULL, Bool make_items = TRUE);

    virtual void 	show			(void);
    virtual void	set_parameter_items	(ParameterSet *ps);
    inline void		edit_term		(void);
    void		add_term			(void);
    void		edit_name			(void);
    void		edit_range0			(void);
    void		edit_range1			(void);
    void		edit_median			(void);
    void		edit_distr			(void);
    void		edit_importance			(void);
    void		edit_dilatation			(void);
    void		edit_term_list			(void);
    void		edit_term_colour		(void);
};







class fuzzy_set_canvas;
class Flip_base_window;
enum MSF_type {MSF,IMSF};

//--------------------------------------------------------------
	class membership_fct_window: public MyWin
//--------------------------------------------------------------
{
protected:
	
public:
   fuzzy_set_canvas 	*canvas;
			membership_fct_window	(CombinedVariable*,
						 Flip_base_window *callingWin,
						 char* title="membership function");
			~membership_fct_window	(void);
   void			show			(CombinedVariable *, 
						 const Bool msf_on, 
						 const Bool imsf_on,
						 const int sel_cv_no,
						 Bool if_show=TRUE);
    void		set_msf_scale		(void);
};


//--------------------------------------------------------------
	class msf_node : public point_float
//--------------------------------------------------------------
{
protected:
	PlimFuzzySet*	plim_;
	int		selected_node_nr_;
	int 		selected_function_no_;	

   	int		drag_min_x_;		// used to drag a node
   	int		drag_min_y_;		// used to drag a node
   	int		drag_max_x_;		// used to drag a node
   	int		drag_max_y_;		// used to drag a node
public:
			msf_node		(void);
	void		clear			(void);
	PlimFuzzySet*	get_plim		(void);
	int		get_node_number		(void);
	void		set			(CombinedVariable *, 
						int selected_func_no, 
						int selected_node_number,
						int drag_min_x, int drag_min_y, 
						int drag_max_x, int drag_max_y);
	Bool		is_selected		(void);
	int 		get_selected_node_no	(void);
	int 		get_drag_max_x_pix	(void);
	int 		get_drag_min_x_pix	(void);
	int 		get_drag_max_y_pix	(void);
	int 		get_drag_min_y_pix	(void);
	int 		get_selected_msf_no	(void);
	PlimFuzzySet* 	get_ps_list		(void);
};








enum CanvasMode {NO_MODE,M_SET_VALUE,M_NEW_NODE,M_DELETE_NODE};
class Flip_window;
class CanvasMenu;


class scale_form
{
private:
   float 	sc_dx;
   float 	sc_x_min, sc_y;
   float 	sc_x_max, sc_dy;
   int 		pix_x, pix_y; 
   int 		pix_dx, pix_dy;

   wxFont	*text_font;
   wxPen	*pen1;

public:
		scale_form		(void);
		~scale_form		(void);

   void		set_win_pix		(int x, int dx, int y, int dy)	
					{pix_x = x;pix_dx = dx;
					 pix_y = y;pix_dy = dy;};
   int		get_pix_x		(void){return pix_x;};
   int		get_pix_y		(void){return pix_y;};
   int		get_pix_dx		(void){return pix_dx;};
   int		get_pix_dy		(void){return pix_dy;};

   void		set_scale_support	(CombinedVariable *cv);
   void		set_scale_support	(float min, float max);
   double 	starting_value		(float x,float pot,int vz);

   void		draw_x_value		(wxMemoryDC *dc,float real_x);
   void		Draw_x_scale		(wxMemoryDC *dc,double start,double end);
   void		Draw			(wxMemoryDC *dc);

   int		value2pixel_x		(float);
   int		value2pixel_y		(float);
   void		pixel2scale		(float pix_x, float pix_y, 
					 float *scale_x, float *scale_y);
   const float 	get_sc_x_min		(void)	{return sc_x_min;};
   const float 	get_sc_x_max		(void)	{return sc_x_max;};

};





class fuzzy_set_canvas: public wxCanvas
{
private:
   wxBitmap   	*memBmp;
   wxMemoryDC	*memDC;
   Flip_base_window *callingWindow_;
   Bool		MSF_On, I_MSF_On;	
   Bool		choose_node;
   CanvasMode	canvasMode_;
   int 		selected_function_no_;
   Bool		show_instantiated_msf;	
   CombinedVariable *cv_;
   wxColour	*background_colour;
   wxBrush	*brush_clear;	
   wxBrush	*brush_trans;
   wxBrush	*fillBrush;	
   wxPen	*pen0;	// variable pen; feel free to change it
   wxPen	*pen1;
   wxPen	*pen2;
   wxPen	*pen3;
   wxFont	*text_font;
   wxFont	*text_font2, *text_font2_fat;
   wxFont	*text_font_normal;
   CanvasMenu    *popupMenu;
   int 		sv_y_up;
   int 		sv_height,sv_y_dw;

   msf_node	selected_node;	// used to drag a node
   Bool 	value_ON;	// show crisp_value of cv_ (if TRUE)
	

   Bool		instant_func_ok		(CombinedVariable *);

   void		Fill_msf		(int pkt1_x,int pkt1_y, int pkt2_x, int pkt2_y); // fill the shape 
   void		Draw_msf		(CombinedVariable *, const int fkt_no,
					const int point_number,
					Bool is_sel_fkt);
   void		Draw_inst_msf		(CombinedVariable *, const int fkt_no,
					const int point_number, 
					Bool is_sel_fkt);
					// draw a single instantiated membership function to memDC


   void		Draw_fkts		(CombinedVariable *,const int selected_term);
   void		Draw_inst_fkts		(CombinedVariable *,const int selected_term);
					// draw set of instantiated membership functions to memDC


   void		show_position		(const float x, const float y);		// not in use
   void		show_position_status 	(const float x, const float y);
   void		show_position		(char *text=NULL);			// not in use
//   void		set_scale_uppest_support(CombinedVariable *cv);
//   void		set_scale_lowest_support(CombinedVariable *cv);
   void 	set_point_sign		(const float sc_x,const float sc_y);
   void 	set_point_sign2		(const float sc_x,const float sc_y);
   void 	OnEvent			(wxMouseEvent& event);
   void		OnSize			(int x, int y);
   Bool		is_a_msf_node		(int msf_no, float x_pix, float y_pix,
					 float *x_pkt, float *y_pkt, int *node_no);
   Bool 	is_a_msfs_node		(float x_pix, float y_pix,
					 float *x_pkt, float *y_pkt,
					 int *imsf_no, int *imsf_node_no);
			//is_a_fkt_pt() is TRUE if (x_pix,y_pix) is a node 
			// of a membership function
   Bool 	is_a_imsfs_node		(int x_pix, int y_pix,
					 float *x_pkt, float *y_pkt,
					 int *imsf_no, int *imsf_node_no);
			//is_a_i_fkt_pt() is TRUE if (x_pix,y_pix) is a node 
			// of an instantiated membership function
   void		Draw_names_of_vars	(NList *names_of_vars);
   void		Draw_cv_name		(CombinedVariable *cv, 
					 Bool is_instantiated);
   void		set_inst_mess		(char *);
   void		set_range_for_set_node(int function_no, int function_node_no, 
					      int *drag_min_x, int *drag_max_x);
   void		set_msf_node		(int msf_number, int point_number, 
					float new_x, float new_y);
   void		unselect_node		(void);
   void		select_node		(const int function_no, const int function_node_no);
   void		get_wxColour		(int colour, char* colour_name);
   int		get_name_of_term_y(CombinedVariable  *cv,const int i); // for Draw_name_of_term()

public:
   scale_form	scale;

   //Bool		make_new_node;

		fuzzy_set_canvas	(CombinedVariable*, 
					 Flip_base_window *callingWin,
					 wxFrame *frame, int x, int y, int w, int h, 
					 int style = wxRETAINED);
		~fuzzy_set_canvas	();
   void		OnPaint			(void);	// repaint procedure
   void		Draw_fkts		(const int);	// print a instantiated membership funktion in cv_
   void		Draw_inst_fkts		(const int);	// print a instantiated membership funktion in cv_
   void		show			(CombinedVariable *,
					 Bool msf_on, Bool imsf_on);
   void		show			(void);
   void		Draw			(void);
   Bool		instant_func_ok		(void);
   void		SetStatusText		(char *);
   void		SetStatusText		(int);
   void		SetStatusText_value	(float);
   void		delete_selected_node	(void);
   void		Draw_info		(char *info_txt);
   void		Draw_name_of_term	(CombinedVariable *, int);
   void		setMode			(CanvasMode c_mode)
						{canvasMode_ = c_mode;};
   const Bool 	in_use			(void) {if(cv_) return TRUE; return FALSE;};
   wxMemoryDC*	get_memDC		(void){return memDC;};
// cv - value methods:
   Bool		show_cv_value		(float);
   Bool		show_cv_value_copy2dc	(float);
   void		set_value_flag		(Bool b){value_ON = b;};
   CombinedVariable* get_last_cv	(void){return cv_;};
   void		set_selected_function_no_(int a_nr) {selected_function_no_ = a_nr;};		

};

// callback procedures:

void canvas_proc(CanvasMenu&, wxCommandEvent&);



class CanvasMenu: public wxMenu
{
   private:
	fuzzy_set_canvas *parent;
   public:
	CanvasMenu			(char* str, wxFunction func, 
					 fuzzy_set_canvas * canv); 
	fuzzy_set_canvas* get_canvas	(void) 	{return parent;};
};


//******************************************************************************//
//		ChoiceParameterList, a choice box to choose a ParameterSet	//
//******************************************************************************//

class ChoiceParameterList: public wxChoice
{
   protected :
	PSList* list_;
   public:
			ChoiceParameterList	(wxPanel *, wxFunction, char *,
						 	int x=-1,int y=-1);
			ChoiceParameterList	(PSList*,
						wxPanel *, wxFunction, char *,
						 	int x=-1,int y=-1);
    ParameterSet*	Get_ps			(void);	
    void		Set_ps			(PSList*);
};



//**********************************************************************//
//		CVListBox,	wxListBox for class (FLIP++) CVList	//
//**********************************************************************//


class CVListBox: public wxListBox
{
   public:
			CVListBox		(wxPanel *, wxFunction, char *,
						int x=-1,int y=-1,
						int width = -1);
    void		set			(CVList*);
    int			Get_cv_no		(void);
    CombinedVariable*	Get_cv			(void);
};






//----------------------------------------------------------------------------
	class Flip_base_panel
//----------------------------------------------------------------------------
{
  protected:
    	wxMessage 	*constraint_mess;  	
    	wxMessage	*dilatation_mess; 	
    	wxMessage 	*imp_mess;  	
    	wxMessage 	*eval_value_mess;  			
  public:
			Flip_base_panel		(void);
    void		set_panel		(wxPanel *panel, int info_x = 50, int info_y=240, int dy=20);
    void		set_info		(CombinedVariable *);
    void		Clear_info_panel	(void);
    void		set_info_name_list	(wxListBox *box, CVList *cv_list);
};




//----------------------------------------------------------------------------
	class Flip_panel :public virtual Flip_base_panel
//----------------------------------------------------------------------------
{
  protected:
    wxListBox		*winList;	// (cv-) variable list box

    TermListBox		*termBox;
    wxMenu 		*term_menue;

    membership_fct_window *msf_win;
    wxCheckBox		*msf_CB, *i_msf_CB;

    wxMenu 		*rule_menue;
    wxMenu 		*rule_how_much_menu;
    wxMessage		*rule_win_line;
    Bool 		show_all_rules_;
    rule_text_box	*rule_box;
	
  public:
			Flip_panel		(void);
    virtual		~Flip_panel		(void);
    void		set_panel		(wxPanel *panel, wxFrame *frame,
					int x=-1, int y=-1, int width = -1, int heigth =-1,
						 wxFunction con_list_funct = NULL,
						 wxFunction msf_funct = NULL,
						 wxFunction imsf_funct = NULL,
						 wxFunction term_box_funct = NULL);
    Bool 		Is_msf_on		(void);
    Bool 		Is_i_msf_on		(void);
    Bool		if_show_all_rules	(void){return show_all_rules_;};
    void		set_rule_win_line	(char *cv_name=NULL);

    virtual void	show_msf		(CombinedVariable *sel_cv);
};







// Callback procedures:
   void 		flip_win_refresh_proc (wxListBox& list, wxCommandEvent& event);
   void 		flip_msf_show	(wxCheckBox& box, wxCommandEvent& event);
   void 		flip_plist_funct(wxCheckBox& box, wxCommandEvent& event);
   void 		flip_which_term	(wxChoice& box, wxCommandEvent& event);
   void 		flip_term	(TermListBox& box, wxCommandEvent& event);
   void 		flip_EVAL_proc	(wxButton& button, wxCommandEvent& event);
   void 		flip_gplotEVAL_proc	(wxButton& button, wxCommandEvent& event);

//----------------------------------------------------------------------------
	class Flip_base_window :public Window_def_file, public Flip_panel
//----------------------------------------------------------------------------
{
 protected:
    wxMenu 		*constraints_menue;
 public:

			Flip_base_window	(wxFrame *frame, char *title,
				 		int x, int y, int w, int h, 
						int type=wxDEFAULT_FRAME, 
						char *def_path = "");
   virtual void		OnMenuCommand		(int id);
   Bool			OnClose			(void);
   
   void			set_panel		(int x, int y, 
						 int length, 
						 int width,
						 wxFunction con_list_funct,
						 wxFunction msf_funct,
						 wxFunction imsf_funct,
						 wxFunction term_box_funct);
    virtual void	show			(void);	// updates constraint info WITH rules
    virtual void	show_sel_var		(void);	// updates constraint info WITHOUT rules
    virtual void	show_msf		(void); // update membership function
    virtual void	set_info_name_list	(void); // update info-array-box
    virtual void	update_win_name		(char *soc_name);

    int			GetSelection		(void);	//
    wxListBox		*GetConstrList		(void){return winList;};
    virtual CombinedVariable* Get_selected_cv	(void);
    virtual char *	Get_selected_var_name	(void){return NULL;};

    virtual void 	clear			(void);
    void		autom_rule_update	(void);
    virtual RuleSet*    get_rules 		(void);
    virtual void	show_rules		(void);

    Bool		read			(void);
    Bool		write			(void);
    virtual Bool	write			(char *);	// write to  file
    virtual Bool	read			(char *);	// read from file
    virtual void      	get_extension		(char *);
    virtual void	update_subwindows	(void);
//    virtual void	set_info		(void);		// update info of variable
    virtual void	update_comment		(void);
    virtual char *	get_data_name		(void);
    virtual void	update_main_win		(void){;};
};


//----------------------------------------------------------------------------
	class Flip_window :public Flip_base_window
//----------------------------------------------------------------------------
{
 protected:
    PSList_window	*PSList_Win_;
    wxCheckBox		*pl_check_;
//    wxMenu 		*constraints_menue;
    wxMenu 		*help_menue;
    wxChoice		*which_term;
    RuleSet 		*rs_base_;
#ifndef NOGNUPLOT
    FrameFlipGplot      *gplot_win;
#endif
 public:
			Flip_window	(wxFrame *frame, char *title,
				 		int x, int y, int w, int h, 
						int type=wxDEFAULT_FRAME, 
						char *def_path = "");
			~Flip_window	(void);
    Bool		OnClose			(void);
    virtual void	OnMenuCommand		(int id);

    void		evaluate		(void);
#ifndef NOGNUPLOT
    void                show_gplotWin           (RuleSet* l) {gplot_win->Show(l);}; 
#endif
    void		show			(void);	// updates all objects
    void		show_sel_var		(void); // updates all objects, but variable-list box
    void		set_info_name_list	(void); // update info-array-box
    void		update_win_name		(char *);
    RuleSet*    	get_rules 		(void){return rs_base_;};
    void		show_ps_list		(Bool);
    void		listbox_callback	(void);

    Bool		edit			(void);
    Bool		add			(void);
    Bool		read			(char *);
    Bool		write			(char *);
    void      		get_extension		(char *);

    void 		deleteSelectedInfo	(void);		//
    char		*Get_selected_var_name	(void);		//
    CombinedVariable	*Get_selected_cv	(void); 	//  get cv_const!! (and cv_var??)
    Bool		data_not_empty		(void); 	// TRUE if soc_data is empty  
    int			GetSelection		(void);		//
    int			GetVarNo		(void);		// get number of CombinedVariables in RuleSet
    wxListBox		*GetConstrList		(void){return winList;};
};




/************************************************************************
*			flip_error_t		 			*
*************************************************************************/

enum flip_error_typ {NO_Error,Stream_Error};

class flip_error_t
{
   private:
	char*	global_flip_error_string_;
   public:
		flip_error_t	(char *global_flip_error_string);
	void	show		(void);
	void	show		(flip_error_typ);
	void	clear		(void);
};

/************************************************************************
*			miscellaneous functions 			*
*************************************************************************/
char *nr2str(const float number, char *ret_string, const int strlen);
char *nr2str(const double number, char *ret_string, const int strlen);
char *nr2str(const int number, char *ret_string, const int strlen);

void Flip_DialogOkButton(wxButton& but, wxEvent& event); 
void Flip_DialogCancelButton(wxButton& but, wxEvent& event); 

double convert_string2float(char* number);		
			// converts char* number to float
Bool convert_string2float(char* number,float *value);	
			// converts char* number to float

int	fstream_OK (fstream*);


void Set_choice_value(CombinedVariable*, wxChoice*);
void Set_choice_value(char *, CombinedVariable*, wxChoice*);
char* Get_choice_value(CombinedVariable* , wxChoice*);

Bool string2fuzzy_operator(char *, fuzzy_operator *op);
Bool string2concat_operator(char *, concat_operator *op);

Bool is_fuzzy_operator(char *);
Bool is_concat_operator(char *);

Bool fuzzy_operator2string(fuzzy_operator, char* );
Bool concat_operator2string(concat_operator, char* );

inline char *strToLower(char *string_);	// use wxToLower


void 	print2errWin		(char* errortext,char *header = "error window");// show errortext in dialogwindow

const int NUMBER_STR_LEN =	20;

#define   DUMMY_CASE		121
#define   FLIP_LINE_LENGTH	200
#define   MSF_CTRL_SET 		610
#define   MSF_PARA_READ 	621
#define   MSF_PARA_WRITE 	622
#define   PARA_DIR		623
#define   RULE_OUTPUT_STYLE	632
#define	  SET_VALUE		634
#define	  SET_OPERATOR		646
#define	  HELP_HELP_CONTENTS	705

#define STANDART 		49 
#define READ      		51
#define WRITE      		53
#define QUIT                    54
#define ADD      		55
#define INF_DELETE      		57
#define EDIT      		59
#define ADD_NODE      		61
#define DELETE_NODE      	63
#define NODE_SELECTED      	64
#define SELECT_TERM_COLOUR      65
#define SET_SCALE      		66
#define RULE_BLOCK_UPDATE      	67
#define RULE_SHOW_ALL      	72
#define RULE_SHOW_VAR      	74
#define QUIT_CHILD_WIN 		150 
#define TEST 			201 





